/*
 * @(#)Account.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import olivamail.core.common.ComUtils;

public class Account {

	public String id;

	public String name;

	public String person;

	public String organization;

	public String email;

	public String replyTo;

	public String serverType;

	public String incomingServer;

	public String outgoingServer;

	public String smtpAuth = "0";

	public String inUser;

	public String inPass;

	public String outUser;

	public String outPass;

	public char status = STAT_NORMAL;

	public char dmStat = DM_SYNC;
	
	public int inPort = -1;

	public int outPort = -1;

	public int inMaxSize = -1;

	public int inLeaveDays = 0;

	public String hwmMsgUid;

	public String useRules = "0";

	public String useSig = "0";

	public String inSSL = "0";

	public String outSSL = "0";

	public String hwmMsgId = null;
	
	public String iShowUnsubscr = SHOW_UNSUBSCR_OFF;

	public static final String SHOW_UNSUBSCR_OFF = "0";

	public static final String SHOW_UNSUBSCR_ON = "1";

	public static final String SERVER_POP3 = "pop3";

	public static final String SERVER_IMAP = "imap";

	public static final char STAT_NORMAL = '0';
	
	public static final char STAT_DEFAULT_ACNT = 'D';
	
	public static final char STAT_NO_RECEIVE = '2';

	public static final char DM_NOSYNC = 'N';
	
	public static final char DM_SYNC = 'S';	
	
	public boolean isShowUnsubscr() {
		return iShowUnsubscr.equals(Account.SHOW_UNSUBSCR_ON);
	}
	
	public void setShowUnsubscr(boolean showUnsubscr) {
		iShowUnsubscr = showUnsubscr ? SHOW_UNSUBSCR_ON:Account.SHOW_UNSUBSCR_OFF;
	}
			
	public boolean isImap() {
		return ComUtils.nvl(serverType).equalsIgnoreCase(SERVER_IMAP);
	}

	public boolean isPop3() {
		return ComUtils.nvl(serverType).equalsIgnoreCase(SERVER_POP3);
	}

	public Account() {
	}

	public String toString() {
		return email + " (" + name + ")";
	}
	
	public boolean isOffline() {
		return dmStat == DM_NOSYNC;
	}

	public boolean isOnline() {
		return dmStat == DM_SYNC;
	}
	
}