/*
 * @(#)AccountWizard.java
 *
 * Copyright (C) 2007 Sergey Bredikhin
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package olivamail.gui;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.FlowLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import javax.swing.JCheckBox;

public class AccountWizard extends JFrame {
	static final long serialVersionUID = 6767896100312300001L;
	private final String WIN_ID = "account_wizard";
	private JPanel jContentPane = null;
	private JPanel aw1Panel = null;  //  @jve:decl-index=0:visual-constraint="519,93"
	private JPanel aw2Panel = null;  //  @jve:decl-index=0:visual-constraint="57,310"
	private JLabel jlPerson = null;
	private JTextField jtfPerson = null;
	private JLabel jlEmail = null;
	private JTextField jtfEmail = null;
	private JLabel jlSrvType = null;
	private JComboBox jcbSrvType = null;
	private JLabel jlInSrv = null;
	private JTextField jtfInSrv = null;
	private JLabel jlInUser = null;
	private JTextField jtfInUser = null;
	private JLabel jlInPass = null;
	private JPasswordField jpfInPass = null;
	private JLabel outSrv = null;
	private JTextField jtfOutSrv = null;
	private JPanel navPanel = null;
	private JButton jbPrev = null;
	private JButton jbNext = null;
	private JButton jbCancel = null;
	private JButton jbFinish = null;
	private AccountsFrame parent = null;
	private JPanel topPanel = null;
	private JPanel leftPanel = null;
	private JPanel rightPanel = null;
	private JLabel jlSmtpAuth = null;
	private JCheckBox jcbSmtpAuth = null;
	private JPanel aw3Panel = null;  //  @jve:decl-index=0:visual-constraint="463,312"
	private JLabel jlOutAsIn = null;
	private JCheckBox jcbOutAsIn = null;
	private JLabel jlOutUser = null;
	private JTextField jtfOutUser = null;
	private JLabel jlOutPass = null;
	private JPasswordField jpfOutPass = null;
	private int panelIdx = 1;

	/**
	 * This is the default constructor
	 */
	public AccountWizard() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(478, 321);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("AccountWizard.title"));
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getNavPanel(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getAw1Panel(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getTopPanel(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getLeftPanel(), java.awt.BorderLayout.WEST);
			jContentPane.add(getRightPanel(), java.awt.BorderLayout.EAST);
		}
		return jContentPane;
	}

	/**
	 * This method initializes aw1Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getAw1Panel() {
		if (aw1Panel == null) {
			jlEmail = new JLabel();
			jlEmail.setText(Strings.getString("AcntFormFrame.emailField"));
			jlEmail.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlEmail.setPreferredSize(new java.awt.Dimension(170,16));
			jlPerson = new JLabel();
			jlPerson.setText(Strings.getString("AcntFormFrame.acntPerson"));
			jlPerson.setPreferredSize(new java.awt.Dimension(170,16));
			jlPerson.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlPerson.setName("jlPerson");
			aw1Panel = new JPanel();
			aw1Panel.setLayout(new FlowLayout());
			aw1Panel.setSize(325, 55);
			aw1Panel.setPreferredSize(new java.awt.Dimension(200,20));
			aw1Panel.add(jlPerson, null);
			aw1Panel.add(getJtfPerson(), null);
			aw1Panel.add(jlEmail, null);
			aw1Panel.add(getJtfEmail(), null);
		}
		return aw1Panel;
	}

	/**
	 * This method initializes aw2Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getAw2Panel() {
		if (aw2Panel == null) {
			jlSmtpAuth = new JLabel();
			jlSmtpAuth.setText(Strings.getString("AccountWizard.useAuth"));
			jlSmtpAuth.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlSmtpAuth.setPreferredSize(new java.awt.Dimension(210,16));
			outSrv = new JLabel();
			outSrv.setText(Strings.getString("AcntFormFrame.outSrvField"));
			outSrv.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			outSrv.setPreferredSize(new java.awt.Dimension(170,16));
			jlInPass = new JLabel();
			jlInPass.setText(Strings.getString("AcntFormFrame.passField"));
			jlInPass.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlInPass.setPreferredSize(new java.awt.Dimension(210,16));
			jlInUser = new JLabel();
			jlInUser.setText(Strings.getString("AcntFormFrame.userField"));
			jlInUser.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlInUser.setPreferredSize(new java.awt.Dimension(210,16));
			jlInSrv = new JLabel();
			jlInSrv.setText(Strings.getString("AcntFormFrame.inSrvField"));
			jlInSrv.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlInSrv.setPreferredSize(new java.awt.Dimension(170,16));
			jlSrvType = new JLabel();
			jlSrvType.setText(Strings.getString("AcntFormFrame.srvTypeField"));
			jlSrvType.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlSrvType.setPreferredSize(new java.awt.Dimension(170,16));
			aw2Panel = new JPanel();
			aw2Panel.setSize(395, 158);
			aw2Panel.add(jlSrvType, null);
			aw2Panel.add(getJcbSrvType(), null);
			aw2Panel.add(jlInSrv, null);
			aw2Panel.add(getJtfInSrv(), null);
			aw2Panel.add(jlInUser, null);
			aw2Panel.add(getJtfInUser(), null);
			aw2Panel.add(jlInPass, null);
			aw2Panel.add(getJpfInPass(), null);
			aw2Panel.add(outSrv, null);
			aw2Panel.add(getJtfOutSrv(), null);
			aw2Panel.add(jlSmtpAuth, null);
			aw2Panel.add(getJcbSmtpAuth(), null);
		}
		return aw2Panel;
	}

	/**
	 * This method initializes jtfPerson	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfPerson() {
		if (jtfPerson == null) {
			jtfPerson = new JTextField();
			jtfPerson.setPreferredSize(new java.awt.Dimension(200,20));
			TextPopup.registerComponent(jtfPerson);
		}
		return jtfPerson;
	}

	/**
	 * This method initializes jtfEmail	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfEmail() {
		if (jtfEmail == null) {
			jtfEmail = new JTextField();
			jtfEmail.setPreferredSize(new java.awt.Dimension(200,20));
			TextPopup.registerComponent(jtfEmail);
		}
		return jtfEmail;
	}

	/**
	 * This method initializes jcbSrvType	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJcbSrvType() {
		if (jcbSrvType == null) {	
			jcbSrvType = new JComboBox(new String[]{ "pop3", "imap" });
			jcbSrvType.setPreferredSize(new java.awt.Dimension(200,20));
		}
		return jcbSrvType;
	}

	/**
	 * This method initializes jtfInSrv	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfInSrv() {
		if (jtfInSrv == null) {
			jtfInSrv = new JTextField();
			jtfInSrv.setPreferredSize(new java.awt.Dimension(200,20));
			TextPopup.registerComponent(jtfInSrv);
		}
		return jtfInSrv;
	}

	/**
	 * This method initializes jtfInPass	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfInUser() {
		if (jtfInUser == null) {
			jtfInUser = new JTextField();
			jtfInUser.setPreferredSize(new java.awt.Dimension(160,20));
			TextPopup.registerComponent(jtfInUser);
		}
		return jtfInUser;
	}

	/**
	 * This method initializes jpfInPass	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */    
	private JPasswordField getJpfInPass() {
		if (jpfInPass == null) {
			jpfInPass = new JPasswordField();
			jpfInPass.setPreferredSize(new java.awt.Dimension(160,20));
		}
		return jpfInPass;
	}

	/**
	 * This method initializes jtfOutSrv	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfOutSrv() {
		if (jtfOutSrv == null) {
			jtfOutSrv = new JTextField();
			jtfOutSrv.setPreferredSize(new java.awt.Dimension(200,20));
			TextPopup.registerComponent(jtfOutSrv);
		}
		return jtfOutSrv;
	}

	/**
	 * This method initializes jpNav	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getNavPanel() {
		if (navPanel == null) {
			navPanel = new JPanel();
			navPanel.setPreferredSize(new java.awt.Dimension(10,40));
			navPanel.add(getJbPrev(), null);
			navPanel.add(getJbNext(), null);
			navPanel.add(getJbFinish(), null);
			navPanel.add(getJbCancel(), null);
		}
		return navPanel;
	}

	/**
	 * This method initializes jbPrev	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbPrev() {
		if (jbPrev == null) {
			jbPrev = new JButton();
			jbPrev.setText(Strings.getString("previousButton"));
			jbPrev.setEnabled(false);
			jbPrev.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					switch (panelIdx) {
					case 2:
						jContentPane.remove(getAw2Panel());
						jContentPane.add(getAw1Panel(),
								java.awt.BorderLayout.CENTER);
						jbNext.setEnabled(true);
						jbPrev.setEnabled(false);
						jContentPane.updateUI();
						panelIdx = 1;
						break;
					case 3:
						jContentPane.remove(getAw3Panel());
						jContentPane.add(getAw2Panel(),
								java.awt.BorderLayout.CENTER);
						jbNext.setEnabled(jcbSmtpAuth.isSelected());
						jbPrev.setEnabled(true);
						jContentPane.updateUI();
						panelIdx = 2;
						break;						
					}
				}
			});
		}
		return jbPrev;
	}

	/**
	 * This method initializes jbNext	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbNext() {
		if (jbNext == null) {
			jbNext = new JButton();
			jbNext.setText(Strings.getString("nextButton"));
			jbNext.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					switch (panelIdx) {
					case 1:
						jContentPane.remove(getAw1Panel());
						jContentPane.add(getAw2Panel(),
								java.awt.BorderLayout.CENTER);
						jbNext.setEnabled(jcbSmtpAuth.isSelected());
						jbPrev.setEnabled(true);
						if(!jbFinish.isEnabled())
							jbFinish.setEnabled(!jcbSmtpAuth.isSelected());
						jContentPane.updateUI();
						panelIdx = 2;
						break;
					case 2:
						jContentPane.remove(getAw2Panel());
						jContentPane.add(getAw3Panel(),
								java.awt.BorderLayout.CENTER);
						jbNext.setEnabled(false);
						jbPrev.setEnabled(true);
						if(!jbFinish.isEnabled())
							jbFinish.setEnabled(true);
						jContentPane.updateUI();
						panelIdx = 3;
						break;
					}
				}
			});
		}
		return jbNext;
	}

	/**
	 * This method initializes jbCancel	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbCancel() {
		if (jbCancel == null) {
			jbCancel = new JButton();
			jbCancel.setText(Strings.getString("cancelButton"));
			jbCancel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					dispose();
					this_windowClosing(null);
				}
			});
		}
		return jbCancel;
	}

	/**
	 * This method initializes jbFinish	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbFinish() {
		if (jbFinish == null) {
			jbFinish = new JButton();
			jbFinish.setText(Strings.getString("saveButton"));
			jbFinish.setEnabled(false);
			jbFinish.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Account acnt = new Account();
					acnt.person = jtfPerson.getText();
					acnt.email = jtfEmail.getText().trim();
/*					
					if (!jtfPerson.getText().trim().equals(""))
						acnt.email = jtfPerson.getText().trim() + " <"
								+ acnt.email + ">";
*/								
					acnt.serverType = (String)jcbSrvType.getSelectedItem();
					acnt.incomingServer = jtfInSrv.getText().trim();
					acnt.inUser = jtfInUser.getText().trim();
					acnt.inPass = String.valueOf(jpfInPass.getPassword());
					acnt.outgoingServer = jtfOutSrv.getText().trim();
					if(!acnt.incomingServer.equals(""))
						acnt.name = acnt.incomingServer;
					else if(!acnt.email.equals(""))
						acnt.name = acnt.email;
					else
						acnt.name = "<noname>";
					if(jcbSmtpAuth.isSelected()) {
						acnt.smtpAuth = "1";
						if(!jcbOutAsIn.isSelected()) {
							acnt.outUser = jtfOutUser.getText().trim();
							acnt.outPass = String.valueOf(jpfOutPass.getPassword());							
						}
					} else
						acnt.smtpAuth = "0";
					try {
						Context.storage.saveAccount(acnt, true);
						parent.listAccounts();
						dispose();
					} catch (Exception exc) {
						exc.printStackTrace();
						AlertDialog.showErrorDialog(exc);
					}
				}
			});
		}
		return jbFinish;
	}

	public void setParent(AccountsFrame parent) {
		this.parent = parent;
	}

	/**
	 * This method initializes topPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getTopPanel() {
		if (topPanel == null) {
			topPanel = new JPanel();
			topPanel.setPreferredSize(new java.awt.Dimension(10,70));
		}
		return topPanel;
	}

	/**
	 * This method initializes leftPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getLeftPanel() {
		if (leftPanel == null) {
			leftPanel = new JPanel();
			leftPanel.setPreferredSize(new java.awt.Dimension(40,10));
		}
		return leftPanel;
	}

	/**
	 * This method initializes rightPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getRightPanel() {
		if (rightPanel == null) {
			rightPanel = new JPanel();
			rightPanel.setPreferredSize(new java.awt.Dimension(40,10));
		}
		return rightPanel;
	}

	/**
	 * This method initializes jcbSmtpAuth	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbSmtpAuth() {
		if (jcbSmtpAuth == null) {
			jcbSmtpAuth = new JCheckBox();
			jcbSmtpAuth.setPreferredSize(new java.awt.Dimension(160,20));
			jcbSmtpAuth.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jbNext.setEnabled(jcbSmtpAuth.isSelected());
					jbFinish.setEnabled(!jcbSmtpAuth.isSelected());
				}
			});
		}
		return jcbSmtpAuth;
	}

	/**
	 * This method initializes aw3Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getAw3Panel() {
		if (aw3Panel == null) {
			jlOutAsIn = new JLabel();
			jlOutAsIn.setText(Strings.getString("AcntFormFrame.acntPassOutAsIn"));
			jlOutAsIn.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlOutAsIn.setPreferredSize(new java.awt.Dimension(170,16));
			jlOutUser = new JLabel();
			jlOutUser.setText(Strings.getString("AcntFormFrame.userField"));
			jlOutUser.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlOutUser.setPreferredSize(new java.awt.Dimension(210,16));
			jlOutPass = new JLabel();
			jlOutPass.setText(Strings.getString("AcntFormFrame.passField"));
			jlOutPass.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlOutPass.setPreferredSize(new java.awt.Dimension(210,16));
			aw3Panel = new JPanel();
			aw3Panel.setPreferredSize(new java.awt.Dimension(100,50));
			aw3Panel.setSize(395, 88);
			aw3Panel.add(jlOutAsIn, null);
			aw3Panel.add(getJcbOutAsIn(), null);
			aw3Panel.add(jlOutUser, null);
			aw3Panel.add(getJtfOutUser(), null);
			aw3Panel.add(jlOutPass, null);
			aw3Panel.add(getJpfOutPass(), null);
		}
		return aw3Panel;
	}

	/**
	 * This method initializes jcbOutAsIn	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbOutAsIn() {
		if (jcbOutAsIn == null) {
			jcbOutAsIn = new JCheckBox();
			jcbOutAsIn.setPreferredSize(new java.awt.Dimension(200,20));
			jcbOutAsIn.setSelected(true);
			jcbOutAsIn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jcbOutAsIn.isSelected()) {
						jtfOutUser.setEnabled(false);
//						jtfOutUser.setText("");
						jpfOutPass.setEnabled(false);
//						jpfOutPass.setText("");
					} else {
						jtfOutUser.setEnabled(true);
						jpfOutPass.setEnabled(true);
					}
				}
			});
		}
		return jcbOutAsIn;
	}

	/**
	 * This method initializes jtfOutUser	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfOutUser() {
		if (jtfOutUser == null) {
			jtfOutUser = new JTextField();
			jtfOutUser.setPreferredSize(new java.awt.Dimension(160,20));
			jtfOutUser.setEnabled(false);
			TextPopup.registerComponent(jtfOutUser);
		}
		return jtfOutUser;
	}

	/**
	 * This method initializes jpfOutPass	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */    
	private JPasswordField getJpfOutPass() {
		if (jpfOutPass == null) {
			jpfOutPass = new JPasswordField();
			jpfOutPass.setPreferredSize(new java.awt.Dimension(160,20));
			jpfOutPass.setEnabled(false);
		}
		return jpfOutPass;
	}
		
}  //  @jve:decl-index=0:visual-constraint="6,-21"
