/*
 * @(#)AccountsFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.event.ActionEvent;
import java.util.Vector;
import java.awt.Color;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableCellRenderer;
import java.awt.Component;
import java.awt.Font;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

public class AccountsFrame extends JFrame {

	static final long serialVersionUID = 947464903942319675L;

	private final String WIN_ID = "accounts";	
	
	private JPanel jContentPane = null;

	private JPanel jPanel4 = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel3 = null;

	private JScrollPane jScrollPane1 = null;

	private JTable jTable1 = null;

	private JMenuBar jJMenuBar1 = null;

	private JMenu jMenuFile = null;

	private JMenuItem jMenuItemClose = null;

	private JMenu jMenuAccounts = null;

	private JMenuItem jMenuItemAcntCreate = null;

	private JMenuItem jMenuItemAcntEdit = null;

	private JMenuItem jMenuItemAcntDelete = null;

	private JMenuItem jMenuItemAcntDefault = null;

	/**
	 * This is the default constructor
	 */
	public AccountsFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(380, 239);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setJMenuBar(getJJMenuBar1());
		this
				.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("AccountsFrame.title"));
	}
	
	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel4(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
		}
		return jPanel4;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
		}
		return jPanel3;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jTable1
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {

				static final long serialVersionUID = -7755773025996875503L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}								
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {// What else
																// should i put
																// in here to
																// check the
																// value
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}
					if (((String) this.getValueAt(rowIndex, AccountTableColumns.COL_STATUS)).equals("D"))
						c.setFont(c.getFont().deriveFont(Font.BOLD));
					else
						c.setFont(c.getFont().deriveFont(Font.PLAIN));
					return c;
				}
			};
			//jTable1.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
			jTable1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(e.getClickCount() == 2)
						editCurrentRow();
				}
			});		
			
			jTable1.setGridColor(jTable1.getBackground());
		}
		return jTable1;
	}

	public void listAccounts() {
		Vector headers = new Vector(2);
		headers.add(Strings.getString("AccountsFrame.idField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.acntName")); //$NON-NLS-1$
/*		
		headers.add(Strings.getString("AccountsFrame.emailField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.srvTypeField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.inSrvField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.outSrvField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.smtpAuthField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.inUserField")); //$NON-NLS-1$
		headers.add(Strings.getString("AccountsFrame.outUserField")); //$NON-NLS-1$
*/
		headers.add(Strings.getString("AccountsFrame.statusField")); //$NON-NLS-1$
		Vector rows = null;
		try {
			rows = Context.storage.getAccountList(null, null);
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(AccountTableColumns.COL_ID).setMaxWidth(50);
			tcm.getColumn(AccountTableColumns.COL_STATUS).setMaxWidth(20);
			tcm.getColumn(AccountTableColumns.COL_STATUS).setCellRenderer(
					new AccountIconRenderer());			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	void jButton3_actionPerformed(ActionEvent e) {
	}

	void jButton2_actionPerformed(ActionEvent e) {
	}

	void jButton4_actionPerformed(ActionEvent e) {
	}

	void jButton5_actionPerformed(ActionEvent e) {
	}

	/**
	 * This method initializes jJMenuBar1	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private JMenuBar getJJMenuBar1() {
		if (jJMenuBar1 == null) {
			jJMenuBar1 = new JMenuBar();
			jJMenuBar1.add(getJMenuFile());
			jJMenuBar1.add(getJMenuAccounts());
		}
		return jJMenuBar1;
	}

	/**
	 * This method initializes jMenuFile	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText(Strings.getString("menuFile")); //$NON-NLS-1$
			jMenuFile.add(getJMenuItemClose());
		}
		return jMenuFile;
	}

	/**
	 * This method initializes jMenuItemClose	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemClose() {
		if (jMenuItemClose == null) {
			jMenuItemClose = new JMenuItem();
			jMenuItemClose.setText(Strings.getString("menuClose")); //$NON-NLS-1$
			jMenuItemClose.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return jMenuItemClose;
	}

	/**
	 * This method initializes jMenuAccounts	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuAccounts() {
		if (jMenuAccounts == null) {
			jMenuAccounts = new JMenu();
			jMenuAccounts.setText(Strings.getString("AccountsFrame.menuAccounts")); //$NON-NLS-1$
			jMenuAccounts.add(getJMenuItemAcntCreate());
			jMenuAccounts.add(getJMenuItemAcntEdit());
			jMenuAccounts.add(getJMenuItemAcntDelete());
			jMenuAccounts.add(getJMenuItemAcntDefault());
		}
		return jMenuAccounts;
	}

	/**
	 * This method initializes jMenuItemAcntCreate	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemAcntCreate() {
		if (jMenuItemAcntCreate == null) {
			jMenuItemAcntCreate = new JMenuItem();
			jMenuItemAcntCreate.setText(Strings.getString("AccountsFrame.menuAcntCreate")); //$NON-NLS-1$
			jMenuItemAcntCreate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemAcntCreate_actionPerformed(e);
				}
			});
		}
		return jMenuItemAcntCreate;
	}

	void jMenuItemAcntCreate_actionPerformed(java.awt.event.ActionEvent e) {
		AccountWizard aw = new AccountWizard();
		aw.setParent(this);
		aw.setVisible(true);
/*		
		AcntFormFrame aff = new AcntFormFrame();
		aff.setParent(this);
		aff.show();	
		//aff.editAccount(new Account());
		aff.updateUIState();
*/		
	}
	
	/**
	 * This method initializes jMenuItemAcntEdit	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemAcntEdit() {
		if (jMenuItemAcntEdit == null) {
			jMenuItemAcntEdit = new JMenuItem();
			jMenuItemAcntEdit.setText(Strings.getString("AccountsFrame.menuAcntEdit")); //$NON-NLS-1$
			jMenuItemAcntEdit.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemAcntEdit_actionPerformed(e);
				}
			});
		}
		return jMenuItemAcntEdit;
	}
	
	void jMenuItemAcntEdit_actionPerformed(java.awt.event.ActionEvent e) {
		editCurrentRow();
	}

	void editCurrentRow() {
		int row = jTable1.getSelectedRow();
		if (row != -1) {
			AcntFormFrame aff = new AcntFormFrame();
			aff.setParent(this);
			aff.editAccount((String) jTable1.getValueAt(row, 0));
			aff.setVisible(true);
			aff.updateUIState();
		}				
	}
	
	/**
	 * This method initializes jMenuItemAcntDelete	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemAcntDelete() {
		if (jMenuItemAcntDelete == null) {
			jMenuItemAcntDelete = new JMenuItem();
			jMenuItemAcntDelete.setText(Strings.getString("menuDelete")); //$NON-NLS-1$
			jMenuItemAcntDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemAcntDelete_actionPerformed(e);
				}
			});
		}
		return jMenuItemAcntDelete;
	}

	void jMenuItemAcntDelete_actionPerformed(java.awt.event.ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row != -1) {
			if(AlertDialog.showConfirmDialog(Strings.getString("AccountsFrame.acntDelConfirm"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION) //$NON-NLS-1$
				return;			
			try {
				Context.storage.deleteAccount((String) jTable1.getValueAt(row,
						0));
//				Context.useDefaultAccount();
				listAccounts();
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
		}		
	}
	
	/**
	 * This method initializes jMenuItemAcntDefault	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemAcntDefault() {
		if (jMenuItemAcntDefault == null) {
			jMenuItemAcntDefault = new JMenuItem();
			jMenuItemAcntDefault.setText(Strings.getString("menuDefault")); //$NON-NLS-1$
			jMenuItemAcntDefault.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemAcntDefault_actionPerformed(e);
				}
			});
		}
		return jMenuItemAcntDefault;
	}

	void jMenuItemAcntDefault_actionPerformed(java.awt.event.ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row != -1) {
			try {
				Context.storage.setDefaultAccount((String) jTable1.getValueAt(
						row, 0));
				listAccounts();
//				Context.useDefaultAccount();
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
		}		
	}
	
} // @jve:decl-index=0:visual-constraint="10,10"

class AccountTableColumns {
	static final int COL_ID = 0;
	static final int COL_NAME = 1;	
	static final int COL_STATUS = 2;
}

class AccountIconRenderer extends JLabel implements TableCellRenderer {

	static final long serialVersionUID = 6244793159432844223L;

	public AccountIconRenderer() {
		super();
	}

	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		try {
			String val = (String) value;
			switch (column) {
			case AccountTableColumns.COL_STATUS:
				if (val.equals("D")) //$NON-NLS-1$
					this.setIcon(new ImageIcon(olivamail.gui.MainFrame.class
							.getResource("check1.png"))); //$NON-NLS-1$
				else if (val.equals("2")) //$NON-NLS-1$
					this.setIcon(new ImageIcon(olivamail.gui.MainFrame.class
							.getResource("rec_off.png"))); //$NON-NLS-1$
				else
					this.setIcon(null);
				break;
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		return this;
	}

}
