/*
 * @(#)AcntFormFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import javax.swing.JTabbedPane;
import java.awt.BorderLayout;
import javax.swing.JCheckBox;

public class AcntFormFrame extends JFrame {

	static final long serialVersionUID = 6767896100312341640L;

	private final String WIN_ID = "account_form";	
	
	private JPanel jContentPane = null;

	private JLabel jLabel2 = null;

	private JTextField emailField = null;

	private JLabel jLabel3 = null;

	private JComboBox serverTypeField = null;

	private JLabel jLabel4 = null;

	private JTextField inServerField = null;

	private JLabel jLabel5 = null;

	private JTextField outServerField = null;

	private JLabel jLabel6 = null;

	private JLabel jLabel7 = null;

	private JTextField inUserField = null;

	private JLabel jLabel8 = null;

	private JPasswordField inPassField = null;

	private JLabel jLabel9 = null;

	private JTextField outUserField = null;

	private JLabel jLabel10 = null;

	private JPasswordField outPassField = null;

	private JButton okButton = null;

	private JButton cancelButton = null;

	private AccountsFrame parent = null;

	private JLabel nameLabel = null;

	private JTextField nameField = null;

	private JComboBox smtpAuthComboBox = null;

	private JTabbedPane jTabbedPane1 = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel3 = null;

	private JPanel jPanel4 = null;

	private JLabel jLabelStoreInPass = null;

	private JCheckBox jCheckBoxStoreInPass = null;

	private JLabel jLabelOutAsIn = null;

	private JLabel jLabelStoreOutPass = null;

	private JCheckBox jCheckBoxOutAsIn = null;

	private JCheckBox jCheckBoxStoreOutPass = null;

	private JLabel jLabelInPort = null;

	private JTextField inPortField = null;

	private JLabel jLabelInMaxSize = null;

	private JTextField inMaxSizeField = null;

	private JLabel jLabelInLeaveDays = null;

	private JTextField inLeaveDaysField = null;

	private JLabel jLabelOutPort = null;

	private JTextField outPortField = null;

	private JLabel jLabelLeaveOnServer = null;

	private JCheckBox jCheckBoxLeaveOnServer = null;

	private JLabel jLabelDeleteAfter = null;

	private JCheckBox jCheckBoxDeleteAfter = null;

	private JLabel jlUseRules = null;

	private JCheckBox jcbUseRules = null;

	private JLabel jlUseSig = null;

	private JComboBox jcbUseSig = null;

	private JLabel jlInSSL = null;

	private JCheckBox jcbInSSL = null;

	private JLabel jlOutSSL = null;

	private JCheckBox jcbOutSSL = null;
	
	private Account myAccount = new Account();

	private JLabel jlPerson = null;

	private JTextField jtfPerson = null;

	private JLabel jlReplyTo = null;

	private JTextField jtfReplyTo = null;

	private JLabel jlOrganization = null;

	private JTextField jtfOrganization = null;

	private JLabel jlUseForReceiving = null;

	private JCheckBox jcbUseForReceiving = null; 

	/**
	 * This is the default constructor
	 */
	public AcntFormFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(412, 392);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setResizable(false);
		this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("AcntFormFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJTabbedPane1(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel4(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes emailField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getEmailField() {
		if (emailField == null) {
			emailField = new JTextField();
			emailField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(emailField);
		}
		return emailField;
	}

	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getServerTypeField() {
		if (serverTypeField == null) {
			String srvTypes[] = new String[]{ "pop3", "imap" }; //$NON-NLS-1$ //$NON-NLS-2$
			serverTypeField = new JComboBox(srvTypes);
			serverTypeField.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return serverTypeField;
	}

	/**
	 * This method initializes inServerField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getInServerField() {
		if (inServerField == null) {
			inServerField = new JTextField();
			inServerField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(inServerField);
		}
		return inServerField;
	}

	/**
	 * This method initializes outServerField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOutServerField() {
		if (outServerField == null) {
			outServerField = new JTextField();
			outServerField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(outServerField);
		}
		return outServerField;
	}

	/**
	 * This method initializes inUserField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getInUserField() {
		if (inUserField == null) {
			inUserField = new JTextField();
			inUserField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(inUserField);
		}
		return inUserField;
	}

	/**
	 * This method initializes inPassField	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getInPassField() {
		if (inPassField == null) {
			inPassField = new JPasswordField();
			inPassField.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return inPassField;
	}

	/**
	 * This method initializes outUserField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOutUserField() {
		if (outUserField == null) {
			outUserField = new JTextField();
			outUserField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(outUserField);
		}
		return outUserField;
	}

	/**
	 * This method initializes outPassField	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getOutPassField() {
		if (outPassField == null) {
			outPassField = new JPasswordField();
			outPassField.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return outPassField;
	}

	/**
	 * This method initializes okButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setText(Strings.getString("okButton")); //$NON-NLS-1$
			okButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					okButton_actionPerformed(e);
				}
			});
		}
		return okButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Strings.getString("cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return cancelButton;
	}

	public void setParent(AccountsFrame parent) {
		this.parent = parent;
	}

	void okButton_actionPerformed(ActionEvent e) {
//		acnt.id = idField.getText();
//		myAccount.id = myAccount.id;
		myAccount.name = Context.checkField(nameField);
		if(myAccount.name == null) {
			jTabbedPane1.setSelectedIndex(0);
			return;
		}
		myAccount.person = Context.trimField(jtfPerson);
		myAccount.organization = Context.trimField(jtfOrganization);
		myAccount.email = Context.checkField(emailField);
		if(myAccount.email == null) {
			jTabbedPane1.setSelectedIndex(0);			
			return;
		}		
		if (myAccount.email.indexOf("@") == -1) {
			AlertDialog.showWarningDialog(Strings.getString("incorrectEmail")); //$NON-NLS-1$
			jTabbedPane1.setSelectedIndex(0);			
			emailField.requestFocus();
			return;
		}		
		myAccount.replyTo = Context.trimField(jtfReplyTo);
		if (myAccount.replyTo.length() > 0 && myAccount.replyTo.indexOf("@") == -1) {
			AlertDialog.showWarningDialog(Strings.getString("incorrectEmail")); //$NON-NLS-1$
			jTabbedPane1.setSelectedIndex(0);			
			jtfReplyTo.requestFocus();
			return;
		}				
		myAccount.serverType = ((String)serverTypeField.getSelectedItem());
		if (myAccount.serverType == null) {
			AlertDialog.showWarningDialog(Strings.getString("enterRequired")); //$NON-NLS-1$
			jTabbedPane1.setSelectedIndex(1);
			serverTypeField.requestFocus();
			return;
		}
		myAccount.incomingServer = Context.trimField(inServerField);
		myAccount.inSSL = (jcbInSSL.isSelected()?"1":"0");
		myAccount.outgoingServer = Context.trimField(outServerField);
		myAccount.outSSL = (jcbOutSSL.isSelected()?"1":"0");
		if(((String)smtpAuthComboBox.getSelectedItem()).equals("none")) //$NON-NLS-1$
			myAccount.smtpAuth = "0"; //$NON-NLS-1$
		else
			myAccount.smtpAuth = "1"; //$NON-NLS-1$
		myAccount.inUser = Context.trimField(inUserField);
		if(inUserField.getText().equals("")) { //$NON-NLS-1$
			inPassField.setText(""); //$NON-NLS-1$
			jCheckBoxStoreInPass.setSelected(false);
			inPassField.setEnabled(false);
		}
		myAccount.inPass = String.valueOf(inPassField.getPassword());
		myAccount.outUser = Context.trimField(outUserField);
		if(outUserField.getText().equals("")) { //$NON-NLS-1$
			outPassField.setText(""); //$NON-NLS-1$
			jCheckBoxStoreOutPass.setSelected(false);
			outPassField.setEnabled(false);			
		}
		myAccount.outPass = String.valueOf(outPassField.getPassword());
		//acnt.status = Context.trimField(statusField);
		if(!jcbUseForReceiving.isSelected())
			myAccount.status = Account.STAT_NO_RECEIVE;
		else if(myAccount.status == Account.STAT_NO_RECEIVE)
			myAccount.status = Account.STAT_NORMAL;
			
		myAccount.useSig = String.valueOf(jcbUseSig.getSelectedIndex());
		if (myAccount.useSig == null) {
			AlertDialog.showWarningDialog(Strings.getString("enterRequired")); //$NON-NLS-1$
			jTabbedPane1.setSelectedIndex(0);
			jcbUseSig.requestFocus();
			return;
		}
		if(jcbUseRules.isSelected())
			myAccount.useRules = "1";
		else
			myAccount.useRules = "0";		
/*
		if(Context.getLastAccount() == null)
			acnt.status = "D"; //$NON-NLS-1$
		if(acnt.status == null || acnt.status.equals("")) //$NON-NLS-1$
			acnt.status = "0"; //$NON-NLS-1$
*/			
		myAccount.inPort = Integer.parseInt(inPortField.getText());
		myAccount.outPort = Integer.parseInt(outPortField.getText());
		myAccount.inMaxSize = Integer.parseInt(inMaxSizeField.getText());
		myAccount.inLeaveDays = Integer.parseInt(inLeaveDaysField.getText());		
		try {
			Context.storage.saveAccount(myAccount, true);
			Context.storePwdInCache(myAccount);
//			Context.useDefaultAccount();
			parent.listAccounts();
			this_windowClosing(null);
			dispose();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	public void editAccount(Account acnt) {
		myAccount = acnt;
//		idField.setText(acnt.id);
		nameField.setText(acnt.name);
		jtfPerson.setText(acnt.person);
		jtfOrganization.setText(acnt.organization);
		emailField.setText(acnt.email);
		jtfReplyTo.setText(acnt.replyTo);
		jcbUseForReceiving.setSelected(acnt.status != Account.STAT_NO_RECEIVE);
		serverTypeField.setSelectedItem(acnt.serverType);
		inServerField.setText(acnt.incomingServer);
		jcbInSSL.setSelected(acnt.inSSL.equals("1"));
		outServerField.setText(acnt.outgoingServer);
		jcbOutSSL.setSelected(acnt.outSSL.equals("1"));
		if(acnt.smtpAuth == null || acnt.smtpAuth.equals("0")) //$NON-NLS-1$
			smtpAuthComboBox.setSelectedItem(Strings.getString("AcntFormFrame.authNone")); //$NON-NLS-1$
		if(acnt.smtpAuth != null && acnt.smtpAuth.equals("1")) //$NON-NLS-1$
			smtpAuthComboBox.setSelectedItem(Strings.getString("AcntFormFrame.authPassword"));			 //$NON-NLS-1$
		inUserField.setText(acnt.inUser);
		inPassField.setText(acnt.inPass);
		outUserField.setText(acnt.outUser);
		outPassField.setText(acnt.outPass);
//		statusField.setText(acnt.status);
		inPortField.setText(String.valueOf(acnt.inPort));
		outPortField.setText(String.valueOf(acnt.outPort));
		inMaxSizeField.setText(String.valueOf(acnt.inMaxSize));
		inLeaveDaysField.setText(String.valueOf(acnt.inLeaveDays));
		jcbUseSig.setSelectedIndex(Integer.parseInt(acnt.useSig));		
		if(acnt.useRules == null || acnt.useRules.equals("0")) //$NON-NLS-1$
			jcbUseRules.setSelected(false);
		if(acnt.useRules != null && acnt.useRules.equals("1")) //$NON-NLS-1$
			jcbUseRules.setSelected(true);		
	}
	
	public void editAccount(String id) {
		try {
			editAccount(Context.storage.getAccount(id));
/*			
			jtfHwmUid.setText(ComUtils.nvl(Context.storage.getAcntHwmUid(id)));
			jtfHwmId.setText(ComUtils.nvl(Context.storage.getAcntHwmId(id)));
*/			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	public void updateUIState() {
		if(inPassField.getPassword().length == 0) {
			jCheckBoxStoreInPass.setSelected(false);
			inPassField.setEnabled(false);
		} else {
			jCheckBoxStoreInPass.setSelected(true);
			inPassField.setEnabled(true);
		}
		if(outUserField.getText().length() == 0) {
			jCheckBoxOutAsIn.setSelected(true);
			outUserField.setEnabled(false);
			jCheckBoxStoreOutPass.setEnabled(false);
		} else {
			jCheckBoxOutAsIn.setSelected(false);
			outUserField.setEnabled(true);
			jCheckBoxStoreOutPass.setEnabled(true);
		}		
		if(outPassField.getPassword().length == 0) {
			jCheckBoxStoreOutPass.setSelected(false);
			outPassField.setEnabled(false);
		} else {
			jCheckBoxStoreOutPass.setSelected(true);
			outPassField.setEnabled(true);
		}
		updateUILeaveDays();
	}
	
	private void updateUILeaveDays() {
		int inLeaveDays = 0;
		try {
			inLeaveDays = Integer.parseInt(inLeaveDaysField.getText());
		} catch (NumberFormatException nfe) {
			return;
		}
		if(inLeaveDays == 0) {
			jCheckBoxLeaveOnServer.setSelected(false);
			jCheckBoxDeleteAfter.setEnabled(false);
			jCheckBoxDeleteAfter.setSelected(true);
			inLeaveDaysField.setEnabled(false);
		} else {
			jCheckBoxLeaveOnServer.setSelected(true);
			jCheckBoxDeleteAfter.setEnabled(true);
			jCheckBoxDeleteAfter.setSelected(inLeaveDays != -1);
			inLeaveDaysField.setEnabled(jCheckBoxDeleteAfter.isSelected());				
		}		
	}
	
	/**
	 * This method initializes nameField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getNameField() {
		if (nameField == null) {
			nameField = new JTextField();
			nameField.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(nameField);
		}
		return nameField;
	}

	/**
	 * This method initializes smtpAuthComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getSmtpAuthComboBox() {
		if (smtpAuthComboBox == null) {
			smtpAuthComboBox = new JComboBox(new Object[]{Strings.getString("AcntFormFrame.authNone"), Strings.getString("AcntFormFrame.authPassword")}); //$NON-NLS-1$ //$NON-NLS-2$
			smtpAuthComboBox.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return smtpAuthComboBox;
	}

	/**
	 * This method initializes jTabbedPane1	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */    
	private JTabbedPane getJTabbedPane1() {
		if (jTabbedPane1 == null) {
			jTabbedPane1 = new JTabbedPane();
			jTabbedPane1.addTab(Strings.getString("AcntFormFrame.pageCommon"), null, getJPanel1(), null); //$NON-NLS-1$
			jTabbedPane1.addTab(Strings.getString("AcntFormFrame.pageIncoming"), null, getJPanel2(), null); //$NON-NLS-1$
			jTabbedPane1.addTab(Strings.getString("AcntFormFrame.pageOutgoing"), null, getJPanel3(), null); //$NON-NLS-1$
		}
		return jTabbedPane1;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jlUseForReceiving = new JLabel();
			jlUseForReceiving.setText(Strings.getString("AcntFormFrame.useForReceiving"));
			jlUseForReceiving.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlUseForReceiving.setPreferredSize(new java.awt.Dimension(210,15));
			jlOrganization = new JLabel();
			jlOrganization.setText(Strings.getString("AcntFormFrame.organization"));
			jlOrganization.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlOrganization.setPreferredSize(new java.awt.Dimension(210,15));
			jlReplyTo = new JLabel();
			jlReplyTo.setText(Strings.getString("AcntFormFrame.replyTo"));
			jlReplyTo.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlReplyTo.setPreferredSize(new java.awt.Dimension(210,15));
			jlPerson = new JLabel();
			jlPerson.setText(Strings.getString("AcntFormFrame.acntPerson"));
			jlPerson.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlPerson.setPreferredSize(new java.awt.Dimension(210,15));
			jlUseSig = new JLabel();
			jlUseSig.setText(Strings.getString("Signatures.useSignatures")); //$NON-NLS-1$
			jlUseSig.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlUseSig.setPreferredSize(new java.awt.Dimension(210,15));
			nameLabel = new JLabel();
			nameLabel.setText(Strings.getString("AcntFormFrame.acntName")); //$NON-NLS-1$
			nameLabel.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			nameLabel.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel2 = new JLabel();
			jLabel2.setText(Strings.getString("AcntFormFrame.emailField")); //$NON-NLS-1$
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel2.setPreferredSize(new java.awt.Dimension(210,15));			
			jlUseRules = new JLabel();
			jlUseRules.setText(Strings.getString("AcntFormFrame.useRules")); //$NON-NLS-1$
			jlUseRules.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlUseRules.setPreferredSize(new java.awt.Dimension(210,15));			
			jPanel1 = new JPanel();
			jPanel1.add(nameLabel, null);
			jPanel1.add(getNameField(), null);
			jPanel1.add(jlPerson, null);
			jPanel1.add(getJtfPerson(), null);
			jPanel1.add(jlOrganization, null);
			jPanel1.add(getJtfOrganization(), null);
			jPanel1.add(jLabel2, null);
			jPanel1.add(getEmailField(), null);
			jPanel1.add(jlReplyTo, null);
			jPanel1.add(getJtfReplyTo(), null);
			jPanel1.add(jlUseSig, null);
			jPanel1.add(getJcbUseSig(), null);			
			jPanel1.add(jlUseRules, null);
			jPanel1.add(getJcbUseRules(), null);			
			jPanel1.add(jlUseForReceiving, null);
			jPanel1.add(getJcbUseForReceiving(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jlInSSL = new JLabel();
			jlInSSL.setText(Strings.getString("AcntFormFrame.useSSL"));
			jlInSSL.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlInSSL.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelDeleteAfter = new JLabel();
			jLabelDeleteAfter.setText(Strings.getString("AcntFormFrame.acntDeleteAfter")); //$NON-NLS-1$
			jLabelDeleteAfter.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelDeleteAfter.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelLeaveOnServer = new JLabel();
			jLabelLeaveOnServer.setText(Strings.getString("AcntFormFrame.acntLeaveOnServer")); //$NON-NLS-1$
			jLabelLeaveOnServer.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelLeaveOnServer.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelInLeaveDays = new JLabel();
			jLabelInLeaveDays.setText(Strings.getString("AcntFormFrame.acntDeleteAfterDays")); //$NON-NLS-1$
			jLabelInLeaveDays.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelInLeaveDays.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelInMaxSize = new JLabel();
			jLabelInMaxSize.setText(Strings.getString("AcntFormFrame.acntMaxMessageSize")); //$NON-NLS-1$
			jLabelInMaxSize.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelInMaxSize.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelInPort = new JLabel();
			jLabelInPort.setText(Strings.getString("AcntFormFrame.acntInPort")); //$NON-NLS-1$
			jLabelInPort.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelInPort.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelStoreInPass = new JLabel();
			jLabelStoreInPass.setText(Strings.getString("AcntFormFrame.acntStoreInPass")); //$NON-NLS-1$
			jLabelStoreInPass.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelStoreInPass.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel3 = new JLabel();
			jLabel3.setText(Strings.getString("AcntFormFrame.srvTypeField")); //$NON-NLS-1$
			jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);		
			jLabel3.setPreferredSize(new java.awt.Dimension(210,15));		
			jLabel4 = new JLabel();
			jLabel4.setText(Strings.getString("AcntFormFrame.inSrvField")); //$NON-NLS-1$
			jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel4.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel7 = new JLabel();
			jLabel7.setText(Strings.getString("AcntFormFrame.userField")); //$NON-NLS-1$
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel7.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel8 = new JLabel();
			jLabel8.setText(Strings.getString("AcntFormFrame.passField")); //$NON-NLS-1$
			jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel8.setPreferredSize(new java.awt.Dimension(210,15));			
			jPanel2 = new JPanel();
			jPanel2.add(jLabel3, null);
			jPanel2.add(getServerTypeField(), null);
			jPanel2.add(jLabel4, null);
			jPanel2.add(getInServerField(), null);
			jPanel2.add(jLabelInPort, null);
			jPanel2.add(getInPortField(), null);
			jPanel2.add(jlInSSL, null);
			jPanel2.add(getJcbInSSL(), null);
			jPanel2.add(jLabel7, null);
			jPanel2.add(getInUserField(), null);
			jPanel2.add(jLabelStoreInPass, null);
			jPanel2.add(getJCheckBoxStoreInPass(), null);
			jPanel2.add(jLabel8, null);
			jPanel2.add(getInPassField(), null);			
			jPanel2.add(jLabelInMaxSize, null);
			jPanel2.add(getInMaxSizeField(), null);
			jPanel2.add(jLabelLeaveOnServer, null);
			jPanel2.add(getJCheckBoxLeaveOnServer(), null);
			jPanel2.add(jLabelDeleteAfter, null);
			jPanel2.add(getJCheckBoxDeleteAfter(), null);
			jPanel2.add(jLabelInLeaveDays, null);
			jPanel2.add(getInLeaveDaysField(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel3() {
		if (jPanel3 == null) {		
			jlOutSSL = new JLabel();
			jlOutSSL.setText(Strings.getString("AcntFormFrame.useSSL"));
			jlOutSSL.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jlOutSSL.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelOutPort = new JLabel();
			jLabelOutPort.setText(Strings.getString("AcntFormFrame.acntOutPort")); //$NON-NLS-1$
			jLabelOutPort.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelOutPort.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelStoreOutPass = new JLabel();
			jLabelStoreOutPass.setText(Strings.getString("AcntFormFrame.acntStoreOutPass")); //$NON-NLS-1$
			jLabelStoreOutPass.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelStoreOutPass.setPreferredSize(new java.awt.Dimension(210,15));
			jLabelOutAsIn = new JLabel();
			jLabelOutAsIn.setText(Strings.getString("AcntFormFrame.acntPassOutAsIn")); //$NON-NLS-1$
			jLabelOutAsIn.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabelOutAsIn.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel10 = new JLabel();
			jLabel10.setText(Strings.getString("AcntFormFrame.passField")); //$NON-NLS-1$
			jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel10.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel9 = new JLabel();
			jLabel9.setText(Strings.getString("AcntFormFrame.userField")); //$NON-NLS-1$
			jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel9.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel6 = new JLabel();
			jLabel6.setText(Strings.getString("AcntFormFrame.smtpAuthField")); //$NON-NLS-1$
			jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel6.setPreferredSize(new java.awt.Dimension(210,15));
			jLabel5 = new JLabel();
			jLabel5.setText(Strings.getString("AcntFormFrame.outSrvField")); //$NON-NLS-1$
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel5.setPreferredSize(new java.awt.Dimension(210,15));
			jPanel3 = new JPanel();
			jPanel3.add(jLabel5, null);
			jPanel3.add(getOutServerField(), null);
			jPanel3.add(jLabelOutPort, null);
			jPanel3.add(getOutPortField(), null);
			jPanel3.add(jlOutSSL, null);
			jPanel3.add(getJcbOutSSL(), null);
			jPanel3.add(jLabel6, null);
			jPanel3.add(getSmtpAuthComboBox(), null);
			jPanel3.add(jLabelOutAsIn, null);
			jPanel3.add(getJCheckBoxOutAsIn(), null);
			jPanel3.add(jLabel9, null);
			jPanel3.add(getOutUserField(), null);
			jPanel3.add(jLabelStoreOutPass, null);
			jPanel3.add(getJCheckBoxStoreOutPass(), null);
			jPanel3.add(jLabel10, null);
			jPanel3.add(getOutPassField(), null);			
		}
		return jPanel3;
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.add(getOkButton(), null);
			jPanel4.add(getCancelButton(), null);										
		}
		return jPanel4;
	}

	/**
	 * This method initializes jCheckBoxStoreInPass	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBoxStoreInPass() {
		if (jCheckBoxStoreInPass == null) {
			jCheckBoxStoreInPass = new JCheckBox();
			jCheckBoxStoreInPass.setPreferredSize(new java.awt.Dimension(170,20));
			jCheckBoxStoreInPass.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					if(jCheckBoxStoreInPass.isSelected())
						inPassField.setEnabled(true);
					else {
						inPassField.setEnabled(false);
						inPassField.setText(""); //$NON-NLS-1$
					}
				}
			});
		}
		return jCheckBoxStoreInPass;
	}

	/**
	 * This method initializes jCheckBoxOutAsIn	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBoxOutAsIn() {
		if (jCheckBoxOutAsIn == null) {
			jCheckBoxOutAsIn = new JCheckBox();
			jCheckBoxOutAsIn.setPreferredSize(new java.awt.Dimension(170,20));
			jCheckBoxOutAsIn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					if(jCheckBoxOutAsIn.isSelected()) {
						outUserField.setEnabled(false);
						outUserField.setText(""); //$NON-NLS-1$
						jCheckBoxStoreOutPass.setEnabled(false);
						jCheckBoxStoreOutPass.setSelected(false);
						outPassField.setEnabled(false);
						outPassField.setText(""); //$NON-NLS-1$
					} else {
						outUserField.setEnabled(true);
						jCheckBoxStoreOutPass.setEnabled(true);
						jCheckBoxStoreOutPass.setSelected(false);
					}
				}
			});
		}
		return jCheckBoxOutAsIn;
	}

	/**
	 * This method initializes jCheckBoxStoreOutPass	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBoxStoreOutPass() {
		if (jCheckBoxStoreOutPass == null) {
			jCheckBoxStoreOutPass = new JCheckBox();
			jCheckBoxStoreOutPass.setPreferredSize(new java.awt.Dimension(170,20));
			jCheckBoxStoreOutPass.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					if(jCheckBoxStoreOutPass.isSelected())
						outPassField.setEnabled(true);
					else {
						outPassField.setEnabled(false);
						outPassField.setText(""); //$NON-NLS-1$
					}
				}
			});
		}
		return jCheckBoxStoreOutPass;
	}

	/**
	 * This method initializes inPortField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getInPortField() {
		if (inPortField == null) {
			inPortField = new JTextField();
			inPortField.setPreferredSize(new java.awt.Dimension(170,20));
			inPortField.setText("-1");
			TextPopup.registerComponent(inPortField);
		}
		return inPortField;
	}

	/**
	 * This method initializes inMaxSizeField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getInMaxSizeField() {
		if (inMaxSizeField == null) {
			inMaxSizeField = new JTextField();
			inMaxSizeField.setPreferredSize(new java.awt.Dimension(170,20));
			inMaxSizeField.setText("-1");
			TextPopup.registerComponent(inMaxSizeField);
		}
		return inMaxSizeField;
	}

	/**
	 * This method initializes inDeleteAfterField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getInLeaveDaysField() {
		if (inLeaveDaysField == null) {
			inLeaveDaysField = new JTextField();
			inLeaveDaysField.setPreferredSize(new java.awt.Dimension(170,20));
			inLeaveDaysField.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusLost(java.awt.event.FocusEvent e) {    
					updateUILeaveDays();
				}
			});
			inLeaveDaysField.setText("0");
			TextPopup.registerComponent(inLeaveDaysField);
		}
		return inLeaveDaysField;
	}

	/**
	 * This method initializes outPortField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getOutPortField() {
		if (outPortField == null) {
			outPortField = new JTextField();
			outPortField.setPreferredSize(new java.awt.Dimension(170,20));
			outPortField.setText("-1");
			TextPopup.registerComponent(outPortField);
		}
		return outPortField;
	}

	/**
	 * This method initializes jCheckBoxLeaveOnServer	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBoxLeaveOnServer() {
		if (jCheckBoxLeaveOnServer == null) {
			jCheckBoxLeaveOnServer = new JCheckBox();
			jCheckBoxLeaveOnServer.setPreferredSize(new java.awt.Dimension(170,20));
			jCheckBoxLeaveOnServer.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jCheckBoxLeaveOnServer_actionPerformed(e);
				}
			});
		}
		return jCheckBoxLeaveOnServer;
	}

	void jCheckBoxLeaveOnServer_actionPerformed(java.awt.event.ActionEvent e) {
		if(jCheckBoxLeaveOnServer.isSelected()) {
			jCheckBoxDeleteAfter.setEnabled(true);
			jCheckBoxDeleteAfter.setSelected(false);
			inLeaveDaysField.setEnabled(false);
			inLeaveDaysField.setText(String.valueOf(-1));
		} else {
			jCheckBoxDeleteAfter.setSelected(true);
			jCheckBoxDeleteAfter.setEnabled(false);
			inLeaveDaysField.setEnabled(false);
			inLeaveDaysField.setText(String.valueOf(0));			
		}	
	}
	
	/**
	 * This method initializes jCheckBoxDeleteAfter	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBoxDeleteAfter() {
		if (jCheckBoxDeleteAfter == null) {
			jCheckBoxDeleteAfter = new JCheckBox();
			jCheckBoxDeleteAfter.setPreferredSize(new java.awt.Dimension(170,20));
			jCheckBoxDeleteAfter.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jCheckBoxDeleteAfter_actionPerformed(e);
				}
			});
		}
		return jCheckBoxDeleteAfter;
	}

	void jCheckBoxDeleteAfter_actionPerformed(java.awt.event.ActionEvent e) {
		if(jCheckBoxDeleteAfter.isSelected()) {
			inLeaveDaysField.setEnabled(true);
			inLeaveDaysField.setText("1");
		} else {
			inLeaveDaysField.setEnabled(false);
			inLeaveDaysField.setText("-1");			
		}
	}

	/**
	 * This method initializes jcbUseRules	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbUseRules() {
		if (jcbUseRules == null) {
			jcbUseRules = new JCheckBox();
			jcbUseRules.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return jcbUseRules;
	}

	/**
	 * This method initializes jcbUseSig	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJcbUseSig() {
		if (jcbUseSig == null) {
			String useSig[] = { 
					Strings.getString("Signatures.sigNotUse"), //$NON-NLS-1$
					Strings.getString("Signatures.sigUse"), //$NON-NLS-1$
					Strings.getString("Signatures.sigUseDefault") }; //$NON-NLS-1$			
			jcbUseSig = new JComboBox(useSig);
			jcbUseSig.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return jcbUseSig;
	}

	/**
	 * This method initializes jcbInSSL	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbInSSL() {
		if (jcbInSSL == null) {
			jcbInSSL = new JCheckBox();
			jcbInSSL.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return jcbInSSL;
	}

	/**
	 * This method initializes jcbOutSSL	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbOutSSL() {
		if (jcbOutSSL == null) {
			jcbOutSSL = new JCheckBox();
			jcbOutSSL.setPreferredSize(new java.awt.Dimension(170,20));
		}
		return jcbOutSSL;
	}

	/**
	 * This method initializes jtfPerson	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfPerson() {
		if (jtfPerson == null) {
			jtfPerson = new JTextField();
			jtfPerson.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(jtfPerson);
		}
		return jtfPerson;
	}

	/**
	 * This method initializes jtfReplyTo	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfReplyTo() {
		if (jtfReplyTo == null) {
			jtfReplyTo = new JTextField();
			jtfReplyTo.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(jtfReplyTo);
		}
		return jtfReplyTo;
	}

	/**
	 * This method initializes jtfOrganization	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfOrganization() {
		if (jtfOrganization == null) {
			jtfOrganization = new JTextField();
			jtfOrganization.setPreferredSize(new java.awt.Dimension(170,20));
			TextPopup.registerComponent(jtfOrganization);
		}
		return jtfOrganization;
	}

	/**
	 * This method initializes jcbUseForReceiving	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbUseForReceiving() {
		if (jcbUseForReceiving == null) {
			jcbUseForReceiving = new JCheckBox();
			jcbUseForReceiving.setPreferredSize(new java.awt.Dimension(170,20));
			jcbUseForReceiving.setSelected(true);
		}
		return jcbUseForReceiving;
	}
	
}  //  @jve:decl-index=0:visual-constraint="-34,18"
