/*
 * @(#)AddrFormFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.FlowLayout;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;

public class AddrFormFrame extends JFrame {

	static final long serialVersionUID = 4675075796621123991L;
	private final String WIN_ID = "address_form";
	private JPanel jContentPane = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	private JLabel jLabel7 = null;
	private JLabel jLabel8 = null;
	private JLabel jLabel9 = null;
	private JLabel jLabel10 = null;
	private JLabel jLabel11 = null;
	private JLabel jLabel12 = null;
	private JTextField fnameField = null;
	private JTextField lnameField = null;
	private JTextField mnameField = null;
	private JTextField emailField = null;
	private JTextField homeCountryField = null;
	private JTextField homeRegionField = null;
	private JTextField homeCityField = null;
	private JTextField homeIndexField = null;
	private JTextField homeStreetField = null;
	private JTextField homePhoneField = null;
	private JTextField mobilePhoneField = null;
	private JButton okButton = null;
	private JButton cancelButton = null;
	private ParentList parent = null;
	private JTable parentTable = null;
	private int parentRow = -1;
	private Address myAddress = new Address();
	
	/**
	 * This is the default constructor
	 */
	public AddrFormFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(410, 352);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("AddrFormFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel12 = new JLabel();
			jLabel12.setText(Strings.getString("AddrFormFrame.emailField")); //$NON-NLS-1$
			jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel12.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel11 = new JLabel();
			jLabel11.setText(Strings.getString("AddrFormFrame.addrStreetField")); //$NON-NLS-1$
			jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel11.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel10 = new JLabel();
			jLabel10.setText(Strings.getString("AddrFormFrame.mobilePhoneField")); //$NON-NLS-1$
			jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel10.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel9 = new JLabel();
			jLabel9.setText(Strings.getString("AddrFormFrame.homePhoneField")); //$NON-NLS-1$
			jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel9.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel8 = new JLabel();
			jLabel8.setText(Strings.getString("AddrFormFrame.homeIndexField")); //$NON-NLS-1$
			jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel8.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel7 = new JLabel();
			jLabel7.setText(Strings.getString("AddrFormFrame.homeCityField")); //$NON-NLS-1$
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel7.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel6 = new JLabel();
			jLabel6.setText(Strings.getString("AddrFormFrame.homeRegionField")); //$NON-NLS-1$
			jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel6.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel5 = new JLabel();
			jLabel5.setText(Strings.getString("AddrFormFrame.homeCountryField")); //$NON-NLS-1$
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel5.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel4 = new JLabel();
			jLabel4.setText(Strings.getString("AddrFormFrame.mNameField")); //$NON-NLS-1$
			jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel4.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel3 = new JLabel();
			jLabel3.setText(Strings.getString("AddrFormFrame.lNameField")); //$NON-NLS-1$
			jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel3.setPreferredSize(new java.awt.Dimension(120,16));
			jLabel2 = new JLabel();
			jLabel2.setText(Strings.getString("AddrFormFrame.fNameField")); //$NON-NLS-1$
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
			jLabel2.setPreferredSize(new java.awt.Dimension(120,16));
			jContentPane = new JPanel();
			jContentPane.setLayout(new FlowLayout());
			jContentPane.add(jLabel2, null);
			jContentPane.add(getFnameField(), null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getLnameField(), null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(getMnameField(), null);
			jContentPane.add(jLabel12, null);
			jContentPane.add(getEmailField(), null);
			jContentPane.add(jLabel5, null);
			jContentPane.add(getHomeCountryField(), null);
			jContentPane.add(jLabel6, null);
			jContentPane.add(getHomeRegionField(), null);
			jContentPane.add(jLabel7, null);
			jContentPane.add(getHomeCityField(), null);
			jContentPane.add(jLabel8, null);
			jContentPane.add(getHomeIndexField(), null);
			jContentPane.add(jLabel11, null);
			jContentPane.add(getHomeStreetField(), null);
			jContentPane.add(jLabel9, null);
			jContentPane.add(getHomePhoneField(), null);
			jContentPane.add(jLabel10, null);
			jContentPane.add(getMobilePhoneField(), null);
			jContentPane.add(getOkButton(), null);
			jContentPane.add(getCancelButton(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes fnameField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getFnameField() {
		if (fnameField == null) {
			fnameField = new JTextField();
			fnameField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(fnameField);
		}
		return fnameField;
	}

	/**
	 * This method initializes lnameField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getLnameField() {
		if (lnameField == null) {
			lnameField = new JTextField();
			lnameField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(lnameField);
		}
		return lnameField;
	}

	/**
	 * This method initializes mnameField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getMnameField() {
		if (mnameField == null) {
			mnameField = new JTextField();
			mnameField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(mnameField);
		}
		return mnameField;
	}

	/**
	 * This method initializes emailField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getEmailField() {
		if (emailField == null) {
			emailField = new JTextField();
			emailField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(emailField);
		}
		return emailField;
	}
		
	/**
	 * This method initializes homeCountryField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomeCountryField() {
		if (homeCountryField == null) {
			homeCountryField = new JTextField();
			homeCountryField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homeCountryField);
		}
		return homeCountryField;
	}

	/**
	 * This method initializes homeRegionField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomeRegionField() {
		if (homeRegionField == null) {
			homeRegionField = new JTextField();
			homeRegionField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homeRegionField);
		}
		return homeRegionField;
	}

	/**
	 * This method initializes homeCityField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomeCityField() {
		if (homeCityField == null) {
			homeCityField = new JTextField();
			homeCityField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homeCityField);
		}
		return homeCityField;
	}

	/**
	 * This method initializes homeIndexField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomeIndexField() {
		if (homeIndexField == null) {
			homeIndexField = new JTextField();
			homeIndexField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homeIndexField);
		}
		return homeIndexField;
	}

	/**
	 * This method initializes homeStreetField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomeStreetField() {
		if (homeStreetField == null) {
			homeStreetField = new JTextField();
			homeStreetField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homeStreetField);
		}
		return homeStreetField;
	}

	/**
	 * This method initializes homePhoneField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getHomePhoneField() {
		if (homePhoneField == null) {
			homePhoneField = new JTextField();
			homePhoneField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(homePhoneField);
		}
		return homePhoneField;
	}

	/**
	 * This method initializes mobilePhoneField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getMobilePhoneField() {
		if (mobilePhoneField == null) {
			mobilePhoneField = new JTextField();
			mobilePhoneField.setPreferredSize(new java.awt.Dimension(250,20));
			TextPopup.registerComponent(mobilePhoneField);
		}
		return mobilePhoneField;
	}

	/**
	 * This method initializes okButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setText(Strings.getString("okButton")); //$NON-NLS-1$
			okButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					okButton_actionPerformed(e);
				}
			});
		}
		return okButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Strings.getString("cancelButton")); //$NON-NLS-1$
			cancelButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return cancelButton;
	}

	public void editAddress(JTable table, int row, String id) {
		this.parentTable = table;
		this.parentRow = row;
		try {
//			olivamail.gui.Address addr = Context.storage.getAddress(id);
//			idField.setText(addr.id);
			myAddress = Context.storage.getAddress(id);
			fnameField.setText(myAddress.fname);
			lnameField.setText(myAddress.lname);
			mnameField.setText(myAddress.mname);
			emailField.setText(myAddress.email);
			homeCountryField.setText(myAddress.homeCountry);
			homeRegionField.setText(myAddress.homeRegion);
			homeCityField.setText(myAddress.homeCity);
			homeIndexField.setText(myAddress.homeIndex);
			homeStreetField.setText(myAddress.homeStreet);
			homePhoneField.setText(myAddress.homePhone);
			mobilePhoneField.setText(myAddress.mobilePhone);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	public void setParent(ParentList parent) {
		this.parent = parent;
	}

	void okButton_actionPerformed(ActionEvent e) {
//		olivamail.gui.Address addr = new olivamail.gui.Address(); 
//		myAddress.id = idField.getText();
		myAddress.fname = fnameField.getText();
		myAddress.lname = lnameField.getText();
		myAddress.mname = mnameField.getText();
		myAddress.email = emailField.getText();
		myAddress.homeCountry = homeCountryField.getText();
		myAddress.homeRegion = homeRegionField.getText();
		myAddress.homeCity = homeCityField.getText();
		myAddress.homeIndex = homeIndexField.getText();
		myAddress.homeStreet = homeStreetField.getText();
		myAddress.homePhone = homePhoneField.getText();
		myAddress.mobilePhone = mobilePhoneField.getText();
		try {
			myAddress = Context.storage.saveAddress(myAddress);
			parent.updateRow(parentTable, parentRow, myAddress);
			this_windowClosing(null);
			dispose();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
