/*
 * @(#)AddressesFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JButton;
import java.util.Vector;
import java.awt.Component;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import java.awt.Color;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JTextField;

public class AddressesFrame extends JFrame implements ParentList {

	static final long serialVersionUID = -8792944795704595556L;

	private final String WIN_ID = "addresses";	
	
	private JPanel jContentPane = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel3 = null;

	private JPanel jPanel4 = null;

	private JScrollPane jScrollPane1 = null;

	private JTable jTable1 = null;

	private JButton jButton5 = null;

	private AddressReceiver addrReceiver = null;
	
	private int addrType = -1;

	private JMenuBar jMenuBar1 = null;

	private JMenu jMenuFile = null;

	private JMenuItem jMenuItemClose = null;

	private JMenu jMenuContacts = null;

	private JMenuItem jMenuItemContCreate = null;

	private JMenuItem jMenuItemContEdit = null;

	private JMenuItem jMenuItemContDelete = null;

	private JMenuItem jMenuItemGrpCreate = null;

	private JTextField jtfSearch = null;

	private JButton jbSearch = null;

	/**
	 * This is the default constructor
	 */
	public AddressesFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	public void setParent(AddressReceiver addrReceiver, int addrType) {
		this.addrReceiver = addrReceiver;
		this.addrType = addrType;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(502, 318);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setJMenuBar(getJMenuBar1());
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("AddressesFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}	
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJPanel4(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setPreferredSize(new java.awt.Dimension(10,30));
			jPanel1.add(getJtfSearch(), null);
			jPanel1.add(getJbSearch(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
		}
		return jPanel3;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.add(getJButton5(), null);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jTable1
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {
				static final long serialVersionUID = 1507730867321229516L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}												
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {// What else
																// should i put
																// in here to
																// check the
																// value
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}
/*
					Font font0 = new java.awt.Font("Dialog", 1, 14); //$NON-NLS-1$
					Font font1 = new java.awt.Font("Dialog", 0, 14); //$NON-NLS-1$
					Font font = null;
					if (((String) this.getValueAt(rowIndex, 8)).compareTo("D") == 0) //$NON-NLS-1$
						font = font0;
					else
						font = font1;
					c.setFont(font);
*/					
					return c;
				}
			};
			//jTable1.setFont(new java.awt.Font("Dialog", 0, 14)); //$NON-NLS-1$
			jTable1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if (e.getClickCount() == 2) {
						if (addrReceiver == null)
							editCurrentRow();
						else
							callSelect();
					}
				}
			});
			
			jTable1.setGridColor(jTable1.getBackground());
		}
		return jTable1;
	}

	public void listAddresses() {
		listAddresses(null);
	}
	
	public void listAddresses(String searchStr) {
		Vector headers = new Vector(4);
		headers.add(Strings.getString("AddressesFrame.idField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.emailField")); //$NON-NLS-1$
		headers.add(Strings.getString("TYPE")); //$NON-NLS-1$		
/*
		Vector headers = new Vector(12);
		headers.add(Strings.getString("AddressesFrame.idField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.lNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.mNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.emailField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeCountryField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeRegionField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeCityField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeIndexField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeStreetField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homePhoneField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.MobilePhoneField")); //$NON-NLS-1$
*/		
		Vector rows = null;
		try {
			rows = Context.storage.getContactsList(searchStr, null, -1);
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(AddressTableColumns.COL_ID).setMaxWidth(40);
			tcm.getColumn(AddressTableColumns.COL_NAME).setMinWidth(200);
			tcm.getColumn(AddressTableColumns.COL_EMAIL).setMinWidth(200);
			tcm.getColumn(AddressTableColumns.COL_TYPE).setMaxWidth(20);
			tcm.getColumn(AddressTableColumns.COL_TYPE).setHeaderRenderer(
					new AddrHeaderRenderer());
			tcm.getColumn(AddressTableColumns.COL_TYPE).setCellRenderer(
					new AddrIconRenderer());			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	void jButton2_actionPerformed(ActionEvent e) {
	}

	void jButton1_actionPerformed(ActionEvent e) {
	}

	void jButton3_actionPerformed(ActionEvent e) {
	}

	/**
	 * This method initializes jButton5
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new JButton();
			jButton5.setText(Strings.getString("AddressesFrame.selectButton")); //$NON-NLS-1$
			jButton5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButton5_actionPerformed(e);
				}
			});
		}
		return jButton5;
	}

	void callSelect() {
		if (!addrReceiver.isVisible())
			return;
		int[] rows = jTable1.getSelectedRows();
		if (rows == null || rows.length == 0)
			return;
		
		StringBuffer sb = new StringBuffer(); 
		
		for(int i = 0; i < rows.length; i++) {
			String recType = (String) jTable1.getValueAt(rows[i], 3);
			if (recType.equals("0")) {
				sb.append((String)jTable1.getValueAt(rows[i], 2)).append(", ");
			} else if (recType.equals("1")) {
				try {
					sb.append(Context.storage.getGroupAddresses((String)jTable1.getValueAt(rows[i], 0)));
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
				}				
			}						
		}
		
		String to = sb.toString(); 
		if(to.length() > 2)
			to = to.substring(0, to.length() - 2);
		addrReceiver.addAddress(to, addrType);
		this_windowClosing(null);
		dispose();		
	}
	
	void jButton5_actionPerformed(java.awt.event.ActionEvent e) {
		if (addrReceiver == null) {
			editCurrentRow();
			return;
		}
		callSelect();
	}

	/**
	 * This method initializes jJMenuBar1	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private JMenuBar getJMenuBar1() {
		if (jMenuBar1 == null) {
			jMenuBar1 = new JMenuBar();
			jMenuBar1.add(getJMenuFile());
			jMenuBar1.add(getJMenuContacts());
		}
		return jMenuBar1;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText(Strings.getString("menuFile")); //$NON-NLS-1$
			jMenuFile.add(getJMenuItemClose());
		}
		return jMenuFile;
	}

	/**
	 * This method initializes jMenuItemClose	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemClose() {
		if (jMenuItemClose == null) {
			jMenuItemClose = new JMenuItem();
			jMenuItemClose.setText(Strings.getString("menuClose")); //$NON-NLS-1$
			jMenuItemClose.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return jMenuItemClose;
	}

	/**
	 * This method initializes jMenuContacts	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuContacts() {
		if (jMenuContacts == null) {
			jMenuContacts = new JMenu();
			jMenuContacts.setText(Strings.getString("AddressesFrame.menuContacts")); //$NON-NLS-1$
			jMenuContacts.add(getJMenuItemContCreate());
			jMenuContacts.add(getJMenuItemGrpCreate());
			jMenuContacts.add(getJMenuItemContEdit());
			jMenuContacts.add(getJMenuItemContDelete());
		}
		return jMenuContacts;
	}

	/**
	 * This method initializes jMenuItemContCreate	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemContCreate() {
		if (jMenuItemContCreate == null) {
			jMenuItemContCreate = new JMenuItem();
			jMenuItemContCreate.setText(Strings.getString("menuCreate")); //$NON-NLS-1$
			jMenuItemContCreate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContCreate_actionPerformed(e);
				}
			});
		}
		return jMenuItemContCreate;
	}

	void jMenuItemContCreate_actionPerformed(java.awt.event.ActionEvent e) {
/*		
		AddrFormFrame aff = new AddrFormFrame();
		aff.setParent(this);
		aff.show();
*/
		AddrFrame af = new AddrFrame();
		af.setParent(this);
		af.setVisible(true);
	}
	
	/**
	 * This method initializes jMenuItemContEdit	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemContEdit() {
		if (jMenuItemContEdit == null) {
			jMenuItemContEdit = new JMenuItem();
			jMenuItemContEdit.setText(Strings.getString("menuEdit")); //$NON-NLS-1$
			jMenuItemContEdit.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContEdit_actionPerformed(e);
				}
			});
		}
		return jMenuItemContEdit;
	}

	void jMenuItemContEdit_actionPerformed(java.awt.event.ActionEvent e) {
		editCurrentRow();
	}

	void editCurrentRow() {
		int row = jTable1.getSelectedRow();
		if (row == -1)
			return;
		String recType = (String)jTable1.getValueAt(row, 3);
		if(recType.equals("0")) {
			AddrFormFrame aff = new AddrFormFrame();
			aff.setParent(this);
			aff.editAddress(jTable1, row, (String) jTable1.getValueAt(row, 0));
			aff.setVisible(true);			
		} else if(recType.equals("1")) {
			GroupsFrame gf = new GroupsFrame();
			gf.setParent(this);
			gf.editAddress(jTable1, row, (String) jTable1.getValueAt(row, 0));
			gf.listAddresses();
			gf.setVisible(true);			
		}				
	}
	
	/**
	 * This method initializes jMenuItemContDelete	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemContDelete() {
		if (jMenuItemContDelete == null) {
			jMenuItemContDelete = new JMenuItem();
			jMenuItemContDelete.setText(Strings.getString("menuDelete")); //$NON-NLS-1$
			jMenuItemContDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContDelete_actionPerformed(e);
				}
			});
		}
		return jMenuItemContDelete;
	}

	void jMenuItemContDelete_actionPerformed(java.awt.event.ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row == -1)
			return;
		if (AlertDialog
				.showConfirmDialog(
						Strings.getString("AddressesFrame.ctntDeleteConfirm"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION) //$NON-NLS-1$
			return;
		try {
			String recType = (String) jTable1.getValueAt(row, 3);
			if (recType.equals("0")) {
				Context.storage.deleteAddress((String) jTable1.getValueAt(row,
						0));
			} else if (recType.equals("1")) {
				Context.storage.deleteGroup((String) jTable1.getValueAt(row,
						0));
			}
			((DefaultTableModel)jTable1.getModel()).removeRow(row);
//			listAddresses();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	/**
	 * This method initializes jMenuItemGrpCreate	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemGrpCreate() {
		if (jMenuItemGrpCreate == null) {
			jMenuItemGrpCreate = new JMenuItem();
			jMenuItemGrpCreate.setText(Strings.getString("AddressesFrame.menuCreateGroup")); //$NON-NLS-1$
			jMenuItemGrpCreate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemGrpCreate_actionPerformed(e);
				}
			});
		}
		return jMenuItemGrpCreate;
	}

	void jMenuItemGrpCreate_actionPerformed(java.awt.event.ActionEvent e) {
		GroupsFrame gf = new GroupsFrame();
		gf.setParent(this);
		gf.listAddresses();
		gf.setVisible(true);				
	}

	public void updateRow(JTable jTable, int row, Object obj) {
		if (obj == null)
			return;
		if(jTable == null)
			jTable = jTable1;		
		if (row == -1) {
			if (obj instanceof olivamail.gui.Address) {
				olivamail.gui.Address addr = (olivamail.gui.Address) obj;
				DefaultTableModel dtm = (DefaultTableModel) jTable.getModel();
				String[] rowArray = { addr.id, addr.fname + " " + addr.lname,
						addr.email, "0" };
				dtm.addRow(rowArray);
				jTable.setRowSelectionInterval(jTable.getRowCount() - 1, jTable.getRowCount() - 1);
			} else if (obj instanceof olivamail.gui.Group) {
				olivamail.gui.Group grp = (olivamail.gui.Group) obj;
				DefaultTableModel dtm = (DefaultTableModel) jTable.getModel();
				String[] rowArray = { grp.id, grp.name, null, "1" };
				dtm.addRow(rowArray);
				jTable.setRowSelectionInterval(jTable.getRowCount() - 1, jTable.getRowCount() - 1);
			}
			return;
		}
		if (jTable.getRowCount() <= row)
			return;
		String id = (String) jTable.getValueAt(row, AddressTableColumns.COL_ID);
		if (obj instanceof olivamail.gui.Address) {
			olivamail.gui.Address addr = (olivamail.gui.Address) obj;
			if (!addr.id.equals(id))
				return;
			jTable.setValueAt(addr.fname + " " + addr.lname, row,
					AddressTableColumns.COL_NAME);
			jTable.setValueAt(addr.email, row, AddressTableColumns.COL_EMAIL);
			jTable.setValueAt("0", row, AddressTableColumns.COL_TYPE);
		} else if (obj instanceof olivamail.gui.Group) {
			olivamail.gui.Group grp = (olivamail.gui.Group) obj;
			if (!grp.id.equals(id))
				return;
			jTable.setValueAt(grp.name, row, AddressTableColumns.COL_NAME);
			jTable.setValueAt(null, row, AddressTableColumns.COL_EMAIL);
			jTable.setValueAt("1", row, AddressTableColumns.COL_TYPE);
		} 
	}

	/**
	 * This method initializes jtfSearch	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfSearch() {
		if (jtfSearch == null) {
			jtfSearch = new JTextField();
			jtfSearch.setPreferredSize(new java.awt.Dimension(220,20));
			jtfSearch.addKeyListener(new java.awt.event.KeyAdapter() {   
				public void keyPressed(java.awt.event.KeyEvent e) {    
					jtfSearch_keyPressed(e);
				} 
			});
		}
		return jtfSearch;
	}

	void jtfSearch_keyPressed(java.awt.event.KeyEvent e) {
		if(e.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
			jbSearch_actionPerformed();			
		}
	}
	
	/**
	 * This method initializes jbSearch	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbSearch() {
		if (jbSearch == null) {
			jbSearch = new JButton();
			jbSearch.setText(Strings.getString("searchButton")); //$NON-NLS-1$
			jbSearch.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbSearch_actionPerformed();
				}
			});
			jbSearch.setPreferredSize(new java.awt.Dimension(70,20));
		}
		return jbSearch;
	}
	
	void jbSearch_actionPerformed() {
		String str = jtfSearch.getText().trim();
		listAddresses(str);
	}
	
} // @jve:decl-index=0:visual-constraint="10,10"

class AddrIconRenderer extends JLabel implements TableCellRenderer {
	static final long serialVersionUID = 6244793159432844502L;

	public AddrIconRenderer() {
		super();
	}

	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		try {
			String val = (String) value;
			if(val == null)
				val = "";
			switch (column) {
			case AddressTableColumns.COL_TYPE:
				if (val.compareTo("1") == 0) //$NON-NLS-1$
					this
							.setIcon(new ImageIcon(this.getClass()
									.getResource("group.gif"))); //$NON-NLS-1$
				else
					this.setIcon(null);
				break;
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		return this;
	}
}

class AddrHeaderRenderer extends JLabel implements TableCellRenderer {
	static final long serialVersionUID = 4451180638410833789L;

	public AddrHeaderRenderer() {
		super();
	}

	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		try {
			switch (column) {
			case AddressTableColumns.COL_TYPE:
				this.setIcon(new ImageIcon(this.getClass().getResource(
						"group.gif"))); //$NON-NLS-1$
				break;
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		return this;
	}

}

class AddressTableColumns {
	static final int COL_ID = 0;

	static final int COL_NAME = 1;

	static final int COL_EMAIL = 2;

	static final int COL_TYPE = 3;
}
