package olivamail.gui;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.io.File;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

import olivamail.core.common.ComUtils;

import java.awt.BorderLayout;

public class ComposeHeader extends JPanel implements AddressReceiver {

	static final long serialVersionUID = 4432323324324231L;	
	
	private JPanel fromPanel = null;

	private JLabel jLabel = null;

	private JPanel toPanel = null;
	
	private JLabel jLabel4 = null;
	
	private JLabel jlAttachments = null;	
	
	public JComboBox jcbAddrFrom = null;

	public JTextField toField = null;

	public JTextField ccField = null;

	public JTextField bccField = null;

	public JTextField subjectField = null;

	private JButton jbTo = null;

	private JButton jbCc = null;

	private JButton jbBcc = null;
	
	private JScrollPane jScrollPane1 = null;	
		
	private Composer composeFrame = null;
	
	public int addrFromIdx = -1;	
	
	public JEditorPane jepAtt = null;
	
	int curAttPort = 0;
	
	int curAttXPos = 5;
	
	int curAttYPos = 5;	
	
	private JPopupMenu jPopupMenu1 = null;
	
	private JMenuItem jmiDelete = null;
	
	private StringBuffer sbAtt = null;
	
	public Vector cacheFiles = null;
	
	private final int HEIGHT_ATT = 150;
	
	private final int HEIGHT_NORMAL = 109;
		
	/**
	 * This is the default constructor
	 */
	public ComposeHeader() {
		super();
		initialize();
	}
		
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.setSize(520, 140);
		this.addComponentListener(new java.awt.event.ComponentAdapter() { 
			public void componentResized(java.awt.event.ComponentEvent e) {    
				this_componentResized(e);
			}
		});
		this.add(getFromPanel(), java.awt.BorderLayout.NORTH);
		this.add(getToPanel(), java.awt.BorderLayout.CENTER);
	}

	void this_componentResized(java.awt.event.ComponentEvent e) {
		int height = toField.getHeight();
		int width = this.getWidth() - jbTo.getWidth() - 30; 
		if(width > 0) {
			Dimension dim = new Dimension(width, height);
			toField.setPreferredSize(dim);
			toField.setSize(dim);
			ccField.setPreferredSize(dim);
			ccField.setSize(dim);
			bccField.setPreferredSize(dim);
			bccField.setSize(dim);
			subjectField.setPreferredSize(dim);
			subjectField.setSize(dim);
			jScrollPane1.setPreferredSize(new Dimension(width, 30));
			jScrollPane1.setSize(new Dimension(width, 30));			
		}
		toPanel.updateUI();
	}
		
	/**
	 * This method initializes jPanel1_1
	 * 
	 * @return javax.swing.JPanel
	 */    
	private JPanel getFromPanel() {
		if (fromPanel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout.setVgap(1);
			jLabel = new JLabel();
			jLabel.setPreferredSize(new Dimension(80, 15));
			jLabel.setText(Strings.getString("ComposeFrame.fromFiled")); //$NON-NLS-1$
			fromPanel = new JPanel();
			fromPanel.setPreferredSize(new java.awt.Dimension(90,24));
			fromPanel.setLayout(flowLayout);
			fromPanel.add(jLabel, null);
			fromPanel.add(getJComboBox1(), null);
		}
		return fromPanel;
	}

	/**
	 * This method initializes jPanel1_2
	 * 
	 * @return javax.swing.JPanel
	 */    
	private JPanel getToPanel() {
		if (toPanel == null) {
			jlAttachments = new JLabel();
			jlAttachments.setText(Strings.getString("MessageFrame.attachments"));
			jlAttachments.setPreferredSize(new java.awt.Dimension(80,15));
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout1.setHgap(5);
			flowLayout1.setVgap(1);
			jLabel4 = new JLabel();
			jLabel4.setPreferredSize(new Dimension(80, 15));
			jLabel4.setText(Strings.getString("ComposeFrame.subjectFiled")); //$NON-NLS-1$			
			toPanel = new JPanel();
			toPanel.setPreferredSize(new java.awt.Dimension(395,80));
			toPanel.setLayout(flowLayout1);
			toPanel.add(getJbTo(), null);
			toPanel.add(getToField(), null);
			toPanel.add(getJbCc(), null);
			toPanel.add(getCcField(), null);
			toPanel.add(getJbBcc(), null);
			toPanel.add(getBccField(), null);
			toPanel.add(jLabel4, null);
			toPanel.add(getSubjectField(), null);			
			toPanel.add(jlAttachments, null);
			toPanel.add(getJScrollPane1(), null);
		}
		return toPanel;
	}	
	
	/**
	 * This method initializes jComboBox1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox1() {
		if (jcbAddrFrom == null) {
			Object senderAddresses[] = null;
			try {
				senderAddresses = Context.storage.getAccounts(null).toArray();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
			Account defAcnt = null;
			try {
				defAcnt = Context.storage.getDefaultAccount();
			} catch (Exception exc) {
				exc.printStackTrace();
			}			
			if(senderAddresses == null)
				jcbAddrFrom = new JComboBox();
			else
				jcbAddrFrom = new JComboBox(senderAddresses);
			if(defAcnt != null)
				jcbAddrFrom.setSelectedItem(defAcnt);
			jcbAddrFrom.setPreferredSize(new java.awt.Dimension(300,20));
			jcbAddrFrom.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (composeFrame != null)
						composeFrame.changeFromAddr();
				}
			});
			addrFromIdx = jcbAddrFrom.getSelectedIndex();
		}
		return jcbAddrFrom;
	}

	/**
	 * This method initializes toField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getToField() {
		if (toField == null) {
			toField = new JTextField();
			toField.setPreferredSize(new java.awt.Dimension(425,20));
			toField.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusLost(java.awt.event.FocusEvent e) {
					if (composeFrame != null)
						composeFrame.setSigHeader();
				}
			});
			TextPopup.registerComponent(toField);
		}
		return toField;
	}

	/**
	 * This method initializes ccField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getCcField() {
		if (ccField == null) {
			ccField = new JTextField();
			ccField.setPreferredSize(new java.awt.Dimension(425,20));
			ccField.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusLost(java.awt.event.FocusEvent e) {    
					if (composeFrame != null)
						composeFrame.setSigHeader();
				}
			});
			TextPopup.registerComponent(ccField);
		}
		return ccField;
	}

	/**
	 * This method initializes bccField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getBccField() {
		if (bccField == null) {
			bccField = new JTextField();
			bccField.setPreferredSize(new java.awt.Dimension(425,20));
			TextPopup.registerComponent(bccField);
		}
		return bccField;
	}

	/**
	 * This method initializes subjectField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getSubjectField() {
		if (subjectField == null) {
			subjectField = new JTextField();
			subjectField.setPreferredSize(new java.awt.Dimension(425,20));
			TextPopup.registerComponent(subjectField);
		}
		return subjectField;
	}
		
	/**
	 * This method initializes jbTo
	 * 
	 * @return javax.swing.JButton
	 */    
	private JButton getJbTo() {
		if (jbTo == null) {
			jbTo = new JButton();
			jbTo.setText(Strings.getString("ComposeFrame.toFiled")); //$NON-NLS-1$
			jbTo.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jbTo.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbTo_actionPerformed(e);
				}
			});
			jbTo.setPreferredSize(new java.awt.Dimension(80,20));
		}
		return jbTo;
	}

	void jbTo_actionPerformed(java.awt.event.ActionEvent e) {
		AddressesFrame af = new AddressesFrame();
		af.setParent(this, Address.ADDR_TO);
		af.setVisible(true);
		af.listAddresses();				
	}
	
	/**
	 * This method initializes jbCc
	 * 
	 * @return javax.swing.JButton
	 */    
	private JButton getJbCc() {
		if (jbCc == null) {
			jbCc = new JButton();
			jbCc.setText(Strings.getString("ComposeFrame.ccFiled")); //$NON-NLS-1$
			jbCc.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jbCc.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbCc_actionPerformed(e);
				}
			});
			jbCc.setPreferredSize(new java.awt.Dimension(80,20));
		}
		return jbCc;
	}

	void jbCc_actionPerformed(java.awt.event.ActionEvent e) {
		AddressesFrame af = new AddressesFrame();
		af.setParent(this, Address.ADDR_CC);
		af.setVisible(true);
		af.listAddresses();						
	}
	
	/**
	 * This method initializes jbBcc
	 * 
	 * @return javax.swing.JButton
	 */    
	private JButton getJbBcc() {
		if (jbBcc == null) {
			jbBcc = new JButton();
			jbBcc.setText(Strings.getString("ComposeFrame.bccFiled")); //$NON-NLS-1$
			jbBcc.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jbBcc.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbBcc_actionPerformed(e);
				}
			});
			jbBcc.setPreferredSize(new java.awt.Dimension(80,20));
		}
		return jbBcc;
	}

	void jbBcc_actionPerformed(java.awt.event.ActionEvent e) {
		AddressesFrame af = new AddressesFrame();
		af.setParent(this, Address.ADDR_BCC);
		af.setVisible(true);
		af.listAddresses();						
	}	
	
	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */    
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setPreferredSize(new java.awt.Dimension(425,30));
			jScrollPane1.setViewportView(getJepAtt());
		}
		return jScrollPane1;
	}	
	
	/**
	 * This method initializes jepAtt
	 * 
	 * @return javax.swing.JEditorPane
	 */    
	private JEditorPane getJepAtt() {
		if (jepAtt == null) {
			jepAtt = new JEditorPane();
			jepAtt.setContentType("text/html");
			jepAtt.setEditable(false);
			jepAtt.addHyperlinkListener(new HyperlinkListener() {				
				public void hyperlinkUpdate(HyperlinkEvent hyperlinkEvent) {
					if(hyperlinkEvent.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
						curAttPort = hyperlinkEvent.getURL().getPort();
						getJPopupMenu1().show(jepAtt, curAttXPos, curAttYPos);
					}
				}
			});												
			jepAtt.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() { 
				public void mouseMoved(java.awt.event.MouseEvent e) {
					curAttXPos = e.getX();
					curAttYPos = e.getY();
				}
			});
			TextPopup.registerComponent(jepAtt);
		}
		return jepAtt;
	}
		
	public void addAddress(String addr, int addrType) {
		String str = null;
		switch (addrType) {
		case Address.ADDR_TO:
			str = toField.getText();
			break;
		case Address.ADDR_CC:
			str = ccField.getText();
			break;
		case Address.ADDR_BCC:
			str = bccField.getText();
			break;
		default:
			return;
		}
		
		if(str != null) {
			str = str.trim();
			int len = str.length();			
			if(len > 0) {
				char last = str.charAt(len - 1);
				if(last == ',' || last == ';')
					str += " " + addr;
				else
					str += ", " + addr;
			} else
				str = addr;
		} else
			str = addr;
		
		switch (addrType) {
		case Address.ADDR_TO:
			toField.setText(str);
			break;
		case Address.ADDR_CC:
			ccField.setText(str);
			break;
		case Address.ADDR_BCC:
			bccField.setText(str);
			break;
		}
		
		if (composeFrame != null)
			composeFrame.setSigHeader();
	}
							
	/**
	 * This method initializes jPopupMenu1
	 * 
	 * @return javax.swing.JPopupMenu
	 */    
	private JPopupMenu getJPopupMenu1() {
		if (jPopupMenu1 == null) {
			jPopupMenu1 = new JPopupMenu();
			jPopupMenu1.add(getJmiDelete());
		}
		return jPopupMenu1;
	}
		
	/**
	 * This method initializes jmiDelete
	 * 
	 * @return javax.swing.JMenuItem
	 */    
	private JMenuItem getJmiDelete() {
		if (jmiDelete == null) {
			jmiDelete = new JMenuItem();
			jmiDelete.setText(Strings.getString("deleteMenuItem")); //$NON-NLS-1$
			jmiDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiDelete_actionPerformed(curAttPort);
				}
			});
		}
		return jmiDelete;
	}		
	
	void jmiDelete_actionPerformed(int attPort) {
		File file = ((CacheFile)cacheFiles.get(attPort)).getFile();
		cacheFiles.remove(attPort);
		validateAtts();
		file.delete();				
		if(cacheFiles.size() == 0) {
			Dimension dim = this.getPreferredSize();
			dim.height = HEIGHT_NORMAL;
			this.setPreferredSize(dim);
			updateUI();
		}		
	}
	
	private void validateAtts() {
		sbAtt = new StringBuffer();
		for (int i = 0; i < cacheFiles.size(); i++) {
			sbAtt = getHyperLink(sbAtt, (CacheFile) cacheFiles.get(i), i);
		}
		jepAtt.setText(sbAtt.toString());
		jepAtt.setCaretPosition(0);
	}
		
	public String getAcntId() throws Exception {
		/*
		 * String acntEmail = (String) jcbAddrFrom.getSelectedItem(); return
		 * Context.storage.getAccountForEmail(acntEmail).id;
		 */
		Account acnt = (Account) jcbAddrFrom.getSelectedItem();
		if (acnt == null)
			return null;
		else
			return acnt.id;
	}

	private StringBuffer getHyperLink(StringBuffer sbAtt, CacheFile cacheFile,
			int attPort) {
		if (sbAtt.length() > 0)
			sbAtt.append(";   ");
		sbAtt.append("<a href=\"http://message.gui.olivamail:").append(attPort)
				.append("\">").append(cacheFile.getName()).append("</a>")
				.append(
						" ("
								+ ComUtils.getSizeString(cacheFile.getFile()
										.length()) + ")");
		return sbAtt;
	}
	
	public void addAttachment(CacheFile cacheFile) {
		if (sbAtt == null)
			sbAtt = new StringBuffer();
		if (cacheFiles == null)
			cacheFiles = new Vector(5);
		cacheFiles.add(cacheFile);
		int attPort = cacheFiles.indexOf(cacheFile);
		sbAtt = getHyperLink(sbAtt, cacheFile, attPort);
		jepAtt.setText(sbAtt.toString());
		jepAtt.setCaretPosition(0);
		if (cacheFiles.size() == 1) {
			Dimension dim = getPreferredSize();
			dim.height = HEIGHT_ATT;
			setPreferredSize(dim);
			updateUI();
		}
	}

	public void assignComposer(Composer composer) {
		this.composeFrame = composer;
	}
		
}
