/*
 * @(#)Context.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

//import java.awt.SystemTray;
//import java.awt.TrayIcon;
import javax.swing.JFrame;
import olivamail.core.common.ComUtils;
import olivamail.core.mail.*;
import olivamail.core.ssl.SSLUtils;
import java.awt.Component;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.Rectangle;
import java.io.*;
import java.util.*;
import java.lang.reflect.Constructor;
import javax.swing.ImageIcon;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;
import javax.swing.text.html.HTMLEditorKit;

public class Context {

	private Context() {
	}
	
	public static boolean DEBUG = false;	
	
	public static MainFrame mainFrame = null;
	
	private static boolean showMessageInline = false;
	
	public static String homeDir = null;

	public static final String xMailer = "OlivaMail/GUI 2.1.0";

	public static final String myPackagePath = "/olivamail/gui/";	
	
	public static final String myName = "OlivaMail/GUI";
	
	private static final String def_storage_class_name = "olivamail.gui.HSQLDBStorage"; 

	private static final String def_db_url = "jdbc:hsqldb:file:$db_dir/mailbox";

	private static final String def_db_user = "sa";

	private static final String def_db_pass = "";

	private static final String def_db_schema = "public";

	private static final String def_db_subdir = "data";
	
	private static String storage_class_name = null;

	private static ITrayNotify trayNotify = null;
	
	public static boolean workOffline = false;
	
	private static String db_url = null;

	private static String db_user = null;

	private static String db_pass = null;

	private static String db_schema = null;

	private static Hashtable iconCache = new Hashtable(); 
	
	private static final String imgPattern = "<\\s*[iI][mM][gG]\\s+";

	public static final String[] countries = { "EN", "RU", "US" };

	public static String[] ctntPanes = { "olivamail.gui.DefaultContentPane",
			"olivamail.gui.JDICContentPane" };

	public static String contentPane = "olivamail.gui.DefaultContentPane";

	public static final String sizeUnits[] = {"Bytes", "Kb", "Mb"};
	
	public static boolean hidePictures = true;

	public static MailBean mailBean = null;

	public static Storage storage = null;

	public static String cache_dir;

	public static String log_dir;
	
	public static int _db_message_max_size = -1; //425984
	
	public static String msgs_dir = null;

	public static final String log_filename = "olivamail.log";

	public static final long log_file_limit = 2097152L;

	private static Font menuFont = null;
	
	public static String cache_link;

	public static String defaultCodepage = "utf-8";

	public static String sendCodepage = "utf-8";

	public static int avgRxSpeed = -1;

	public static int avgTxSpeed = -1;

	public static final int timerLim = 3;

	private static Properties settings = new Properties();

	private static String FileDlgOpenPath = null;

	private static String FileDlgSavePath = null;

	private static String inboxFolderId = null;

	private static String outboxFolderId = null;

	private static String draftFolderId = null;

	private static String sentFolderId = null;

	private static String trashFolderId = null;

	private static Vector programs = null;

	public static String clientAbout = "<html><body><p align=\"center\"><strong><font face=\"Arial, Verdana, Tahoma\" size=\"+2\" color=\"#000099\">OlivaMail Email Client</font></strong><br><strong>Author:</strong> Sergey Bredikhin<br><strong>OlivaMail/GUI ver:</strong> $guiver<br><strong>OlivaMail/Core ver:</strong> $corever<br><strong>JavaMail ver:</strong> $javamailver<br><strong>Database:</strong> $dbname<br><strong>Database ver:</strong> $dbver<br><strong>JDBC driver:</strong> $jdbcname<br><strong>JDBC driver ver:</strong> $jdbcver<br><a href=\"http://olivamail.sourceforge.net\">http://olivamail.sourceforge.net</a><br>&copy; 2008</p></body></html>";

	private static Object[] folders = null;

	public static String country = "US";

	public static String language = "en";
	
	public static String lookAndFeelClass = null;
	
	private static ContentSearchEngine cse = null;
	
	public static Hashtable pwdCache = new Hashtable();
		
	public static String htmlMetaCharset = null;
        
	private static MP3 mp3 = null;	
	
	public static Object[] getFolders() {
		return folders;
	}

	/*
	 * public void writeFile(InputStream is, File file) throws Exception {
	 * FileOutputStream fos = new FileOutputStream(file); BufferedOutputStream
	 * bos = new BufferedOutputStream(fos, 16 * 1024); // FileChannel fc =
	 * fos.getChannel(); WritableByteChannel wbc = Channels.newChannel(bos);
	 * BufferedInputStream bis = new BufferedInputStream(is, 16 * 1024);
	 * ReadableByteChannel rbc = Channels.newChannel(bis); ByteBuffer buffer =
	 * ByteBuffer.allocate(16 * 1024); while (true) { buffer.clear(); int r =
	 * rbc.read(buffer); if (r == -1) { break; } buffer.flip();
	 * wbc.write(buffer); } wbc.close(); }
	 */

	public static void loadFolders() throws Exception {
		folders = storage.getFolderList().toArray();
	}

	public static String getSettingsValue(String name) throws Exception {
		if (name.equals("receive_periodically")) {
			return String.valueOf(olivamail.core.common.ComUtils.parseBoolean(Context.storage
					.getSettingsValue("receive_periodically"), false));
		}
		if (name.equals("receive_period")) {
			String period = Context.storage.getSettingsValue("receive_period");
			if (period == null)
				period = "30";
			return period;
		}
		return null;
	}

	public static String getExtension(String fileName) {
		if (fileName == null)
			return null;
		int idx = fileName.lastIndexOf('.');
		if (idx == -1)
			return null;
		return fileName.substring(idx);
	}

	public static String getProgram(String ext) throws Exception {
		// if(programs == null)
		loadPrograms();
		String mimeTypeName = olivamail.core.mail.MailUtils.getMimeType(ext);
		if(mimeTypeName == null)
			return null;
		//System.out.println(mimeTypeName);

		for (Enumeration en = programs.elements(); en.hasMoreElements();) {
			Vector mimeType = (Vector) en.nextElement();
			MimeType mtype = new MimeType();
			mtype.id = (String) mimeType.elementAt(0);
			mtype.mimeType = (String) mimeType.elementAt(1);
			mtype.program = (String) mimeType.elementAt(2);
			mtype.mgrpId = (String) mimeType.elementAt(3);
			if (mimeTypeName.startsWith(ComUtils.nvl(mtype.mimeType))) {
				return mtype.program;
			}
		}
		return null;
	}

	/*
	 * public static String getProgram(String ext) { String iexplore =
	 * "C:\\Program Files\\Internet Explorer\\iexplore.exe"; String shimgvw =
	 * "C:\\WINDOWS\\system32\\rundll32.exe
	 * C:\\WINDOWS\\system32\\shimgvw.dll,ImageView_Fullscreen"; String winword =
	 * "C:\\Program Files\\Microsoft Office\\Office10\\WINWORD.EXE"; String
	 * mimeType = olivamail.core.mail.MailUtils.getMimeType(ext);
	 * if(mimeType.startsWith("image/")) return shimgvw;
	 * if(mimeType.startsWith("application/msword")) return winword; return
	 * iexplore; }
	 */

	public static OutputStream getFileOutputStream(File file) throws Exception {
		FileOutputStream fos = new FileOutputStream(file);
		BufferedOutputStream bos = new BufferedOutputStream(fos);
		return bos;
	}
	
	public static void closeOutputStream(OutputStream os) throws Exception {
		os.flush();
		os.close();
	}
		
	public static void toDo() {
		;
	}

	public static String getInboxFolder() {
		if (inboxFolderId == null) {
			try {
				inboxFolderId = Context.storage.getInboxFolder();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		return inboxFolderId;
	}
	
	public static String getOutboxFolder() {
		if (outboxFolderId == null) {
			try {
				outboxFolderId = Context.storage.getOutboxFolder();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		return outboxFolderId;
	}

	public static String getDraftFolder() {
		if (draftFolderId == null) {
			try {
				draftFolderId = Context.storage.getDraftFolder();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		return draftFolderId;
	}

	public static String getSentFolder() {
		if (sentFolderId == null) {
			try {
				sentFolderId = Context.storage.getSentFolder();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		return sentFolderId;
	}

	public static String getTrashFolder() {
		if (trashFolderId == null) {
			try {
				trashFolderId = Context.storage.getTrashFolder();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		return trashFolderId;
	}
/*
	public static Object[] getCodepages() {
		return cpsArray;
	}

	public static Object[] getCpNames() {
		return cpNamesArray;
	}
*/
	
	private static MailBean getNewMailBean() {
		MailBean mailBean = new MailBean();		
		if(defaultCodepage != null)		
			mailBean.setDefaultCodePage(defaultCodepage);
		if(sendCodepage != null)				
			mailBean.setSendCodePage(sendCodepage);
		mailBean.setAutoFolder(false);
		mailBean.setPageSize(3);
		mailBean.setRichContent(true);
		mailBean.setUsePOP3UID(true);
		mailBean.setXMailer(Context.xMailer);
		return mailBean;
	}
	
	public static void loadSettings() throws Exception {
		debugStr("MessageTableModel.initRenderers()...");
		MessageTableModel.initRenderers();
		
		debugStr("Loading language settings...");		
		
		ResourceBundle bundle = ResourceBundle.getBundle("settings",
				java.util.Locale.US);
		for (java.util.Enumeration e = bundle.getKeys(); e.hasMoreElements();) {
			String key = (String) e.nextElement();
			String value = olivamail.core.common.ComUtils.getStringInternals(bundle
					.getString(key), "utf-8");
			settings.setProperty(key, value);
		}
		
		defaultCodepage = settings.getProperty("olivamail.gui.defaultCodepage");
		sendCodepage = settings.getProperty("olivamail.gui.sendCodepage");		
				
		String country1 = ComUtils.nvl(settings.getProperty("olivamail.gui.country"));
		String language1 = ComUtils.nvl(settings.getProperty("olivamail.gui.language"));		
		
		if(language1.equals("") || country1.equals("")) {
			InternatFrame internatFrame = new InternatFrame();
			internatFrame.center();
			internatFrame.setModal(true);			
			internatFrame.setVisible(true);
		} else {
			country = country1;
			language = language1; 
		}		
		
		Strings.setLanguage(language);
		HelpStrings.setLanguage(language);
		
		String fileEnc = System.getProperty("file.encoding");
		if(!ComUtils.nvl(fileEnc).equals("")) {
			String mapEnc = (String)Charsets.htJavaToMime.get(fileEnc);
			if(mapEnc != null)
				fileEnc = mapEnc;
			htmlMetaCharset = fileEnc;
		}
		
		debugStr("Loading classpath elements...");				
		
		String myClasspath = settings.getProperty("olivamail.gui.classpath");
		if (myClasspath != null) {
			StringTokenizer st = new StringTokenizer(myClasspath, ":");
					//File.pathSeparator);
			while (st.hasMoreTokens()) {
				String cpElement = st.nextToken();
				//if (cpElement.indexOf(File.separatorChar) == -1)
				cpElement = Context.homeDir + "lib/" + cpElement;
				System.out.println("classpath element: " + cpElement);
				ClassPathHacker.addFile(cpElement);
			}
		}

		debugStr("Instantiating tray notify class...");
		
		String trayNotifyClassName = settings
				.getProperty("olivamail.gui.tray_notify_class");
		if (trayNotifyClassName != null) {
			Class trayNotifyClass = Class.forName(trayNotifyClassName);
			Constructor ct = trayNotifyClass.getConstructor(null);
			trayNotify = (ITrayNotify) ct.newInstance(null);
		}
				
		debugStr("Loading storage parameters...");		
		
		storage_class_name = settings.getProperty("olivamail.gui.storage_class_name");
		db_url = settings.getProperty("olivamail.gui.db_url");
		db_user = settings.getProperty("olivamail.gui.db_user");
		db_pass = settings.getProperty("olivamail.gui.db_pass");
		db_schema = settings.getProperty("olivamail.gui.db_schema");		
		
		if(storage_class_name == null) {
			storage_class_name = def_storage_class_name;			
		}
		if(storage_class_name.equals(def_storage_class_name)) {
			if (db_url == null) {
				String db_dir = homeDir + def_db_subdir;
				File file = new File(db_dir);
				if (!file.exists())
					file.mkdir();
				db_url = def_db_url.replaceAll("\\$db_dir", db_dir);				
			}
			if(db_user == null)
				db_user = def_db_user;	
			if(db_pass == null)
				db_pass = def_db_pass;	
			if(db_schema == null)
				db_schema = def_db_schema;					
		}		
		Class storageClass = Class.forName(storage_class_name);
		Constructor ct = storageClass.getConstructor(null);
		storage = (olivamail.gui.Storage) ct.newInstance(null);
		storage.setDatabaseUrl(db_url);
		storage.setSchema(db_schema);
		try {
			debugStr("Before connect to srorage...");			
			storage.logon(db_user, db_pass);
			debugStr("After connect to srorage...");			
		} catch (Exception exc) {
			exc.printStackTrace();
			if(exc.toString().toLowerCase().indexOf("the database is already in use") != -1)
				AlertDialog.showErrorDialog(Strings.getString("Context.alreadyRunning"), exc);
			else
				AlertDialog.showErrorDialog(exc);			
			System.exit(1);
		}
		
		//storage.setSettingsValue("schema_version", "2.0.0");
		
		mailBean = getNewMailBean();
		
		msgs_dir = homeDir + "msgs/";
		cache_dir = homeDir + "cache/";
		cache_link = "file://" + homeDir + "cache/";
		log_dir = homeDir + "log/";
		
		File file = new File(msgs_dir);
		if (!file.exists())
			file.mkdir();		
		Context.storage.setMsgsDir(msgs_dir);				
				
		debugStr("Checking schema version...");
		try {		
			int schemaVer = storage.getSchemaVersion(); 
			if(schemaVer != Storage.getReleaseVersion()) {				
				if(AlertDialog.showConfirmDialog(Strings.getString("Context.schemaInvalid"), AlertDialog.YES_NO_OPTION) == AlertDialog.YES_OPTION) {
					debugStr("Before populating schema...");					
					storage.populateSchema(schemaVer);
					debugStr("After populating schema...");					
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}										

		debugStr("Checking directories...");		
				
		file = new File(cache_dir);		
		if(!file.exists()) 
			file.mkdir();

		file = new File(log_dir);		
		if(!file.exists()) 
			file.mkdir();
				
		clearCache("msg");
		
		debugStr("Before loading folders...");		
		loadFolders();
		debugStr("After loading folders...");		
		
		String maxDbMsgSize = Context.storage.getSettingsValue("db_message_max_size");
		if(!ComUtils.nvl(maxDbMsgSize).equals("")) {
			_db_message_max_size = Integer.parseInt(maxDbMsgSize);
		}		
		Context.storage.setDbMessageMaxSize(_db_message_max_size);
		
		workOffline = olivamail.core.common.ComUtils.parseBoolean(Context.storage
				.getSettingsValue("work_offline"), workOffline);		
		
		String ctntPane = Context.storage.getSettingsValue("content_pane"); 
		if(ctntPane != null)
			contentPane = ctntPane;
		hidePictures = olivamail.core.common.ComUtils.parseBoolean(Context.storage
				.getSettingsValue("hide_pictures"), hidePictures);
		showMessageInline = olivamail.core.common.ComUtils.parseBoolean(Context.storage
				.getSettingsValue("show_message_inline"), showMessageInline);		
	
		lookAndFeelClass = settings.getProperty("olivamail.gui.LookAndFeelClass");
/*		
		if(lookAndFeelClass == null) {
			lookAndFeelClass = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		}
*/		
/*
		System.setProperty("http.proxySet","true");
		System.setProperty("http.proxyHost", "proxy.your.domain");
		System.setProperty("http.proxyPort", "8080");
		java.net.Authenticator.setDefault(new java.net.Authenticator() {
			protected java.net.PasswordAuthentication getPasswordAuthentication() {  
				return new java.net.PasswordAuthentication("username","password".toCharArray()); 
			} 			
		});
*/			
	}

/*	
	public static void useDefaultAccount() throws Exception {
		acnt = storage.getDefaultAccount();
		useLastAccount();
	}

	public static void useAccount(String id) throws Exception {
		acnt = storage.getAccount(id);
		useLastAccount();
	}
*/	
	
	public static MailBean getMailBean(Account acnt) {
		if (acnt == null)
			return null;
		MailBean mailBean = getNewMailBean();
		mailBean.setHost(acnt.serverType, acnt.incomingServer, acnt.inPort);
		mailBean.setFolderName("INBOX");
		mailBean.setCredentials(acnt.inUser, acnt.inPass);
		mailBean.setSmtpHost(acnt.outgoingServer, acnt.outPort);
		if (acnt.smtpAuth.compareTo("1") == 0)
			mailBean.setSmtpAuth(true);
		else
			mailBean.setSmtpAuth(false);
		if (ComUtils.nvl(acnt.outUser).length() == 0)
			mailBean.setSmtpCredentials(acnt.inUser, acnt.inPass);
		else
			mailBean.setSmtpCredentials(acnt.outUser, acnt.outPass);
		mailBean.setSenderAddress(acnt.email);
		return mailBean;
	}	
	
	public static void clearCache(final String pattern) throws Exception {
		if (pattern == null)
			return;
		if (pattern.length() == 0)
			return;
		if (cache_dir == null)
			cache_dir = "";
		if (cache_dir.length() == 0)
			return;
		File file = new File(cache_dir);
		if (!file.isDirectory())
			return;
		File list[] = file.listFiles(new FileFilter() {
			public boolean accept(File pathname) {
				String fileName = pathname.getName();
				if (fileName == null)
					return false;
				if (fileName.startsWith(pattern))
					return true;
				return false;
			}
		});
		for (int i = 0; i < list.length; i++) {
			list[i].delete();
		}
	}

	public static void loadPrograms() throws Exception {
		olivamail.gui.MimeGroup mgrp = storage.getDefaultMimeGroup();
		programs = storage.getMimeTypeList(mgrp.id, null, "MIME_TYPE DESC", -1);
	}

/*	
	public static int getMessageSize(javax.mail.Message message) throws Exception {
		int size = -1;
		if (message instanceof javax.mail.internet.MimeMessage) {
			InputStream is = message.getDataHandler().getInputStream();
			size = getStreamLength(is);
		} else {
			size = message.getSize();
		}		
		return size;
	}
	
	public static int getStreamLength(InputStream is) throws Exception {
		ReadableByteChannel rbc = Channels.newChannel(is);
		ByteBuffer buffer = ByteBuffer.allocate(512);		
		int count = 0;
		while (true) {
			buffer.clear();
			int r = rbc.read(buffer);
			if (r == -1) {
				break;
			}
			System.out.write(buffer.array());
			System.out.flush();
			count += r;
			buffer.flip();
		}
		return count;
	}
*/	
	
	public static String checkField(JTextComponent jtc) {
		String str = jtc.getText().trim();
		jtc.setText(str);
		if (str.equals("")) {
			AlertDialog.showErrorDialog(Strings.getString("enterRequired"));
			jtc.requestFocus();
			return null;
		}
		return str;
	}
	
	public static String trimField(JTextComponent jtc) {
		String str = jtc.getText().trim();
		jtc.setText(str);
		return str;
	}	
	
	public static String[] getLanguageFiles() {		
		File confDir = new File(homeDir + "conf/");
		FilenameFilter ff = new FilenameFilter() {
			public boolean accept(File dir, String name) {
				if(name.matches("strings_\\w\\w.properties"))
					return true;
				return false;
			}			
		};
		return confDir.list(ff);
	}
	
	public static File getSettingsFile() {
		return new File(homeDir + "conf/settings.properties");		
	}

	/*
	 * http://www.javaworld.com/javaworld/javatips/jw-javatip109.html Java Tip
	 * 109: Display images using JEditorPane Modify the JEditorPane component to
	 * display images By Rob Kenworthy JavaWorld.com, 03/16/01
	 */
	public static void insertHTML(JEditorPane editor, String html, int location)
			throws Exception {
		//assumes editor is already set to "text/html" type
		HTMLEditorKit kit = (HTMLEditorKit) editor.getEditorKit();
		Document doc = editor.getDocument();
		StringReader reader = new StringReader(html);
		kit.read(reader, doc, location);
	}
	
	public static boolean hasPics(String html) {
		return true;		 
	}	
		
	public static String getHtmlNoPics(String html) {
		return html.replaceAll(imgPattern, "<x-img ");
	}

	public static Font getMenuFont() {
		if(menuFont == null) {
			menuFont = new java.awt.Font("Dialog", java.awt.Font.BOLD, 12);
			menuFont = menuFont.deriveFont(menuFont.getSize2D() + 2);
		}
		return menuFont;
	}

	public static void setMenuFont(Font menuFont) {
		if(menuFont == null)
			menuFont = new java.awt.Font("Dialog", java.awt.Font.BOLD, 12);
		Context.menuFont = menuFont.deriveFont(menuFont.getSize2D() + 2);
	}	
	
	public static File fileSaveDialog(Component parent, String fileName) {		
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileSave"));
		if (Context.FileDlgSavePath == null)
			Context.FileDlgSavePath = "";
		
		fileName = ComUtils.nvl(fileName);
				
		jFileChooser1.setSelectedFile(new File(Context.FileDlgSavePath + fileName));
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showSaveDialog(parent))
			return null;
		File file = jFileChooser1.getSelectedFile();

		if (file != null && file.exists()) {
			switch (AlertDialog
					.showConfirmDialog(Strings.getString("fileOverwrite"),
							AlertDialog.YES_NO_CANCEL_OPTION)) {
			case AlertDialog.YES_OPTION:
				break;
			case AlertDialog.NO_OPTION:
				file = fileSaveDialog(parent, file.getPath());
				break;
			case AlertDialog.CANCEL_OPTION:
				file = null;
				break;
			}
		}		
		
		if (file != null)
			Context.FileDlgSavePath = file.getParent() + File.separator;
				
		return file;
	}
	
	public static File fileOpenDialog(Component parent) {
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileOpen"));
		// jFileChooser1.setDialogType(JFileChooser.OPEN_DIALOG);		
		if (Context.FileDlgOpenPath == null)
			Context.FileDlgOpenPath = "";
		jFileChooser1.setSelectedFile(new File(ComUtils
				.nvl(Context.FileDlgOpenPath)));
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showOpenDialog(parent))
			return null;
		File file = jFileChooser1.getSelectedFile();
		if (file != null)
			Context.FileDlgOpenPath = file.getPath();
		return file;
	}	

	public static File[] multipleFileOpenDialog(Component parent) {
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileOpen"));
		// jFileChooser1.setDialogType(JFileChooser.OPEN_DIALOG);		
		if (Context.FileDlgOpenPath == null)
			Context.FileDlgOpenPath = "";
		jFileChooser1.setSelectedFile(new File(ComUtils
				.nvl(Context.FileDlgOpenPath)));
		jFileChooser1.setMultiSelectionEnabled(true);
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showOpenDialog(parent))
			return null;
		File[] files = jFileChooser1.getSelectedFiles();
		if (files != null)
			Context.FileDlgOpenPath = files[0].getPath();
		return files;
	}	
	
	public static File dirOpenDialog(Component parent) {
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileOpen"));
		jFileChooser1.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);		
		if (Context.FileDlgOpenPath == null)
			Context.FileDlgOpenPath = "";
		jFileChooser1.setSelectedFile(new File(ComUtils
				.nvl(Context.FileDlgOpenPath)));
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showOpenDialog(parent))
			return null;
		File file = jFileChooser1.getSelectedFile();
		if (file != null)
			Context.FileDlgOpenPath = file.getPath();
		return file;
	}	
	
	public static synchronized Properties setSSL(Account acnt, boolean incoming) {
		String serverType = null;
		int port = -1;
		boolean isSSL = false;
		if(incoming) {
			serverType = acnt.serverType.toLowerCase();
			port = acnt.inPort;
			isSSL = acnt.inSSL.equals("1");
		} else {
			serverType = "smtp";
			port = acnt.outPort;
			isSSL = acnt.outSSL.equals("1");
		}
		return SSLUtils.setSSL(serverType, port, isSSL);
	}
		
	public static ContentSearchEngine getContentSearchEngine() {
		if(cse == null)
			cse = new LuceneSearchEngine();
		return cse;
	}

	public static void storePwdInCache(Account acnt) {
		pwdCache.put(acnt.id, acnt);
	}

	public static void restorePwdFromCache(Account acnt) {
		Account pwdAcnt = (Account)pwdCache.get(acnt.id);
		if(pwdAcnt != null) {
			acnt.inUser = pwdAcnt.inUser;
			acnt.inPass = pwdAcnt.inPass;
			acnt.outUser = pwdAcnt.outUser;
			acnt.outPass = pwdAcnt.outPass;			
		}
	}
	
	public static Point getWindowPosition(String winId) {
		Point pt = null;
		try {
			String spos = null;			
			spos = Context.storage.getSettingsValue("winpos."
					+ winId.toLowerCase());
			int x = 100;
			int y = 100;
			if (spos != null) {
				int idx = spos.indexOf(',');
				x = Integer.parseInt(spos.substring(0, idx));
				y = Integer.parseInt(spos.substring(idx + 1, spos.length()));
				GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
				Rectangle bounds = ge.getMaximumWindowBounds();			
				Point center = ge.getCenterPoint();
				if(x > bounds.width)
					x = center.x;
				if(y > bounds.height)
					y = center.y;							
			}
			pt = new Point(x, y);
		} catch (Exception exc) {
			exc.printStackTrace();
		}		
		return pt;
	}
	
	public static void setWindowPosition(String winId, Point position) {
		try {
			Context.storage.setSettingsValue("winpos." + winId.toLowerCase(),
					position.x + "," + position.y);
		} catch (Exception exc) {
			exc.printStackTrace();
		}				
	}

	public static boolean isShowMessageInline() {
		return showMessageInline;
	}

	public static void setShowMessageInline(boolean showMessageInline) {
		Context.showMessageInline = showMessageInline;
		mainFrame.updateShowMessageInline();
	}
	
/*	
        public static void initTray() {
            if(!SystemTray.isSupported()) {
                //System.out.println("System tray is not supported");
                return;
            }
            try {
                if(systemTray == null)
                    systemTray = SystemTray.getSystemTray();
                if(myTrayIcon == null) {
                    trayImgNormal = Toolkit.getDefaultToolkit().getImage(Context.class.getResource(myPackagePath + "at.gif"));
                    trayImgNewMsg = Toolkit.getDefaultToolkit().getImage(Context.class.getResource(myPackagePath + "at_anim.gif"));
                    myTrayIcon = new TrayIcon(trayImgNormal);
                    systemTray.add(myTrayIcon);                    
                    myTrayIcon.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            //System.out.println(e.toString());
                            Context.unsetTrayNewMsg();
                            if((Context.mainFrame.getExtendedState() & JFrame.ICONIFIED) == JFrame.ICONIFIED)
                                deiconify(Context.mainFrame);
                            else {
                                Context.mainFrame.setAlwaysOnTop(true);
                                Context.mainFrame.setAlwaysOnTop(false);
                            }
                        }
                    });
                }                
            } catch (Exception exc) {
                exc.printStackTrace();
            }
        }
*/                        

    public static void deiconify(JFrame frame) {
        int state = frame.getExtendedState();
        state &= ~JFrame.ICONIFIED;
        frame.setExtendedState(state);
    }
 
    public static void iconify(JFrame frame) {
        int state = frame.getExtendedState();
        state |= JFrame.ICONIFIED;
        frame.setExtendedState(state);
    }        
    
	public static void setWorkOffline(boolean offline) throws Exception {
		workOffline = offline;
		storage.setSettingsValue("work_offline", String.valueOf(offline));
		mainFrame.refreshWorkOffline();
		if (!workOffline)
			IMAPContext.applyAllAcntDMChanges();
	}    

	public static boolean isConnectionProblem(Exception exc) {
		boolean connProblem = false;
		if (exc instanceof javax.mail.AuthenticationFailedException) {
			if (exc.toString().toLowerCase().indexOf("eof on socket") != -1)
				connProblem = true;
		}
		if (exc instanceof javax.mail.MessagingException) {
			if (exc.toString().toLowerCase().indexOf("connect failed") != -1)
				connProblem = true;
			Throwable t = exc.getCause();
/* 2008-12-01			
			if (t != null && t instanceof java.net.UnknownHostException) {
				connProblem = true;
			}
*/
			if (t != null
					&& (t instanceof java.net.UnknownHostException || t instanceof java.io.IOException)) {
				connProblem = true;
			}			
		}
		return connProblem;
	}
	
/*	
	public static boolean gonnaWorkOffline(Exception e) {
		if (!isConnectionProblem(e))
			return false;
		if (AlertDialog.showMessageDialog(null, Strings
				.getString("MessageRow.goOffline"), e, AlertDialog.ERROR_ALERT,
				AlertDialog.YES_NO_OPTION, null) != AlertDialog.YES_OPTION)
			return false;
		try {
			setWorkOffline(true);
			return true;
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
		return false;
	}
*/	    

	public static boolean gonnaWorkOffline(Exception e, Account acnt) {
		if (!isConnectionProblem(e))
			return false;
		if (AlertDialog.showMessageDialog(null, Strings
				.getString("MessageRow.goOffline"), e, AlertDialog.ERROR_ALERT,
				AlertDialog.YES_NO_OPTION, null) != AlertDialog.YES_OPTION)
			return false;
		try {
			acnt.dmStat = Account.DM_NOSYNC;
			Context.storage.saveAccount(acnt, false);
			return true;
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
		return false;
	}    
		
	public static synchronized ImageIcon getImageIcon(String name) {
		Object iconObject = iconCache.get(name);
		ImageIcon icon = null;
		if (iconObject == null)
			try {
				icon = new ImageIcon(Context.class
						.getResource(Context.myPackagePath + name));
				iconCache.put(name, icon);
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		else
			icon = (ImageIcon) iconObject;
		return icon;
	}

	public static void debugStr(String str) {
		if (Context.DEBUG) {
			System.out.println("DEBUG: " + str);
			System.out.flush();
		}
	}

	public static void initTray() {
		if(trayNotify != null)
			trayNotify.initTray();
	}

	public static void unsetTrayNewMsg() {
		if(trayNotify != null)
			trayNotify.unsetTrayNewMsg();		
	}

	public static void setTrayNewMsg(ReceivingResult result) {
		if (trayNotify != null)
			trayNotify.setTrayNewMsg(result);
	}
		
	public static void playNewMsgSound() {
		if (mp3 == null) {
			mp3 = new MP3("./sound/newmsg.mp3");
		}
		if (!mp3.isRunning())
			mp3.play();		
	}
	
	public static void stopNewMsgSound() {
		if (mp3 != null && mp3.isRunning())
			mp3.close();
	}

	public static String getTrayNewMsgTxt(ReceivingResult result) {
		return Strings.getString("Context.trayNewMsg") + ": " + result.getNew();
	}

	private static ContentPane getCurCtntPaneObject() throws Exception {
		Class ccpClass = Class.forName(contentPane);
		Constructor ct = ccpClass.getConstructor(null);
		return (ContentPane) ct.newInstance(null);
	}

	public static boolean contentPaneNeedAwt() {
		boolean needAwt = false;
		try {
			needAwt = Context.getCurCtntPaneObject().needAwt();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return needAwt;
	}
	
}
