/*
 * @(#)DefaultContentPane.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.Component;
import java.awt.Dimension;
import javax.swing.JEditorPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

public class DefaultContentPane implements ContentPane {

	private JEditorPane jEditorPane1 = null;
		
	public DefaultContentPane() {	
	}
				
	/**
	 * This method initializes jEditorPane1
	 * 
	 * @return javax.swing.JEditorPane
	 */
	private JEditorPane getJEditorPane1() {
		if (jEditorPane1 == null) {
			jEditorPane1 = new JEditorPane();
			jEditorPane1.setContentType("text/html");
			jEditorPane1.setFont(new java.awt.Font("Default", java.awt.Font.PLAIN, 14));
			jEditorPane1.setEditable(false);
//			final JFrame parent = this;
			jEditorPane1.addHyperlinkListener(new HyperlinkListener() {
				public void hyperlinkUpdate(HyperlinkEvent hyperlinkEvent) {
					// processHyperlinkEvent (hyperlinkEvent );
					if(hyperlinkEvent.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
						Ocm ocm = new Ocm();
						try {
							String program = Context.getProgram("htm");
							if(program == null) {
								AlertDialog.showInfoDialog(Strings.getString("MessageFrame.noProgram"));					
								return;
							}							
							ocm.run(program.replaceAll("%1", hyperlinkEvent.getURL().toString()), System.out, false);
						} catch (Exception exc) {
							exc.printStackTrace();
							AlertDialog.showErrorDialog(exc);
						}						
/*						
						try {
							jEditorPane1.setPage(hyperlinkEvent.getURL());
						} catch (Exception exc) {
							exc.printStackTrace();
							AlertDialog.showErrorDialog(exc);
						} 
*/						
					}
				}
			});
			TextPopup.registerComponent(jEditorPane1);
		}
		return jEditorPane1;
	}

	public Component getComponent() {
		return getJEditorPane1();
	}	

	public void setContentType(String contentType) {
		jEditorPane1.setContentType(contentType);
	}
	
	public void setText(String text) {
		jEditorPane1.setText(text);
	}

	public void setCaretPosition(int pos) {
		jEditorPane1.setCaretPosition(pos);
	}

	public String getContentType() {
		return jEditorPane1.getContentType();
	}

	public void setSize(Dimension size) {
	}
		
	public boolean needAwt() {
		return false;
	}

	public boolean needSwing() {
		return true;
	}	
		
}
