/*
 * @(#)FoldersFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;

public class FoldersFrame extends JFrame {

	static final long serialVersionUID = 5563670445731909307L;

	private final String WIN_ID = "folders";
	
	private JPanel jContentPane = null;

	private JScrollPane jScrollPane1 = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel3 = null;

	private JPanel jPanel4 = null;

	private JButton jButton1 = null;

	private JButton jButton2 = null;

	private JButton jButton3 = null;

	private JButton jButton4 = null;

	private JTable jTable1 = null;

	private MainFrame parent = null;

	/**
	 * This is the default constructor
	 */
	public FoldersFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(501, 303);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this
				.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("FoldersFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJPanel4(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
		}
		return jPanel3;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.add(getJButton1(), null);
			jPanel4.add(getJButton3(), null);
			jPanel4.add(getJButton4(), null);
			jPanel4.add(getJButton2(), null);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText(Strings.getString("newButton")); //$NON-NLS-1$
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButton1_actionPerformed(e);
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText(Strings.getString("closeButton")); //$NON-NLS-1$
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButton2_actionPerformed(e);
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText(Strings.getString("editButton")); //$NON-NLS-1$
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButton3_actionPerformed(e);
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jButton4
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText(Strings.getString("deleteButton")); //$NON-NLS-1$
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButton4_actionPerformed(e);
				}
			});
		}
		return jButton4;
	}

	/**
	 * This method initializes jTable1
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {
				static final long serialVersionUID = 1109159197208849333L;

				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {// What else
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}
					return c;
				}
			};
			jTable1.setFont(new java.awt.Font("Dialog", 0, 14)); //$NON-NLS-1$			
		}
		return jTable1;
	}

	public void listFolders() {
		Vector headers = new Vector(2);
		headers.add(Strings.getString("FoldersFrame.idField")); //$NON-NLS-1$
		headers.add(Strings.getString("FoldersFrame.nameField")); //$NON-NLS-1$
		Vector rows = null;
		try {
			rows = Context.storage.getFolderList();
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(0).setMaxWidth(50);
			tcm.getColumn(1).setMinWidth(150);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	void jButton3_actionPerformed(ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row == -1)
			return;
		FolderFormFrame fff = new FolderFormFrame();
		fff.setVisible(true);
/*		
		fff.setParent(this);
		fff.editFolder((String) jTable1.getValueAt(row, 0));
*/		
	}

	void jButton1_actionPerformed(ActionEvent e) {
		FolderFormFrame fff = new FolderFormFrame();
/*		
		fff.setParent(this);
*/		
		fff.setVisible(true);
	}

	void jButton4_actionPerformed(ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row != -1) {
			if(AlertDialog.showConfirmDialog(Strings.getString("FoldersFrame.deleteFolder"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION) //$NON-NLS-1$
				return;			
			try {
				String folderId = (String) jTable1
				.getValueAt(row, 0);
				if(!Context.storage.isFolderEmpty(folderId)) {
					if(AlertDialog.showConfirmDialog(Strings.getString("FoldersFrame.folderNotEmpty"), AlertDialog.YES_NO_OPTION) != AlertDialog.YES_OPTION) //$NON-NLS-1$
						return;
					Context.storage.deleteFolderContent(folderId);
				}
				Context.storage.deleteFolder(folderId);
				listFolders();
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
		}
	}

	public void setParent(MainFrame parent) {
		this.parent = parent;
	}

	void jButton2_actionPerformed(ActionEvent e) {
		try {
			Context.loadFolders();
			parent.updateTree();
			parent.selectInboxFolder();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
		this_windowClosing(null);
		dispose();
	}

} // @jve:decl-index=0:visual-constraint="10,10"
