/*
 * @(#)GroupsFrame.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import javax.swing.JSplitPane;

public class GroupsFrame extends JFrame implements ParentList {

	static final long serialVersionUID = -8792933795704595556L;
	private final String WIN_ID = "groups";
	private JPanel jContentPane = null;
	private JMenuBar jMenuBar1 = null;
	private JMenu jMenuFile = null;
	private JMenuItem jMenuItem = null;
	private JMenu jMenuContacts = null;
	private JMenuItem jMenuItemContCreate = null;
	private JMenuItem jMenuItemContEdit = null;
	private JMenuItem jMenuItemContDelete = null;
	private JScrollPane jScrollPane1 = null;
	private JScrollPane jScrollPane2 = null;
	private JTable jTable1 = null;
	private JTable jTable2 = null;
	private JButton jButtonRight = null;
	private JButton jButtonLeft = null;
	private JPanel jPanel2 = null;
	private JPanel jPanel3 = null;
	private JLabel jLabelName = null;
	private JTextField jTextFieldName = null;
	private JLabel jLabelComment = null;
	private JTextField jTextFieldComment = null;
	private JButton okButton = null;
	private JButton cancelButton = null;
	private JSplitPane jSplitPane1 = null;
	private ParentList parent = null;
	private String grpId = null;
	private JTable parentTable = null;
	private int parentRow = -1;
	
	/**
	 * This is the default constructor
	 */
	public GroupsFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(510, 422);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setJMenuBar(getJMenuBar1());
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("GroupsFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJSplitPane1(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private JMenuBar getJMenuBar1() {
		if (jMenuBar1 == null) {
			jMenuBar1 = new JMenuBar();
			jMenuBar1.add(getJMenu());
			jMenuBar1.add(getJMenu1());
		}
		return jMenuBar1;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText(Strings.getString("menuFile"));
			jMenuFile.add(getJMenuItem());
		}
		return jMenuFile;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem();
			jMenuItem.setText(Strings.getString("menuClose"));
			jMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return jMenuItem;
	}

	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu1() {
		if (jMenuContacts == null) {
			jMenuContacts = new JMenu();
			jMenuContacts.setText(Strings.getString("AddressesFrame.menuContacts"));
			jMenuContacts.add(getJMenuItem1());
			jMenuContacts.add(getJMenuItem2());
			jMenuContacts.add(getJMenuItem3());
		}
		return jMenuContacts;
	}

	/**
	 * This method initializes jMenuItem1	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem1() {
		if (jMenuItemContCreate == null) {
			jMenuItemContCreate = new JMenuItem();
			jMenuItemContCreate.setText(Strings.getString("menuCreate"));
			jMenuItemContCreate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContCreate_actionPerformed(e);
				}
			});
		}
		return jMenuItemContCreate;
	}

	void jMenuItemContCreate_actionPerformed(java.awt.event.ActionEvent e) {
		AddrFormFrame aff = new AddrFormFrame();
		aff.setParent(this);
		aff.setVisible(true);		
	}
	
	/**
	 * This method initializes jMenuItem2	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem2() {
		if (jMenuItemContEdit == null) {
			jMenuItemContEdit = new JMenuItem();
			jMenuItemContEdit.setText(Strings.getString("menuEdit"));
			jMenuItemContEdit.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContEdit_actionPerformed(e);
				}
			});
		}
		return jMenuItemContEdit;
	}

	void editCurrentRow() {
		JTable table = null;
		if(jTable1.isFocusOwner())
			table = jTable1;
		if(jTable2.isFocusOwner())
			table = jTable2;
		if(table == null)
			table = jTable2;
		int row = table.getSelectedRow();
		if (row == -1)
			return;
		AddrFormFrame aff = new AddrFormFrame();
		aff.setParent(this);
		aff.editAddress(table, row, (String) table.getValueAt(row, 0));
		aff.setVisible(true);					
	}
	
	void jMenuItemContEdit_actionPerformed(java.awt.event.ActionEvent e) {
		editCurrentRow();
	}
	
	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem3() {
		if (jMenuItemContDelete == null) {
			jMenuItemContDelete = new JMenuItem();
			jMenuItemContDelete.setText(Strings.getString("menuDelete"));
			jMenuItemContDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItemContDelete_actionPerformed(e);
				}
			});
		}
		return jMenuItemContDelete;
	}

	void jMenuItemContDelete_actionPerformed(java.awt.event.ActionEvent e) {
		int row = jTable2.getSelectedRow();
		if (row == -1)
			return;
		if (AlertDialog
				.showConfirmDialog(					
						Strings.getString("AddressesFrame.ctntDeleteConfirm"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION) //$NON-NLS-1$
			return;
		try {
			Context.storage.deleteAddress((String) jTable1.getValueAt(row, 0));
			((DefaultTableModel)jTable2.getModel()).removeRow(row);			
//			listAddresses2();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}
	
	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setPreferredSize(new java.awt.Dimension(230,250));
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jScrollPane2	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setPreferredSize(new java.awt.Dimension(230,250));
			jScrollPane2.setViewportView(getJTable2());
		}
		return jScrollPane2;
	}

	/**
	 * This method initializes jTable1	
	 * 	
	 * @return javax.swing.JTable	
	 */    
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {
				static final long serialVersionUID = 1508830867321229516L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}												
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {// What else
																// should i put
																// in here to
																// check the
																// value
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}
/*
					Font font0 = new java.awt.Font("Dialog", 1, 14); //$NON-NLS-1$
					Font font1 = new java.awt.Font("Dialog", 0, 14); //$NON-NLS-1$
					Font font = null;
					if (((String) this.getValueAt(rowIndex, 8)).compareTo("D") == 0) //$NON-NLS-1$
						font = font0;
					else
						font = font1;
					c.setFont(font);
*/					
					return c;
				}
			};
			//jTable1.setFont(new java.awt.Font("Dialog", 0, 14)); //$NON-NLS-1$
			jTable1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(e.getClickCount() == 2)
						editCurrentRow();
				}
			});						
		}
		return jTable1;
	}

	private void listAddresses1() {
		Vector headers = new Vector(12);
		headers.add(Strings.getString("AddressesFrame.idField")); //$NON-NLS-1$
//		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
		//headers.add(Strings.getString("AddressesFrame.mNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.emailField")); //$NON-NLS-1$
/*
		headers.add(Strings.getString("AddressesFrame.homeCountryField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeRegionField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeCityField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeIndexField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeStreetField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homePhoneField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.MobilePhoneField")); //$NON-NLS-1$
*/		
		Vector rows = null;
		try {
			rows = Context.storage.getAddressList1(null, null, -1, this.grpId, 0);
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(0).setMaxWidth(40);
			tcm.getColumn(1).setMinWidth(200);
			tcm.getColumn(2).setMinWidth(200);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}		
	
	/**
	 * This method initializes jTable2	
	 * 	
	 * @return javax.swing.JTable	
	 */    
	private JTable getJTable2() {
		if (jTable2 == null) {
			jTable2 = new JTable() {
				static final long serialVersionUID = 1508830867321229516L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}												
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {// What else
																// should i put
																// in here to
																// check the
																// value
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}
/*
					Font font0 = new java.awt.Font("Dialog", 1, 14); //$NON-NLS-1$
					Font font1 = new java.awt.Font("Dialog", 0, 14); //$NON-NLS-1$
					Font font = null;
					if (((String) this.getValueAt(rowIndex, 8)).compareTo("D") == 0) //$NON-NLS-1$
						font = font0;
					else
						font = font1;
					c.setFont(font);
*/					
					return c;
				}
			};
			//jTable2.setFont(new java.awt.Font("Dialog", 0, 14)); //$NON-NLS-1$
			jTable2.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(e.getClickCount() == 2)
						editCurrentRow();
				}
			});						
		}
		return jTable2;
	}

	private void listAddresses2() {
		Vector headers = new Vector(12);
		headers.add(Strings.getString("AddressesFrame.idField")); //$NON-NLS-1$
//		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.fNameField")); //$NON-NLS-1$
//		headers.add(Strings.getString("AddressesFrame.mNameField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.emailField")); //$NON-NLS-1$
/*
		headers.add(Strings.getString("AddressesFrame.homeCountryField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeRegionField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeCityField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeIndexField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homeStreetField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.homePhoneField")); //$NON-NLS-1$
		headers.add(Strings.getString("AddressesFrame.MobilePhoneField")); //$NON-NLS-1$
*/		
		Vector rows = null;
		try {
			rows = Context.storage.getAddressList1(null, null, -1, this.grpId, 1);
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable2.setModel(dtm);
			TableColumnModel tcm = jTable2.getColumnModel();
			tcm.getColumn(0).setMaxWidth(40);
			tcm.getColumn(1).setMinWidth(200);
			tcm.getColumn(2).setMinWidth(200);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}	
		
	/**
	 * This method initializes jButtonRight	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButtonRight() {
		if (jButtonRight == null) {
			jButtonRight = new JButton();
			jButtonRight.setText("-->");
			jButtonRight.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jButtonRight_actionPerformed(e);
				}
			});
		}
		return jButtonRight;
	}

	void jButtonRight_actionPerformed(java.awt.event.ActionEvent e) {
		int rows[] = jTable1.getSelectedRows();			
		for (int i = rows.length - 1; i >= 0; i--) {
			String[] row = {
					(String)jTable1.getValueAt(rows[i], 0),
					(String)jTable1.getValueAt(rows[i], 1),
					(String)jTable1.getValueAt(rows[i], 2)
					};  
			((DefaultTableModel)jTable2.getModel()).addRow(row);
			((DefaultTableModel)jTable1.getModel()).removeRow(rows[i]);
		}
	}
	
	/**
	 * This method initializes jButtonLeft	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButtonLeft() {
		if (jButtonLeft == null) {
			jButtonLeft = new JButton();
			jButtonLeft.setText("<--");
			jButtonLeft.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jButtonLeft_actionPerformed(e);
				}
			});
		}
		return jButtonLeft;
	}

	void jButtonLeft_actionPerformed(java.awt.event.ActionEvent e) {
		int rows[] = jTable2.getSelectedRows();			
		for (int i = rows.length - 1; i >= 0; i--) {
			String[] row = {
					(String)jTable2.getValueAt(rows[i], 0),
					(String)jTable2.getValueAt(rows[i], 1),
					(String)jTable2.getValueAt(rows[i], 2)
					};  
			((DefaultTableModel)jTable1.getModel()).addRow(row);
			((DefaultTableModel)jTable2.getModel()).removeRow(rows[i]);
		}		
	}
	
	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.add(getJButtonLeft(), null);
			jPanel2.add(getJButtonRight(), null);
			jPanel2.add(getJButton(), null);
			jPanel2.add(getJButton1(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jLabelComment = new JLabel();
			jLabelComment.setText(Strings.getString("GroupsFrame.commentField")); //$NON-NLS-1$
			jLabelName = new JLabel();
			jLabelName.setText(Strings.getString("GroupsFrame.nameField")); //$NON-NLS-1$
			jPanel3 = new JPanel();
			jPanel3.setPreferredSize(new java.awt.Dimension(659,60));
			jPanel3.add(jLabelName, null);
			jPanel3.add(getJTextFieldName(), null);
			jPanel3.add(jLabelComment, null);
			jPanel3.add(getJTextFieldComment(), null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jTextFieldName	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextFieldName() {
		if (jTextFieldName == null) {
			jTextFieldName = new JTextField();
			jTextFieldName.setPreferredSize(new java.awt.Dimension(240,20));
		}
		return jTextFieldName;
	}

	/**
	 * This method initializes jTextFieldComment	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextFieldComment() {
		if (jTextFieldComment == null) {
			jTextFieldComment = new JTextField();
			jTextFieldComment.setPreferredSize(new java.awt.Dimension(300,20));
		}
		return jTextFieldComment;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setText(Strings.getString("okButton"));
			okButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					okButton_actionPerformed(e);
				}
			});
		}
		return okButton;
	}

	void okButton_actionPerformed(java.awt.event.ActionEvent e) {
		olivamail.gui.Group grp = new olivamail.gui.Group();
		grp.id = this.grpId;
		grp.name = jTextFieldName.getText();
		grp.comments = jTextFieldComment.getText();
		String ids[] = new String[jTable2.getRowCount()];
		for (int i = 0; i < jTable2.getRowCount(); i++) {
			ids[i] = (String) jTable2.getValueAt(i, 0);
		}		
		try {
			grp = Context.storage.saveGroup(grp, ids);
			parent.updateRow(parentTable, parentRow, grp);
			this_windowClosing(null);
			dispose();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}
	
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Strings.getString("cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return cancelButton;
	}

	public void editAddress(JTable table, int row, String id) {
		this.parentTable = table;
		this.parentRow = row;		
		try {
			this.grpId = id;
			olivamail.gui.Group grp = Context.storage.getGroup(id);
			jTextFieldName.setText(grp.name);
			jTextFieldComment.setText(grp.comments);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	public void setParent(ParentList parent) {
		this.parent = parent;
	}	
		
	/**
	 * This method initializes jSplitPane1	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */    
	private JSplitPane getJSplitPane1() {
		if (jSplitPane1 == null) {
			jSplitPane1 = new JSplitPane();
			jSplitPane1.setDividerLocation(240);
			jSplitPane1.setLeftComponent(getJScrollPane1());
			jSplitPane1.setRightComponent(getJScrollPane2());
		}
		return jSplitPane1;
	}

	public void listAddresses() {
		// TODO Auto-generated method stub
		listAddresses1();
		listAddresses2();
	}	
	
	public void updateRow(JTable jTable, int row, Object obj) {
		if(obj == null)
			return;
		olivamail.gui.Address addr = (olivamail.gui.Address)obj;
		if(jTable == null)
			jTable = jTable2;
		if (row == -1) {
			DefaultTableModel dtm = (DefaultTableModel) jTable.getModel();
			String[] rowArray = { addr.id, addr.fname + " " + addr.lname,
					addr.email };
			dtm.addRow(rowArray);
			return;
		}
		if(jTable.getRowCount() <= row)
			return;	
		String id = (String)jTable.getValueAt(row, AddressTableColumns.COL_ID);
		if(!addr.id.equals(id))
			return;				
		jTable.setValueAt(addr.fname + " " + addr.lname, row, AddressTableColumns.COL_NAME);
		jTable.setValueAt(addr.email, row, AddressTableColumns.COL_EMAIL);
	}
		
}  //  @jve:decl-index=0:visual-constraint="10,10"
