/*
 * @(#)HelpStrings.java
 *
 * Copyright (C) 2007 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Locale;

public class HelpStrings {
	private static final String BUNDLE_NAME = "help"; //$NON-NLS-1$

	private static String lang = "";
	
	private static ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	public static String getString(String key) {
		try {
			return olivamail.core.common.ComUtils.getStringInternals(RESOURCE_BUNDLE
					.getString(key), "UTF-8");
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		} catch (Exception e) {
			return '!' + key + '!';
		}
	}

	public static String getLanguage() {
		return HelpStrings.lang;
	}
	
	public static void setLanguage(String lang) { 
		HelpStrings.lang = lang;		
		Locale locale = new Locale(lang, "");
		RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME, locale);
	}

}
