/*
 * @(#)JDICContentPane.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.Component;
import java.awt.Dimension;
import org.jdesktop.jdic.browser.WebBrowser;

public class JDICContentPane implements ContentPane {

	private String contentType = "text/plain";
	private WebBrowser webBrowser1 = null;
	
	public JDICContentPane() {
	}

	/**
	 * This method initializes jEditorPane1
	 * 
	 * @return javax.swing.JEditorPane
	 */
	private WebBrowser getWebBrowser1() {		
		if (webBrowser1  == null) {
/*			
			BrowserEngineManager bem = BrowserEngineManager.instance();
			if (bem.getActiveEngine() == null) {
				String osName = ComUtils.nvl(System.getProperty("os.name"))
						.trim().toLowerCase();
				String browserEngine = BrowserEngineManager.MOZILLA;
				if (osName.startsWith("windows"))
					browserEngine = BrowserEngineManager.IE;
				bem.setActiveEngine(browserEngine);
			}
*/						
			webBrowser1 = new WebBrowser();
			//WebBrowser.setDebug(true);
			contentType = "text/html";			
		}
		return webBrowser1;
	}

	public Component getComponent() {
		return getWebBrowser1();
//		return getWebBrowser1().asComponent();
	}	

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}
	
	public void setText(String text) {
		if (contentType.equalsIgnoreCase("text/plain")) {
			StringBuffer sb = new StringBuffer("<pre>");
			sb.append(text).append("</pre>");
			webBrowser1.setContent(sb.toString());
		} else
			webBrowser1.setContent(text);
	}

	public void setCaretPosition(int pos) {
	}

	public String getContentType() {
		return contentType;
	}

	public void setSize(Dimension size) {		
		final int border = 15;
		int width = size.width;
		int height = size.height;
		if(width - border > 0)
			width = width - border;
		if(height - border > 0)
			height = height - border;		
		webBrowser1.setSize(width, height);				
		//webBrowser1.setSize(size);
	}
		
	public boolean needAwt() {
		return true;
	}

	public boolean needSwing() {
		return false;
	}	
	
}
