/*
 * @(#)JDICTrayNotify.java
 *
 * Copyright (C) 2008 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Icon;
import org.jdesktop.jdic.tray.SystemTray;
import org.jdesktop.jdic.tray.TrayIcon;

public class JDICTrayNotify implements ITrayNotify {

	private SystemTray systemTray = null;

	private TrayIcon myTrayIcon = null;

	private static Icon trayImgNormal = null;

	private static Icon trayImgNewMsg = null;

	private static ReceivingResult trayCounter = new ReceivingResult();

	public void initTray() {
		try {
			if (systemTray == null)
				systemTray = SystemTray.getDefaultSystemTray();
			//systemTray = SystemTray.getSystemTray();
			if (myTrayIcon == null) {
				//trayImgNormal = Toolkit.getDefaultToolkit().getImage(Context.class.getResource(myPackagePath + "at.gif"));
				//trayImgNewMsg = Toolkit.getDefaultToolkit().getImage(Context.class.getResource(myPackagePath + "at_anim.gif"));
				trayImgNormal = Context.getImageIcon("at.gif");
				trayImgNewMsg = Context.getImageIcon("at_anim.gif");
				myTrayIcon = new TrayIcon(trayImgNormal);
				systemTray.addTrayIcon(myTrayIcon);
				myTrayIcon.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						//System.out.println(e.toString());
						unsetTrayNewMsg();
						Context.mainFrame.placeOnTop();
					}
				});
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}

	public void unsetTrayNewMsg() {
		if (myTrayIcon == null)
			return;
		try {
			trayCounter.reset();
			myTrayIcon.setIcon(trayImgNormal);
			myTrayIcon.setToolTip("");
			Context.stopNewMsgSound();
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}

	public void setTrayNewMsg(ReceivingResult result) {
		if (myTrayIcon == null)
			return;
		try {
			trayCounter.append(result);
			myTrayIcon.setIcon(trayImgNewMsg);
			String newMsgTxt = Context.getTrayNewMsgTxt(result);
			myTrayIcon.displayMessage(null, newMsgTxt,
					TrayIcon.INFO_MESSAGE_TYPE);
			myTrayIcon.setToolTip(newMsgTxt);
			Context.playNewMsgSound();
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}

}
