/*
 * @(#)MainFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;
import javax.mail.Flags;
import javax.mail.MessageRemovedException;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.JTable;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JProgressBar;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;
import java.awt.Component;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.JSplitPane;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreePath;
import javax.swing.BoxLayout;
import java.awt.FlowLayout;
import java.awt.event.MouseAdapter;
import javax.swing.table.JTableHeader;
import java.awt.Rectangle;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.InputStream;
import java.net.URL;
import javax.swing.Timer;
import javax.swing.JTextPane;
import olivamail.core.common.ComUtils;
import olivamail.core.mail.Header;
import olivamail.core.mail.MailUtils;
import olivamail.core.mail.Message;
import olivamail.core.mail.MessageHeader;
import javax.swing.JTextField;
import java.awt.Toolkit;
import javax.swing.JPopupMenu;

public class MainFrame extends JFrame implements MessageSelectionEvent,
		ParentList, RequestHandler {

	static final long serialVersionUID = 4854804733131819902L;	
	
	private JTextPane folderInfoPane = null;	
	
	private JScrollPane folderMessageInfoScroll = null;
	
	private JPanel jContentPane = null;

	private JPanel toolbarPanel = null;

	private JScrollPane jScrollPane1 = null;

	private JScrollPane jScrollPane2 = null;

	private JTree jTree1 = null;
	
	MessageTableModel mtm = null;

	protected JTable jTable1 = null;

	private JButton jbReceiveDefault = null;

	private JButton jbOpenMessage = null;

	private JButton jbCompose = null;

	private JButton jbDeleteMessages = null;

	private JButton jbSend = null;

	private JComboBox jComboBox2 = null;

	private JPanel statusBarPanel = null;

	private JProgressBar jProgressBar1 = null;

	private MessageView messageView1 = null;
	
	private int orderByColumn = MessageTableModel.COL_ID;

	private int orderByDirection = 0;

	private static final int infoPaneHeight = 120; 		
	
	private String quickSearchStr = null;
	
	private SpecialTreeFolders sf = new SpecialTreeFolders();
	 	
	private JButton jbMoveMessages = null;

	private final int DIV_LOC_INLINE = 100;
	
	private final int DIV_LOC_NORMAL = 310;

	private final int DIV_SIZE_INLINE = 10;
	
	private final int DIV_SIZE_NORMAL = 0;	
	
	private JSplitPane TreeSplit = null;

	private JSplitPane MessagesSplit = null;	
	
	private JMenuBar jMainMenuBar = null;

	private JMenu jMenuFile = null;

	private JMenuItem jmiExit = null;

	private JMenu jMenuSettings = null;

	private JMenuItem jmiAccounts = null;

	private JMenu jMenuMessages = null;

	private JMenuItem jmiMsgOpen = null;

	private JMenuItem jmiMsgMove = null;

	private JMenuItem jmiMsgDelete = null;

	private JMenuItem jmiFolders = null;

	private JMenu jMenuService = null;

	private JMenuItem jmiAddresses = null;

	private JMenuItem jmiMime = null;

	private JPanel buttonsPanel = null;

	private JPanel managementPanel = null;

	private JLabel folderLabel = null;

	private JMenuItem jmiSettings = null;

	private Timer timer = null;

	private JMenu jMenuHelp = null;

	private JMenuItem jmiAbout = null;

	private JMenuItem jmiMsgSelAll = null;

	private JMenu jMenuFolders = null;

	private JMenuItem jmiFldCreate = null;

	private JMenuItem jmiFldMove = null;

	private JMenuItem jmiFldDelete = null;

	private JMenuItem jmiFldProps = null;

	private JMenuItem jmiRules = null;

	private JMenu jMenuDeliver = null;

	private JMenuItem jmiReceiveAll = null;

	private JMenuItem jmiSendAll = null;

	private JMenu jMenuReceive = null;

	private JMenuItem jmiReceive = null;

	private Hashtable ReceiveMenu = null;

	private JMenuItem jmiInfo = null;
	
	private boolean isReceiving = false;

	private JMenuItem jmiMsgInvertSel = null;

	private JMenuItem jmiSearchMessages = null;

	private JLabel jsSpacer1 = null;

	private JTextField jtfSearch = null;

	private JButton jbSearch = null; 
	
	private boolean tableLayoutRestored = false;

	private JMenuItem jmiMsgRefresh = null;

	private JMenuItem jmiSignatures = null;

	private JMenuItem jmiMsgCodepage = null;

	private JMenuItem jmiMsgExport = null;

	private JLabel jlStatus = null;

	private JMenuItem jmiMsgShowPics = null;

	private JMenuItem jmiMsgDeleteNoTrash = null;

	private JMenuItem jmiSqlQuery = null;

	private JMenuItem jmiForward = null;

	private JMenuItem jmiImapSubscr = null;

	private JMenuItem jmiImapExpunge = null;

	private JMenu jmMsgToggle = null;

	private JMenuItem jmiMsgTglSeen = null;

	private JMenuItem jmiMsgTglFlag = null;

	private JMenuItem jmiMsgTglReceive = null;

	private JMenuItem jmiWorkOffline = null;

	private JMenuItem jmiCopyMsgs = null;

	private JMenuItem jmiColLayout = null;

	private JMenuItem jmiCancel = null; 
	
	private boolean cancelDelivery = false;

	private JLabel jlStatRec = null;

	private JLabel jlStatSend = null;

	private JLabel jlStatPercent = null;
	
	private int threadsRec = 0;
	
	private int threadsSend = 0;
	
	private Date statBarOperDate = null;

	private JMenuItem jmiSaveAllAtt = null;

	private JPopupMenu jPopupMenuMessages = null;  //  @jve:decl-index=0:visual-constraint="2,653"

	private JMenuItem jmiSetSeen = null;

	private JMenuItem jmiSetUnseen = null;

	private JMenuItem jmiSetReceive = null;

	private JMenuItem jmiUnsetReceive = null;

	private JMenuItem jmiSetFlag = null;

	private JMenuItem jmiUnsetFlag = null;
	
	/**
	 * This is the default constructor
	 */
	public MainFrame() {
		super();
		Context.mainFrame = this;
		if(MessageTableModel.colPos[MessageTableModel.COL_RECEIVED_DATE] != -1)
			orderByColumn = MessageTableModel.COL_RECEIVED_DATE;
		else if(MessageTableModel.colPos[MessageTableModel.COL_SENT_DATE] != -1)
			orderByColumn = MessageTableModel.COL_SENT_DATE;
		initialize();
	}

	public void resetCancelDelivery() {
		cancelDelivery = false;
		jmiCancel.setEnabled(true);
	}

	public void setCancelDelivery() {
		cancelDelivery = true;
		jmiCancel.setEnabled(false);
	}
		
	public boolean isDeliveryCanceled() {
		return cancelDelivery;
	}
	
	public void updateShowMessageInline() {
		jmiMsgShowPics.setEnabled(false);					
		if (Context.isShowMessageInline()) { 			
			MessagesSplit.setDividerLocation(MessagesSplit.getSize().height / 3);
			MessagesSplit.setDividerSize(DIV_SIZE_INLINE);
			showFolderMessageInfo();
		} else {			
			MessagesSplit.setDividerLocation(MessagesSplit.getSize().height - infoPaneHeight);
			MessagesSplit.setDividerSize(DIV_SIZE_NORMAL);
			if(!(MessagesSplit.getBottomComponent() instanceof JScrollPane)) {
				//int divPos = MessagesSplit.getDividerLocation();					
				MessagesSplit.setBottomComponent(getFolderMessageInfoScroll());
				//MessagesSplit.setDividerLocation(divPos);													
			}											
		}
	}
	
	public void updateTimer() {
		try {
			boolean rp = olivamail.core.common.ComUtils.parseBoolean(Context
					.getSettingsValue("receive_periodically"), false);
			if (!rp) {
				if (timer == null)
					return;
				if (timer.isRunning())
					timer.stop();
				timer = null;
				return;
			}
			int period = Integer.parseInt(Context
					.getSettingsValue("receive_period"));
			if (timer != null)
				if (timer.isRunning())
					timer.stop();
			timer = new Timer(period * 60000,
					new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							timer_actionPerformed(e);
						}
					});
			timer.start();
			return;
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	public int getOrderByColumn() {
		return orderByColumn;
	}

	public int getOrderByDirection() {
		return orderByDirection;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(906, 598);
		this.setIconImage(Toolkit.getDefaultToolkit().getImage(getClass()
				.getResource(Context.myPackagePath + "at.gif")));
		this.addComponentListener(new java.awt.event.ComponentAdapter() { 
			public void componentResized(java.awt.event.ComponentEvent e) {
				if(MessagesSplit != null) {
					if(Context.isShowMessageInline())
						MessagesSplit.setDividerLocation(MessagesSplit.getSize().height / 3);
					else
						MessagesSplit.setDividerLocation(MessagesSplit.getSize().height - infoPaneHeight);
				}
			}
		});
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				callExit();
			}
		});
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setJMenuBar(getJMainMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("MainFrame.title"));
		Context.setMenuFont(jMenuFile.getFont());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getToolbarPanel(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getStatusBarPanel(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getTreeSplit(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getToolbarPanel() {
		if (toolbarPanel == null) {
			toolbarPanel = new JPanel();
			toolbarPanel.setLayout(new BoxLayout(toolbarPanel, BoxLayout.Y_AXIS));
			toolbarPanel.add(getButtonsPanel(), null);
			toolbarPanel.add(getManagementPanel(), null);
		}
		return toolbarPanel;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setPreferredSize(new java.awt.Dimension(100, 2));
			jScrollPane2.setViewportView(getJTree1());
		}
		return jScrollPane2;
	}

/*	
	private void updateNewMsgInfo() throws Exception {
		DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode) jTree1
				.getModel().getChild(jTree1.getModel().getRoot(), 0);
		if (dmtn == null)
			return;
		Enumeration en = dmtn.depthFirstEnumeration();
		//Enumeration en = jTree1.get(new TreePath(dmtn.getPath()));
		while(en.hasMoreElements()) {
			dmtn = (DefaultMutableTreeNode)en.nextElement();
			Object obj = dmtn.getUserObject();
			if(obj instanceof Folder) {
				Folder folder = (Folder)obj;
				folder.setNewMsgCount(Context.storage.getNewMsgCount(folder.getId()));
			}
		}
		jTree1.updateUI();
	}
*/	
	
			
	/**
	 * This method initializes jTree
	 * 
	 * @return javax.swing.JTree
	 */
	private JTree getJTree1() {
		if (jTree1 == null) {
			jTree1 = new JTree(FoldersTreeFrame.getRootTreeNode(sf));
			jTree1.setRootVisible(false);
			jTree1.setRowHeight(16);			
			jTree1.setCellRenderer(new MyCellRenderer());

			jTree1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {    
					jTree1_folderSelected();
				}
				
			    public void mouseReleased(java.awt.event.MouseEvent e) {        
			    	displayPopupMenu(e);
			    }
							
			    private void displayPopupMenu(MouseEvent e) {
			        if(!e.isPopupTrigger()) {
			        	//jTree1_nodeSelected();			        	
			        	return;			
			        }
			        DefaultMutableTreeNode dutn = (DefaultMutableTreeNode)((JTree)e.getComponent()).getClosestPathForLocation(e.getX(), e.getY()).getLastPathComponent();
			        jTree1.setSelectionPath(new TreePath(dutn.getPath()));
			        JPopupMenu menu = null;
			        try {
			        	Object userObject = dutn.getUserObject();
			        	if(!(userObject instanceof PopupFactory))
			        		return;
						menu = ((PopupFactory) userObject)
								.getPopupMenu(jTree1, dutn);
						menu.show(e.getComponent(), e.getX(), e.getY());
					} catch (Exception exc) {
						exc.printStackTrace();
						AlertDialog.showErrorDialog(exc);
					}
			    }								
			});
			
			jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent e) {
					jTree1_folderSelected();
				}
			});
			FoldersTreeFrame.expandTreeNode(jTree1, 0);
			FoldersTreeFrame.expandTreeNode(jTree1, 1);
		}
		return jTree1;
	}
	
	public void updateTree() {
		JTree jTree = new JTree(FoldersTreeFrame.getRootTreeNode(sf));	
		jTree1.removeAll();
		jTree1.setModel(jTree.getModel());
		FoldersTreeFrame.expandTreeNode(jTree1, 0);
		FoldersTreeFrame.expandTreeNode(jTree1, 1);
	}

	/**
	 * This method initializes jTable1
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {
				static final long serialVersionUID = 3102406582614675292L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}				
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					MessageRow mr = mtm.getMessageRowAt(rowIndex);

					if (isCellSelected(rowIndex, vColIndex)) {// What else
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						if (mr.sfDel)
							c.setForeground(Color.RED);
						else
							c.setForeground(Color.black);
					}
					int style = Font.BOLD;
					if (mr.sfSeen)
						style = Font.PLAIN;
					if (mr.sfDel)
						style |= Font.ITALIC;

					c.setFont(c.getFont().deriveFont(style));
					// c.setFont(new java.awt.Font("Dialog", style, 12));
					//
					return c;
				}
			};
			// jTable1.setFont(new java.awt.Font("Dialog", 0, 12));
			//
//			jTable1.setCellEditor(new MessagesCellEditor());
			jTable1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(e.getClickCount() == 2)
						callOpenMessage(null);
					else {
						if (e.getButton() == MouseEvent.BUTTON3) {
							Point point = e.getPoint();
							int index = jTable1.rowAtPoint(point);
							if (!jTable1.isRowSelected(index))
								jTable1.setRowSelectionInterval(index, index);
							getJPopupMenuMessages().show(e.getComponent(),
									e.getX(), e.getY());
						}
					}
				}
			});
			jTable1.getTableHeader().addMouseListener(
					new ColumnHeaderListener(this));
			MessageSelectionListener listener = new MessageSelectionListener(jTable1, this);
			jTable1.getSelectionModel().addListSelectionListener(listener);
			
			jTable1.setGridColor(jTable1.getBackground());
		}
		return jTable1;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbReceiveDefault() {
		if (jbReceiveDefault == null) {
			jbReceiveDefault = new JButton();
			jbReceiveDefault.setText(Strings.getString("MainFrame.receive"));
			jbReceiveDefault.setIcon(Context.getImageIcon("recieve.gif"));
			jbReceiveDefault.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					receiveDefault();
				}
			});
		}
		return jbReceiveDefault;
	}

	protected void setOrderBy(int col) {
		col = MessageTableModel.checkColumn(col);
		orderByColumn = MessageTableModel.checkColumn(orderByColumn);
		
		if (col == orderByColumn)
			orderByDirection = 1 - orderByDirection;
                else {
			orderByColumn = col;
			orderByDirection = 0;
		}
		if(getCurrentSearchFolder() != null) {
			try {
				String widths = null;
				if (tableLayoutRestored)
					widths = getColumnsLayout();
				else {
					tableLayoutRestored = true;
					widths = Context.storage
							.getSettingsValue("table.messages.widths");
				}

				mtm.sortAllRowsBy(orderByColumn, orderByDirection == 1);
				MessageTableModel.setColumnModel(jTable1, this);

				applyColumnsLayout(widths);
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}		
		} else
			listMessages();
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbOpenMessage() {
		if (jbOpenMessage == null) {
			jbOpenMessage = new JButton();
			jbOpenMessage.setText(Strings.getString("MainFrame.openButton"));
			jbOpenMessage.setIcon(Context.getImageIcon("open.gif"));
			jbOpenMessage.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					callOpenMessage(null);
				}
			});
		}
		return jbOpenMessage;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbCompose() {
		if (jbCompose == null) {
			jbCompose = new JButton();
			jbCompose.setText(Strings.getString("MainFrame.composeButton"));
			jbCompose.setIcon(Context.getImageIcon("compose.gif"));
			jbCompose.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					callCompose();
				}
			});
		}
		return jbCompose;
	}

	/**
	 * This method initializes jButton6
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbDeleteMessages() {
		if (jbDeleteMessages == null) {
			jbDeleteMessages = new JButton();
			jbDeleteMessages.setText(Strings.getString("MainFrame.deleteButton"));
			jbDeleteMessages.setIcon(Context.getImageIcon("delete.gif"));
			jbDeleteMessages.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteMessages(false, MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jbDeleteMessages;
	}

	/**
	 * This method initializes jButton8
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbSend() {
		if (jbSend == null) {
			jbSend = new JButton();
			jbSend.setText(Strings.getString("MainFrame.send"));
			jbSend.setIcon(Context.getImageIcon("send.gif"));
			jbSend.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					MailContext.sendFromOutbox();
				}
			});
		}
		return jbSend;
	}

	public synchronized void refreshWorkOffline() {
		jmiWorkOffline.setIcon((Context.workOffline) ? Context
				.getImageIcon("check.png") : null);
	}
	
	/**
	 * This method initializes jComboBox2
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox2() {
		if (jComboBox2 == null) {
			String counts[] = new String[] {
					"50", "100", Strings.getString("MainFrame.limitAll") };
			jComboBox2 = new JComboBox(counts);
			jComboBox2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jComboBox2_actionPerformed(e);
				}
			});
		}
		return jComboBox2;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getStatusBarPanel() {
		if (statusBarPanel == null) {
			jlStatPercent = new JLabel();
			jlStatPercent.setText("0:%");
			jlStatSend = new JLabel();
			jlStatSend.setText(":0");
			jlStatSend.setIcon(Context.getImageIcon("sendgr.gif"));
			jlStatRec = new JLabel();
			jlStatRec.setText(":0");
			jlStatRec.setIcon(Context.getImageIcon("recgr.gif"));
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			jlStatus = new JLabel();
			jlStatus.setText("");
			jlStatus.setPreferredSize(new java.awt.Dimension(550,16));
			statusBarPanel = new JPanel();
			statusBarPanel.setLayout(flowLayout1);
			statusBarPanel.add(jlStatRec, null);
			statusBarPanel.add(jlStatSend, null);
			statusBarPanel.add(getJProgressBar1(), null);
			statusBarPanel.add(jlStatPercent, null);
			statusBarPanel.add(jlStatus, null);
		}
		return statusBarPanel;
	}

	/**
	 * This method initializes jProgressBar1
	 * 
	 * @return javax.swing.JProgressBar
	 */
	private JProgressBar getJProgressBar1() {
		if (jProgressBar1 == null) {
			jProgressBar1 = new JProgressBar();
			jProgressBar1.setStringPainted(true);
			jProgressBar1.setString("");
		}
		return jProgressBar1;
	}

	void timer_actionPerformed(ActionEvent e) {
/*		
		if(!errorConfirmed)
			return;
*/			
		if(isReceiving())
			return;
		Account acnt = null;
		try {
			acnt = Context.storage.getDefaultAccount();			
		} catch (Exception exc) {
			setReceiving();
			AlertDialog.showErrorDialog(exc);
			unsetReceiving();
			return;
		}
		if (acnt == null) {
			setReceiving();
			if(AlertDialog.showConfirmDialog(
					Strings.getString("MainFrame.noAccount"), 
					AlertDialog.OK_CANCEL_OPTION) == AlertDialog.OK_OPTION) {
				showAccounts();
			}
			unsetReceiving();			
			return;
		}			
		MailContext.callReceive(acnt, null, false);
		MailContext.sendFromOutbox(true);
	}	

	public synchronized boolean setReceiving() {
		if(isReceiving)
			return false;
		isReceiving = true;
		return true;
	}
	
	public synchronized void unsetReceiving() {
		isReceiving = false;
	}

	public synchronized boolean isReceiving() {
		return isReceiving;
	}	
	
	public void setProgressMax(int max) {
		jProgressBar1.setMaximum(max);
		int value = jProgressBar1.getValue();
		jlStatPercent.setText(String.valueOf((int)(value / max * 100)) + ":%");		
	}

	public int getProgressMax() {
		return jProgressBar1.getMaximum();
	}	
	
	public void setProgressVal(int value) {
		jProgressBar1.setValue(value);
		int max = jProgressBar1.getMaximum();		
		jlStatPercent.setText(String.valueOf((int)(value / max * 100)) + ":%");
	}	

	public void refreshStatusBarText(boolean setDate) {
		if (setDate)
			statBarOperDate = new Date();
		String date = MessageRow.getRelativeDate(statBarOperDate);

		int[] rows = jTable1.getSelectedRows();
		long totSize = 0;
		for (int i = 0; i < rows.length; i++) {
			int msgSize = mtm.getMessageRowAt(rows[i]).msgSize;
			if (msgSize < 0)
				msgSize = 0;
			totSize += msgSize;
		}

		jlStatus.setText(Strings.getString("statBarStr").replaceFirst(
				"\\$date", date).replaceFirst("\\$count",
				String.valueOf(rows.length)).replaceFirst("\\$size",
				ComUtils.getSizeString(totSize)));
	}		

	public void removeRowFromTable(MessageRow mr) {
		try {
			String curFldId = getCurrentFolderId();
			if (curFldId != null && curFldId.equals(mr.folderId)) {
				for (int row = jTable1.getRowCount() - 1; row >= 0; row--) {
					String id = mtm.getMessageRowAt(row).id;
					if (id.equals(mr.id)) {
						mtm.removeRow(row);
						break;
					}
				}
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}
	
	public void updateRowInTable(MessageRow mr) {
		try {
			String curFldId = getCurrentFolderId();
			if (curFldId != null && curFldId.equals(mr.folderId)) {
				for (int row = jTable1.getRowCount() - 1; row >= 0; row--) {
					String id = mtm.getMessageRowAt(row).id;
					if (id.equals(mr.id)) {
						mtm.setMessageRowAt(mr, row);
						break;
					}
				}
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}
	}	
	
	public void addRowToTableIfNeeded(String id, String folderId)
			throws Exception {
		String curFldId = getCurrentFolderId();
		if (curFldId == null)
			return;
		if (folderId != null)
			if (!curFldId.equals(folderId))
				return;
		MessageRow mr = Context.storage.getMessageRow(id);
		if (!curFldId.equals(mr.folderId))
			return;

		int[] rows = jTable1.getSelectedRows();
		int oldPos = -1;
		if(rows.length > 0)
			oldPos = rows[0]; 
		mtm.addRowSorted(mr, orderByColumn, orderByDirection == 1);
		int delta = jTable1.getSelectedRowCount() - rows.length;
		if (delta > 0)
			jTable1.removeRowSelectionInterval(oldPos, oldPos);
	}	
	
/*
	public void addRowToTable(DefaultTableModel dtm, MessageRow mr) {
		String date = null;
		if (isOutFolder())
			date = mr.getSentDateDMY();
		else
			date = mr.getReceivedDateDMY();
		dtm.addRow(new Object[] {
				mr.importance, 
				mr.seen,
				mr.hasAtt,
				mr.id,
				date,
				mr.addrFrom,
				mr.addrTo,
				mr.subject,
		});						
	} 
 */	
	
	public void selectInboxFolder() {
		if(sf.inboxTreeNode == null)
			return;
		TreePath treePath = new TreePath(sf.inboxTreeNode.getPath());
		Context.debugStr("jTree1.getSelectionPath()...");
		TreePath selectionPath = jTree1.getSelectionPath();
		if (selectionPath != null && selectionPath.equals(treePath)) {
		} else {
			Context.debugStr("jTree1.setSelectionPath(treePath)...");
			jTree1.setSelectionPath(treePath);
			Context.debugStr("jTree1.scrollPathToVisible(treePath)...");
			jTree1.scrollPathToVisible(treePath);
		}		
	}

	private void applyColumnsLayout(String widths) {
		if(widths == null)
			return;
		StringTokenizer st = new StringTokenizer(widths, ",");
		TableColumnModel tcm = jTable1.getColumnModel();
		for(int i = 0; st.hasMoreTokens() && i < tcm.getColumnCount(); i++) {
			String avp = st.nextToken();
			int idx = avp.indexOf("=");
			int col = ((Integer)MessageTableModel.colCapHt.get(avp.substring(0, idx))).intValue();
			int val = Integer.parseInt(avp.substring(idx + 1, avp.length()));
			if(MessageTableModel.colPos[col] != -1) {
				tcm.getColumn(MessageTableModel.colPos[col]).setPreferredWidth(val);
			} else if(col == MessageTableModel.COL_RECEIVED_DATE) {
				if(MessageTableModel.colPos[MessageTableModel.COL_SENT_DATE] != -1)
					tcm.getColumn(MessageTableModel.colPos[MessageTableModel.COL_SENT_DATE]).setPreferredWidth(val);
			} else if(col == MessageTableModel.COL_SENT_DATE) {
				if(MessageTableModel.colPos[MessageTableModel.COL_RECEIVED_DATE] != -1)
					tcm.getColumn(MessageTableModel.colPos[MessageTableModel.COL_RECEIVED_DATE]).setPreferredWidth(val);
			}
		}	
//		jTable1.updateUI();
	}	
	
	private String getColumnsLayout() {
		TableColumnModel tcm = jTable1.getColumnModel();
		StringBuffer sb = new StringBuffer(); 
		for(int i = 0; i < tcm.getColumnCount(); i++) {
			if(i != 0)
				sb.append(",");			
			sb.append(MessageTableModel.columnCaps[MessageTableModel.shownColumns[i]]).append("=").append(tcm.getColumn(i).getWidth());
		}
		return sb.toString();		
	}
	
	public void setShownColumns(String width) throws Exception {
		Context.storage.setSettingsValue("table.messages.widths",
				width);		
		MessageTableModel.setShownColumns(width);
		tableLayoutRestored = false;
		listMessages();
	}
	
	void callExit() {
		if (Context.storage != null) {
			try {
				Context.storage.setSettingsValue("table.messages.widths",
						getColumnsLayout());
			} catch (Exception exc) {
				exc.printStackTrace();
			}
			try {
				Context.storage.close();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
		}
		try {
			Context.clearCache("msg");
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		System.exit(0);
	}

	private boolean isOutFolder() {
		String fldId = getCurrentFolderId();
		if(fldId == null)
			return false;
		return fldId.equals(Context.getSentFolder())
				|| fldId.equals(Context.getOutboxFolder());
	}

	protected IFolder getCurrentImapFolder() throws Exception {
		String folderId = getCurrentFolderId();
		if (folderId == null)
			return null;
		Folder folder = Context.storage.getFolder(folderId);
		if(!folder.isImap())
			return null;
		return Context.storage.getImapFolder(folderId);
	}
	
	public synchronized void deleteLostImapMessages(Hashtable htuids,
			IFolder iFolder) throws Exception {
		String folderId = getCurrentFolderId();
		if (folderId == null || !folderId.equals(iFolder.getId()))
			return;
		for (int i = mtm.getRowCount() - 1; i >= 0; i--) {
			MessageRow mr = mtm.getMessageRowAt(i);
			if (!ComUtils.nvl(iFolder.uidVal).equals(String.valueOf(mr.uidValidity)) || !htuids.containsKey(mr.msgUid))
				mtm.removeRow(i);
		}
	}

	public synchronized void expungeFolder(IFolder iFolder) throws Exception {
		String folderId = getCurrentFolderId();
		if (folderId == null || !folderId.equals(iFolder.getId()))
			return;
		for (int i = mtm.getRowCount() - 1; i >= 0; i--) {
			MessageRow mr = mtm.getMessageRowAt(i);
			if (mr.sfDel)
				mtm.removeRow(i);
		}
	}
		
	public synchronized void updateMessageIfNeeded(MessageRow mr) throws Exception {
		String folderId = getCurrentFolderId();
		if (folderId == null || !folderId.equals(mr.folderId))
			return;

		int row = jTable1.getSelectedRow();
		MessageRow tmr = null;
		if (row != -1) {
			tmr = mtm.getMessageRowAt(row);
			if (mr.id.equals(tmr.id)) {
				mtm.setMessageRowAt(mr, row);
				return;
			}
		}

		for (int i = mtm.getRowCount() - 1; i >= 0; i--) {
			tmr = mtm.getMessageRowAt(i);
			if (mr.id.equals(tmr.id)) {
				mtm.setMessageRowAt(mr, i);
				break;
			}
		}
	}	

	public synchronized int removeRowIfNeeded(MessageRow mr)
			throws Exception {
		String currentFolderId = getCurrentFolderId();
		if (currentFolderId == null || !currentFolderId.equals(mr.folderId))
			return -1;
		for (int i = mtm.getRowCount() - 1; i >= 0; i--) {
			MessageRow tmr = mtm.getMessageRowAt(i);
			if (mr.id.equals(tmr.id)) {
				mtm.removeRow(i);
				return i;
			}
		}
		return -1;
	}	
		
	public synchronized void listMessages() {
		Vector rows = null;
		try {
			int limit = -1;
			if (true) {
				if (jComboBox2.getSelectedIndex() != jComboBox2.getItemCount() - 1)
					limit = Integer.parseInt((String) jComboBox2
							.getSelectedItem());
			}

			String folderId = getCurrentFolderId();
			SearchFolder searchFolder = getCurrentSearchFolder();			
			String searchStr = quickSearchStr;
			quickSearchStr = null;
			
			if (!MessageTableModel.showBothDates) {
				if (orderByColumn == MessageTableModel.COL_SENT_DATE
						&& !isOutFolder())
					orderByColumn = MessageTableModel.COL_RECEIVED_DATE;
				else if (orderByColumn == MessageTableModel.COL_RECEIVED_DATE
						&& isOutFolder())
					orderByColumn = MessageTableModel.COL_SENT_DATE;
			}
			
			if (searchFolder != null) {
				searchStr = searchFolder.getSearchCondition();
				if(searchFolder.getType() == SearchFolder.SEARCH_NONE ||
						searchStr == null) {
					rows = new Vector(0);
				} else {
					Context.debugStr("Context.storage.getMessageList1...");					
					rows = Context.storage.getMessageList(folderId, searchStr,
							MessageTableModel.sortv[orderByDirection][orderByColumn], limit,
							Context.getContentSearchEngine(),
							searchFolder.contentSearchText, searchFolder.progressBar);
					if (searchFolder.contentSearchText != null) {
						searchFolder.commonSearchCondition = null;
						searchFolder.contentSearchText = null;
						searchFolder.progressBar = null;
					}
				}
			} else {
				Context.debugStr("Context.storage.getMessageList2...");
				rows = Context.storage.getMessageList(folderId, searchStr,
						MessageTableModel.sortv[orderByDirection][orderByColumn], limit);
			}
			
			String widths = null;
			if (tableLayoutRestored)
				widths = getColumnsLayout();
			else {
				tableLayoutRestored = true;
				widths = Context.storage
						.getSettingsValue("table.messages.widths");
				MessageTableModel.setShownColumns(widths);
			}			

			Context.debugStr("new MessageTableModel...");			
			mtm = new MessageTableModel(rows, isOutFolder());  						
			jTable1.setModel(mtm);			
			Context.debugStr("MessageTableModel.setColumnModel...");
			MessageTableModel.setColumnModel(jTable1, this);
			
			Context.debugStr("applyColumnsLayout(widths)...");
			applyColumnsLayout(widths);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}

/*	
	public void listMessages1() {
		Vector headers = new Vector(7);
		headers.add("!");
		headers.add(Strings.getString("MainFrame.seenField"));
		headers.add(Strings.getString("MainFrame.attField"));		
		headers.add(Strings.getString("MainFrame.idField"));		
		if (isOutFolder())
			headers.add(Strings.getString("MainFrame.sentDate"));
		else
			headers.add(Strings.getString("MainFrame.receivedDate"));
		headers.add(Strings.getString("MainFrame.fromField"));
		headers.add(Strings.getString("MainFrame.toField"));
		headers.add(Strings.getString("MainFrame.subjectField"));
		Vector rows = null;
		try {
*/		
/*			
			if (folderId == null)
				folderId = Context.storage.getInboxFolder();
*/
/*
			int limit = -1;
			if (true) {
				if (jComboBox2.getSelectedIndex() != jComboBox2.getItemCount() - 1)
					limit = Integer.parseInt((String) jComboBox2
							.getSelectedItem());
			}

			String folderId = getCurrentFolderId();
			SearchFolder searchFolder = getCurrentSearchFolder();			
			String searchStr = quickSearchStr;
			quickSearchStr = null;
			
			int orderBy = orderByColumn;
			if(orderByColumn == MessageTableColumns.COL_SENT_DATE &&
					!isOutFolder())
				orderBy = MessageTableColumns.COL_RECEIVED_DATE;
			
			if (searchFolder != null) {
				searchStr = searchFolder.getSearchCondition();
				if(searchFolder.getType() == SearchFolder.SEARCH_NONE ||
						searchStr == null) {
					rows = new Vector(0);
				} else {
					rows = Context.storage.getMessageList(folderId, searchStr,
							sortv[orderByDirection][orderBy], limit,
							Context.getContentSearchEngine(),
							searchFolder.contentSearchText, searchFolder.progressBar);
					if (searchFolder.contentSearchText != null) {
						searchFolder.commonSearchCondition = null;
						searchFolder.contentSearchText = null;
						searchFolder.progressBar = null;
					}
				}
			} else {
				rows = Context.storage.getMessageList(folderId, searchStr,
						sortv[orderByDirection][orderBy], limit);
			}
						
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setColumnIdentifiers(headers);
			//dtm.setDataVector(rows, headers);
			for(int i = 0; i < rows.size(); i++) {
				MessageRow mr = (MessageRow)rows.get(i);
				addRowToTable(dtm, mr);				
			}
			
			String widths = null;
			if(tableLayoutRestored)
				widths = getColumnsLayout();
			else {
				tableLayoutRestored = true;
				widths = Context.storage.getSettingsValue("table.messages.widths");				
			}
			
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(MessageTableColumns.COL_IMPORTANCE).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_IMPORTANCE).setCellRenderer(
					new IconRenderer());			
			tcm.getColumn(MessageTableColumns.COL_IMPORTANCE).setMaxWidth(20);
			tcm.getColumn(MessageTableColumns.COL_ID).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_ID).setMaxWidth(40);
			tcm.getColumn(MessageTableColumns.COL_SENT_DATE).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_SENT_DATE).setMaxWidth(160);
			tcm.getColumn(MessageTableColumns.COL_ADDR_FROM).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_ADDR_TO).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_SUBJECT).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_HAS_ATT).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_HAS_ATT).setCellRenderer(
					new IconRenderer());
			tcm.getColumn(MessageTableColumns.COL_HAS_ATT).setMaxWidth(20);
			tcm.getColumn(MessageTableColumns.COL_SEEN).setHeaderRenderer(
					new HeaderRenderer(this));
			tcm.getColumn(MessageTableColumns.COL_SEEN).setCellRenderer(
					new IconRenderer());
			tcm.getColumn(MessageTableColumns.COL_SEEN).setMaxWidth(20);
			
			applyColumnsLayout(widths);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
*/	
		
	private void showFolderInfo() {
		if (Context.isShowMessageInline()) {
			if(!(MessagesSplit.getBottomComponent() instanceof JScrollPane)) {
				int divPos = MessagesSplit.getDividerLocation();					
				MessagesSplit.setBottomComponent(getFolderMessageInfoScroll());
				MessagesSplit.setDividerLocation(divPos);													
			}
		}
		Object folderObject = getCurrentTreeObject();
		if (folderObject == null)
			return;
		try {
			if (folderObject instanceof SearchFolder) {
				SearchFolder searchFolder = (SearchFolder)folderObject;				
				folderLabel.setText(searchFolder.getTitle());				
				StringBuffer sb = new StringBuffer();
				sb.append("<html><body>\n");
				sb.append("<table border=\"0\">\n");
				sb.append("<tr><td align=\"center\" valign=\"center\">\n");
				sb.append("<img width=\"96\" height=\"96\" src=\"").append(
						"file://").append(Context.homeDir).append(
						"pics/folder.jpg\">\n");
				sb.append("</td>\n");
				sb.append("<td valign=\"top\">\n");
				sb.append("<h2><font face=\"Tahoma, Arial, Verdana\" color=\"#ffffff\">\n");
				sb.append(searchFolder.getTitle());
				sb.append("</font></h2>\n");
				if(searchFolder.getType() != SearchFolder.SEARCH_NONE &&
						searchFolder.getSearchCondition() != null) {
					sb.append("<font face=\"Tahoma, Arial, Verdana\" color=\"#ffffff\" size=\"2\">\n");
					sb.append(searchFolder.getSearchCondition());
					sb.append("</font>\n");
				}
				sb.append("</td></tr>\n");
				sb.append("</table\n");
				sb.append("</body></html>");
				folderInfoPane.setText(sb.toString());
				folderInfoPane.setCaretPosition(0);
/*				
				if(searchFolder.getType() == SearchFolder.SEARCH_BASIC &&
						searchFolder.getSearchCondition() == null) {
					jMenuItem15_actionPerformed(null);
				}
*/				
			} else if (folderObject instanceof Folder) {				
				String dispName = null;
				if(folderObject instanceof IFolder) {
					IFolder iFolder = (IFolder)folderObject;
					dispName = iFolder.getDisplayName();
				} else {
					Folder folder = (Folder)folderObject;
					dispName = folder.getDisplayName();
				}

				folderLabel.setText(dispName);

				StringBuffer sb = new StringBuffer();
				sb.append("<html><body>\n");
				sb.append("<table border=\"0\">\n");
				sb.append("<tr><td align=\"center\" valign=\"center\">\n");
				sb.append("<img width=\"96\" height=\"96\" src=\"").append(
						"file://").append(Context.homeDir).append(
						"pics/folder.jpg\">\n");
				sb.append("</td>\n");
				sb.append("<td valign=\"top\">\n");
				sb
						.append("<h2><font face=\"Tahoma, Arial, Verdana\" color=\"#ffffff\">\n");
				sb.append(dispName);
				sb.append("</font></h2>\n");
				sb.append("</td></tr>\n");
				sb.append("</table\n");
				sb.append("</body></html>");
				folderInfoPane.setText(sb.toString());
				folderInfoPane.setCaretPosition(0);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			// AlertDialog.showErrorDialog(exc);
		}						
	}
	
	private Object getCurrentTreeObject() {
		if (jTree1.getSelectionPath() == null)
			return null;
		DefaultMutableTreeNode dutn = (DefaultMutableTreeNode) jTree1
				.getSelectionPath().getLastPathComponent();		
		return dutn.getUserObject();
	}
	
	private SearchFolder getCurrentSearchFolder() {
		Object folderObject = getCurrentTreeObject();
		if (folderObject == null)
			return null;
		if (!(folderObject instanceof SearchFolder))
			return null;
		return (SearchFolder)folderObject;
	}
		
	protected String getCurrentFolderId() {
		Object folderObject = getCurrentTreeObject();
		if (folderObject == null)
			return null;
		if (folderObject instanceof Folder)
			return ((Folder) folderObject).getId();
		return null;
	}
	
	protected synchronized void jTree1_folderSelected() {
		Object folderObject = getCurrentTreeObject();
		if (folderObject == null)
			return;
		Context.debugStr("showFolderInfo()...");
		showFolderInfo();
		Context.debugStr("listMessages()...");
		listMessages();				
		
		if (!Context.workOffline) {
			try {
				IFolder iFolder = getCurrentImapFolder();
				if (iFolder != null && iFolder.getFldId() != null) {
					Context.debugStr("iFolder.getFldId() == "
							+ iFolder.getFldId());
					Context.debugStr("MailContext.callReceive...");
					Context.debugStr("Context.storage == null: "
							+ String.valueOf(Context.storage == null));
					MailContext.callReceive(Context.storage
							.getAccount(iFolder.acntId), iFolder, true);
				}
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
		}
	}
		
	public MessageRow deleteMessage(String id, boolean noTrash) throws Exception {
		MessageRow mr = null;
		Cursor oldCursor = getCursor();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			mr = Context.storage.getMessageRow(id);
			if (changeImapMessageFlag(mr, Flags.Flag.DELETED, MessageRow.MESSAGES_FLAGS_SET))
				mr = null;
			else {
				if (mr.folderId.compareTo(Context.getTrashFolder()) == 0)
					Context.storage.deleteMessage(mr.id, true);
				else {
					if (noTrash)
						Context.storage.deleteMessage(mr.id, true);
					else
						Context.storage.moveMessage(mr.id, Context
								.getTrashFolder());
				}

				int row = removeRowIfNeeded(mr);
				if (row < 0)
					row = 0;

				if (jTable1.getRowCount() > 0) {
					if (row >= jTable1.getRowCount())
						row = jTable1.getRowCount() - 1;

					jTable1.setRowSelectionInterval(row, row);
					mr = mtm.getMessageRowAt(row);
				}
			}
			updateFldNewMsgInfo();
			setCursor(oldCursor);
			return mr;
		} catch (Exception exc) {
			setCursor(oldCursor);
			throw exc;
		}
	}		
	
	public MessageRow nextMessage(MessageFrame mf) {
		if(jTable1.getRowCount() == 0) {
			AlertDialog.showInfoDialog(Strings.getString("MainFrame.lastMessageReached"));	
			return null;
		}
		int row = jTable1.getSelectedRow();
		if (row == -1) {
			row = 0;
		} else {
			row++;
			if(row >= jTable1.getRowCount()) {
				AlertDialog.showInfoDialog(Strings.getString("MainFrame.lastMessageReached"));				
				return null;
			}
		}
		jTable1.setRowSelectionInterval(row, row);
		callOpenMessage(mf);
		return null;
/*		
		jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
		return (String) jTable1.getValueAt(row, MessageTableColumns.COL_ID);
*/		
	}

	public MessageRow previousMessage(MessageFrame mf) {
		if(jTable1.getRowCount() == 0) {
			AlertDialog.showInfoDialog(Strings.getString("MainFrame.firstMessageReached"));			
			return null;		
		}
		int row = jTable1.getSelectedRow();
		if (row == -1) {
			row = 0;
		} else {
			row--;
			if(row == -1) {
				AlertDialog.showInfoDialog(Strings.getString("MainFrame.firstMessageReached"));				
				return null;
			}				
		}
		jTable1.setRowSelectionInterval(row, row);
		callOpenMessage(mf);
		return null;
/*				
		jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
		return (String) jTable1.getValueAt(row, MessageTableColumns.COL_ID);
*/		
	}

	public MessageRow currentMessage(MessageFrame mf) {
		if(jTable1.getRowCount() == 0)
			return null;		
		int row = jTable1.getSelectedRow();
		if (row == -1) {
			row = 0;
			jTable1.setRowSelectionInterval(row, row);			
		}
		callOpenMessage(mf);
		return null;
/*				
		jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
		return (String) jTable1.getValueAt(row, MessageTableColumns.COL_ID);
*/		
	}
		
	public MessageRow firstMessage(MessageFrame mf) {
		if(jTable1.getRowCount() == 0)
			return null;
		int row = 0;
		jTable1.setRowSelectionInterval(row, row);
		callOpenMessage(mf);
		return null;
/*				
		jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
		return (String) jTable1.getValueAt(row, MessageTableColumns.COL_ID);
*/		
	}

	public MessageRow lastMessage(MessageFrame mf) {
		if(jTable1.getRowCount() == 0)
			return null;
		int row = jTable1.getRowCount() - 1;
		jTable1.setRowSelectionInterval(row, row);
		callOpenMessage(mf);
		return null;
/*				
		jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
		return (String) jTable1.getValueAt(row, MessageTableColumns.COL_ID);
*/		
	}
	
	public void handleRequest(URL url) {
		if(url.getHost().equalsIgnoreCase("mainframe.gui.olivamail")) {
			switch(url.getPort()) {
			case 1:
				// Toggle receiving (HDR_FORCED)
				changeSelMsgHdr(MessageRow.MESSAGES_FLAGS_SET);
				break;
			case 2:
				receiveDefault();
				break;
			case 3:
				// Toggle receiving (HDR_FORCED) and load from server
				changeSelMsgHdr(MessageRow.MESSAGES_FLAGS_SET);				
				receiveDefault();
				break;
			case 4:
				//fwd as att separate
				break;				
			case 5:
				//fwd as att in one
				break;				
			}
		}
	}
	
	protected synchronized void callOpenMessage(MessageFrame mf) {
		try {
			// Context.unsetTrayNewMsg();
			if (jTable1.getRowCount() == 0)
				return;
			int row = jTable1.getSelectedRow();
			if (row == -1) {
				row = 0;
				jTable1.setRowSelectionInterval(row, row);
			}

			/*
			 * String seen = (String) jTable1.getValueAt(row,
			 * MessageTableColumns.COL_SEEN); String id = (String)
			 * jTable1.getValueAt(row, MessageTableColumns.COL_ID); MessageRow
			 * mr = null; try { mr = Context.storage.getMessageRow(id); } catch
			 * (Exception exc) { exc.printStackTrace();
			 * AlertDialog.showErrorDialog(exc); return; }
			 */
			
			MessageRow mr = mtm.getMessageRowAt(row);
			mr = MessageContext.prepareMessageForOpen(mr, this);
			if (mr == null)
				return;
/*			
			boolean imapMsgLoaded = false;
			IFolder iFolder = getCurrentImapFolder();
			// Load IMAP Message if it is just a header
			Account acnt = null;
			if(iFolder != null)
				acnt = Context.storage.getAccount(iFolder.acntId);
			if (!Context.workOffline && acnt != null && acnt.isOnline() && mr.isHeader()) {
				javax.mail.Message[] messages = null;
				try {
					messages = IMAPContext.getMessages(iFolder, false,
							new String[] { mr.msgUid });
				} catch (Exception exc) {
					if (!Context.gonnaWorkOffline(exc, acnt))
						throw exc;
				}
				if (messages != null) {
					Context.storage.saveMessageSource(mr.id, messages[0]);
					mr = Context.storage.getMessageRow(mr.id);
					mtm.setMessageRowAt(mr, row);
					imapMsgLoaded = true;
				}
			}

			if (imapMsgLoaded) {
				// NONE
			} else if (mr.folderId.equals(Context.getTrashFolder())
					&& mr.isHeader()) {
				AlertDialog
						.showInfoDialog(
								Strings
										.getString(
												"MessageFrame.justHeaderTrash").replaceAll("\\$1", "http://mainframe.gui.olivamail:1").replaceAll("\\$2", "http://mainframe.gui.olivamail:2").replaceAll("\\$3", "http://mainframe.gui.olivamail:3"), this);
				return;
			} else if (mr.hdr == MessageRow.HDR_HDR) {
				AlertDialog
						.showInfoDialog(
								Strings
										.getString("MessageFrame.justHeader").replaceAll("\\$1", "http://mainframe.gui.olivamail:1").replaceAll("\\$2", "http://mainframe.gui.olivamail:2").replaceAll("\\$3", "http://mainframe.gui.olivamail:3"), this);
				return;
			} else if (mr.hdr == MessageRow.HDR_FORCED) {
				AlertDialog
						.showInfoDialog(
								Strings
										.getString(
												"MessageFrame.justHeaderForced").replaceAll("\\$1", "http://mainframe.gui.olivamail:1").replaceAll("\\$2", "http://mainframe.gui.olivamail:2").replaceAll("\\$3", "http://mainframe.gui.olivamail:3"), this);
				return;
			}
*/			
			
			// For partial messages (Start)
			if (mr.hdr == MessageRow.HDR_MULTI) {
				javax.mail.Message message = Context.storage.loadMessage(mr.id);
				olivamail.core.mail.Header props = MailUtils.parseMimeHeader(
						"content-type", message.getContentType());
				String partialId = props.getAttribute("id");
				int partialTotal = Integer
						.parseInt(props.getAttribute("total"));
				Vector messages = Context.storage.getMessageList(mr.folderId,
						"HDR = '" + MessageRow.HDR_MULTI
								+ "' and ADDR_FROM = '" + mr.addrFrom + "'",
						null, -1);
				String ids[] = new String[partialTotal];
				int count = 0;
				for (Enumeration en = messages.elements(); en.hasMoreElements();) {
					MessageRow mrow = (MessageRow) en.nextElement();
					javax.mail.Message rowMessage = Context.storage
							.loadMessage(mrow.id);
					Header rowProps = MailUtils.parseMimeHeader("content-type",
							rowMessage.getContentType());
					String rowPartialId = rowProps.getAttribute("id");
					int rowPartialNumber = Integer.parseInt(rowProps
							.getAttribute("number"));
					if (rowPartialId.equals(partialId)) {
						ids[rowPartialNumber - 1] = mrow.id;
						count++;
					}
				}
				boolean glue = true;
				if (count != partialTotal) {
					// AlertDialog.showWarningDialog(Strings.getString("MessageFrame.notAllParts"));
					//
					glue = false;
				}

				// If all parts was found
				if (glue) {
					ByteArrayOutputStream baos = new ByteArrayOutputStream(
							512 * 1024);
					for (int i = 0; i < count; i++) {
						InputStream is = Context.storage.loadMessage(ids[i])
								.getInputStream();
						byte[] buffer = new byte[16384];
						int c = -1;
						while ((c = is.read(buffer)) != -1) {
							baos.write(buffer, 0, c);
						}
						baos.flush();
					}
					Session session = Session.getDefaultInstance(System
							.getProperties());
					ByteArrayInputStream bais = new ByteArrayInputStream(baos
							.toByteArray());
					MimeMessage partialMessage = new MimeMessage(session, bais);
					// Context.storage.setMessageSeen(id, true);
					String cp = Context.storage.getMessageCodepage(mr.id);
					olivamail.core.mail.Message msg = Context.mailBean
							.getMessage(partialMessage, cp);
					String id = Context.storage.saveMessage(msg, mr.folderId,
							partialMessage, "".hashCode(), null, null, null);
					mr = Context.storage.getMessageRow(id);
					mtm.addRow(mr);

					// Remove all parts because the glued message was saved
					for (int i = 0; i < count; i++) {
						Context.storage.deleteMessage(ids[i], true);
						for (int j = 0; j < jTable1.getRowCount(); j++) {
							String idj = mtm.getMessageRowAt(j).id;
							if (idj.equals(ids[i])) {
								/*
								 * DefaultTableModel dtm = (DefaultTableModel)
								 * jTable1.getModel(); dtm.removeRow(j);
								 */
								mtm.removeRow(j);
								break;
							}
						}
					}
					// Find glued message in JTable
					for (int j = 0; j < jTable1.getRowCount(); j++) {
						String idj = mtm.getMessageRowAt(j).id;
						if (idj.equals(mr.id)) {
							row = j;
							jTable1.setRowSelectionInterval(j, j);
							break;
						}
					}
				}
			}
			// For partial messages (End)

			if (mf == null)
				mf = new MessageFrame();
			//mf.setMainFrame(this);
			//mf.setParent(this, jTable1, row);
			mf.setVisible(true);
			mf.showMessageRow(mr);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
			return;
		}
	}	
	
	void callCompose() {
		try {
			Account acnt = Context.storage.getDefaultAccount();
			if (acnt == null) {
				if(AlertDialog.showConfirmDialog(Strings.getString("MainFrame.noAccount"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION)
					return;
				showAccounts();
				return;
			}			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
			return;
		}
		ComposeFrame cf = new ComposeFrame();
		cf.setVisible(true);
		cf.performAction(ComposeFrame.ACTION_NEW);
	}

	protected synchronized void deleteMessages(boolean noTrash, int operation) {
		Cursor oldCursor = getCursor();

		int rows[] = jTable1.getSelectedRows();
		String ids[] = new String[rows.length];

		for (int i = 0; i < rows.length; i++) {
			ids[i] = mtm.getMessageRowAt(rows[i]).id;
		}
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));

			if (changeImapMessagesFlag(rows, Flags.Flag.DELETED, operation))
				return;

			for (int i = ids.length - 1; i >= 0; i--) {
				if (Context.storage.getMessageRow(ids[i]).folderId
						.compareTo(Context.getTrashFolder()) == 0)
					Context.storage.deleteMessage(ids[i], true);
				else {
					if (noTrash)
						Context.storage.deleteMessage(ids[i], true);
					else
						Context.storage.moveMessage(ids[i], Context
								.getTrashFolder());
				}
				mtm.removeRow(rows[i]);
			}
			// listMessages();
			updateFldNewMsgInfo();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {
			setCursor(oldCursor);
		}

	}
	
	public synchronized void move(Folder destFolder, boolean copy) {
		if (destFolder == null)
			return;
		int rows[] = jTable1.getSelectedRows();
		boolean warnHeader = true;
		Cursor oldCursor = getCursor();		
		try {
			IFolder destIFolder = null;		
			if(destFolder.getFType() == Folder.FTYPE_IMAP) {
				destIFolder = Context.storage.getImapFolder(destFolder.getId());
				if(!destIFolder.holdsMessages()) {
					AlertDialog.showWarningDialog(Strings
							.getString("MainFrame.cannotHoldsMessages"));				
					return;
				}
			}
						
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			IFolder sourceIFolder = getCurrentImapFolder();

			if (sourceIFolder != null && destIFolder != null) {
				// Source and destination are IMAP folders							

				Account sAcnt = Context.storage
						.getAccount(sourceIFolder.acntId);
				Account dAcnt = Context.storage.getAccount(destIFolder.acntId);

				for (int i = rows.length - 1; i >= 0; i--) {

					MessageRow mr = mtm.getMessageRowAt(rows[i]);
					boolean sOffline = true;
					boolean dOffline = true;
					javax.mail.Message sMessage = null;

					if (!Context.workOffline) {
						// try {
						if (destIFolder.acntId.equals(sourceIFolder.acntId)) {
							// Move inside the same IMAP server

							if (sAcnt.isOnline()) {
								try {
									try {
										IMAPContext
												.operateMessages(
														sourceIFolder,
														false,
														new String[] { mr.msgUid },
														(copy) ? MessageRow.MESSAGES_COPY
																: MessageRow.MESSAGES_MOVE,
														null, destIFolder, null);
									} catch (MessageRemovedException mre) {
										mre.printStackTrace();
										Context.storage.deleteMessage(mr.id, true);
										mtm.removeRow(rows[i]);
										continue;
									}									
									sOffline = false;
									dOffline = false;
								} catch (Exception exc) {
									if (!Context.gonnaWorkOffline(exc, sAcnt))
										throw exc;
								}
							}
						} else {
							// Move between different IMAP servers

							// Get message from IMAP source
							if (!mr.isHeader()) {
								sMessage = Context.storage.loadMessage(mr.id);
							}
							if (sMessage == null && sAcnt.isOnline()) {
								try {
									sMessage = IMAPContext.getMessage(
											sourceIFolder, false, mr.msgUid);
								} catch (Exception exc) {
									if (!Context.gonnaWorkOffline(exc, sAcnt))
										throw exc;
								}
							}

							if (sMessage == null) {
								warnHeader = showSkipAlert(mr, warnHeader);
								continue;
							}

							// Append to destination server
							if (dAcnt.isOnline()) {
								try {
									IMAPContext
											.operateMessages(
													destIFolder,
													false,
													null,
													MessageRow.MESSAGES_APPEND,
													null,
													null,
													new javax.mail.Message[] { sMessage });
									dOffline = false;
								} catch (Exception exc) {
									if (!Context.gonnaWorkOffline(exc, dAcnt))
										throw exc;
								}
							}

							// Delete from source server
							if (!copy && mr.dmStat != MessageRow.DM_NEW) {
								if (sAcnt.isOnline()) {
									try {
										try {
											IMAPContext
													.operateMessages(
															sourceIFolder,
															false,
															new String[] { mr.msgUid },
															MessageRow.MESSAGES_FLAGS_SET,
															Flags.Flag.DELETED,
															null, null);
										} catch (MessageRemovedException mre) {
											mre.printStackTrace();
											Context.storage.deleteMessage(mr.id, true);
											mtm.removeRow(rows[i]);
											continue;
										}																			
										sOffline = false;
									} catch (Exception exc) {
										if (!Context.gonnaWorkOffline(exc,
												sAcnt))
											throw exc;
									}
								}
							}
						}
						/*
						 * } catch (Exception exc) { if
						 * (!Context.gonnaWorkOffline(exc)) throw exc; }
						 */
					}

					// Storage and JTable staff
					// if(Context.workOffline) {
					if (dOffline) {
						if (mr.isHeader()) {
							if (sMessage != null) {
								Context.storage.saveMessageSource(mr.id,
										sMessage);
								mr = Context.storage.getMessageRow(mr.id);
								mtm.setMessageRowAt(mr, rows[i]);
							} else {
								warnHeader = showSkipAlert(mr, warnHeader);
								continue;
							}
						}

						Context.storage.copyMessage(mr.id, destIFolder.getId(),
								true);
					}

					if (!copy) {
						if (mr.dmStat == MessageRow.DM_NEW) {
							Context.storage.deleteMessage(mr.id, true);
							mtm.removeRow(rows[i]);
						} else {
							mr.sfDel = true;
							if (sOffline)
								mr.dmStat = MessageRow.DM_FLAG;
							Context.storage.saveMessageState(mr);
							mtm.setMessageRowAt(mr, rows[i]);
						}
					}
				}
			} else if (sourceIFolder == null && destIFolder != null) {
				// Source is local and destination is IMAP

				Account dAcnt = Context.storage.getAccount(destIFolder.acntId);

				for (int i = rows.length - 1; i >= 0; i--) {
					boolean dOffline = true;
					MessageRow mr = mtm.getMessageRowAt(rows[i]);
					if (mr.isHeader()) {
						warnHeader = showSkipAlert(mr, warnHeader);
						continue;
					}

					// Append to destination server
					if (!Context.workOffline && dAcnt.isOnline()) {
						try {
							IMAPContext.operateMessages(destIFolder, false,
									null, MessageRow.MESSAGES_APPEND, null,
									null,
									new javax.mail.Message[] { Context.storage
											.loadMessage(mr.id) });
							dOffline = false;
						} catch (Exception exc) {
							if (!Context.gonnaWorkOffline(exc, dAcnt))
								throw exc;
						}
					}

					// Storage and JTable staff
					if (dOffline) {
						Context.storage.copyMessage(mr.id, destIFolder.getId(),
								true);
					}
					if (!copy) {
						Context.storage.deleteMessage(mr.id, true);
						mtm.removeRow(rows[i]);
					}
				}
			} else if (sourceIFolder != null && destIFolder == null) {
				// Source is IMAP and destination is local

				Account sAcnt = Context.storage
						.getAccount(sourceIFolder.acntId);

				for (int i = rows.length - 1; i >= 0; i--) {
					boolean sOffline = true;
					boolean dOffline = true;					
					javax.mail.Message sMessage = null;					
					MessageRow mr = mtm.getMessageRowAt(rows[i]);

					if (!Context.workOffline && sAcnt.isOnline()) {
						// Get message from IMAP source
						if (!mr.isHeader()) {
							sMessage = Context.storage.loadMessage(mr.id);
						}
						if (sMessage == null) {
							try {
								sMessage = IMAPContext.getMessage(
										sourceIFolder, false, mr.msgUid);
							} catch (Exception exc) {
								if (!Context.gonnaWorkOffline(exc, sAcnt))
									throw exc;
							}
						}

						if (sMessage == null) {
							warnHeader = showSkipAlert(mr, warnHeader);
							continue;
						}

						// Append to local folder
						//Not included sMessage.getFlags() To prevent deleted message in local folder
						Context.storage.saveMessage(Context.mailBean
								.getMessageHeader(sMessage, mr.codepage),
								destFolder.getId(), sMessage, "".hashCode(),
								null, mr.codepage, null);

						dOffline = false;

						// Delete from source server
						if (!copy && mr.dmStat != MessageRow.DM_NEW) {
							if (sAcnt.isOnline()) {
								try {
									try {
										IMAPContext.operateMessages(
												sourceIFolder, false,
												new String[] { mr.msgUid },
												MessageRow.MESSAGES_FLAGS_SET,
												Flags.Flag.DELETED, null, null);
									} catch (MessageRemovedException mre) {
										mre.printStackTrace();
										Context.storage.deleteMessage(mr.id, true);
										mtm.removeRow(rows[i]);
										continue;
									}																		
									sOffline = false;
								} catch (Exception exc) {
									if (!Context.gonnaWorkOffline(exc, sAcnt))
										throw exc;
								}
							}
						}
					}

					// Storage and JTable staff
					if (dOffline) {
						if (mr.isHeader()) {
							if (sMessage != null) {
								Context.storage.saveMessageSource(mr.id,
										sMessage);
								mr = Context.storage.getMessageRow(mr.id);
								mtm.setMessageRowAt(mr, rows[i]);
							} else {
								warnHeader = showSkipAlert(mr, warnHeader);
								continue;
							}
						}

						Context.storage.copyMessage(mr.id, destFolder.getId(), false);
					}

					if (!copy) {
						if (mr.dmStat == MessageRow.DM_NEW) {
							Context.storage.deleteMessage(mr.id, true);
							mtm.removeRow(rows[i]);
						} else {
							mr.sfDel = true;
							if (sOffline)
								mr.dmStat = MessageRow.DM_FLAG;
							Context.storage.saveMessageState(mr);
							mtm.setMessageRowAt(mr, rows[i]);
						}
					}
				}
			} else {
				// Source and destination are local

				// Storage and JTable staff (For completly local operations)
				for (int i = rows.length - 1; i >= 0; i--) {
					MessageRow mr = mtm.getMessageRowAt(rows[i]);
					if (copy)
						Context.storage.copyMessage(mr.id, destFolder.getId(),
								false);
					else {
						Context.storage.moveMessage(mr.id, destFolder.getId());
						mtm.removeRow(rows[i]);
					}
				}
			}

			updateFldNewMsgInfo();
		} catch (OperationCancelledException exc) {
			updateFldNewMsgInfo();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {					
			setCursor(oldCursor);
		}
	}

	private boolean showSkipAlert(MessageRow mr, boolean warnHeader) throws Exception {
		if (warnHeader) {
			int response = AlertDialog
					.showWarningDialog(
							Strings
									.getString(
											"MessageRow.skipHeader")
									.replaceAll(
											"\\$from",
											mr.addrFrom)
									.replaceAll(
											"\\$subject",
											mr.subject),
							AlertDialog.YES_NO_CANCEL_OPTION);
			if (response == AlertDialog.CANCEL_OPTION)
				throw new OperationCancelledException();
			warnHeader = (response == AlertDialog.YES_OPTION);
		}
		return warnHeader;
	}
	
	void jComboBox2_actionPerformed(ActionEvent e) {
		listMessages();
	}

	void showAccounts() {
		AccountsFrame af = new AccountsFrame();
		af.setVisible(true);
		af.listAccounts();
	}

	/**
	 * This method initializes jButton9
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJbMoveMessages() {
		if (jbMoveMessages == null) {
			jbMoveMessages = new JButton();
			jbMoveMessages.setText(Strings.getString("MainFrame.moveButton"));
			jbMoveMessages.setIcon(Context.getImageIcon("move.gif"));
			jbMoveMessages.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					callMoveMessages(false);
				}
			});
		}
		return jbMoveMessages;
	}

	public synchronized void callMoveMessages(boolean copy) {
		int rows[] = jTable1.getSelectedRows();
		if (rows.length == 0)
			return;
/*		
		FolderChoseFrame fcf = new FolderChoseFrame();
		fcf.setParent(this);
		fcf.setVisible(true);
*/
		Object folderObject = FoldersTreeFrame.selectFolder();
		if(folderObject == null)
			return;
		if(!(folderObject instanceof Folder))
			return;
		Folder folder = (Folder)folderObject;
		move(folder, copy);
	}

	/**
	 * This method initializes jTextPane1	
	 * 	
	 * @return javax.swing.JTextPane	
	 */    
	private JTextPane getFolderInfoPane() {
		if (folderInfoPane == null) {
			folderInfoPane = new JTextPane();
			folderInfoPane.setContentType("text/html");
			folderInfoPane.setBackground(new java.awt.Color(0,51,153));
		}
		return folderInfoPane;
	}	
	
	/**
	 * This method initializes jScrollPane3	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getFolderMessageInfoScroll() {
		if (folderMessageInfoScroll == null) {
			folderMessageInfoScroll = new JScrollPane();
			folderMessageInfoScroll.setViewportView(getFolderInfoPane());
		}
		return folderMessageInfoScroll;
	}
		
	/**
	 * This method initializes jSplitPane2	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */    
	private JSplitPane getMessagesSplit() {
		if (MessagesSplit == null) {
			MessagesSplit = new JSplitPane();
			MessagesSplit.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
			if (Context.isShowMessageInline()) { 
				MessagesSplit.setDividerLocation(DIV_LOC_INLINE);
			} else {
				MessagesSplit.setDividerSize(DIV_SIZE_NORMAL);
				MessagesSplit.setDividerLocation(DIV_LOC_NORMAL);				
			}							
			MessagesSplit.setTopComponent(getJScrollPane1());
			MessagesSplit.setBottomComponent(getFolderMessageInfoScroll());			
		}
		return MessagesSplit;
	}	
	
	/**
	 * This method initializes jSplitPane1
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getTreeSplit() {
		if (TreeSplit == null) {
			TreeSplit = new JSplitPane();
			TreeSplit.setDividerLocation(200);
			TreeSplit.setLeftComponent(getJScrollPane2());
			TreeSplit.setRightComponent(getMessagesSplit());
			//jSplitPane1.setRightComponent(getJScrollPane1());
		}
		return TreeSplit;
	}

	/**
	 * This method initializes jJMenuBar1
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJMainMenuBar() {
		if (jMainMenuBar == null) {
			jMainMenuBar = new JMenuBar();
			jMainMenuBar.add(getJMenuFile());
			jMainMenuBar.add(getJMenu2());
			jMainMenuBar.add(getJMenuService());
			jMainMenuBar.add(getJMenuMessages());
			jMainMenuBar.add(getJMenuFolders());
			jMainMenuBar.add(getJMenuDeliver());
			jMainMenuBar.add(getJMenu5());			
		}
		return jMainMenuBar;
	}

	/**
	 * This method initializes jMenu1
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText(Strings.getString("menuFile"));
			jMenuFile.add(getJmiWorkOffline());
			jMenuFile.addSeparator();
			jMenuFile.add(getJMenuItem1());
		}
		return jMenuFile;
	}

	/**
	 * This method initializes jMenuItem1
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem1() {
		if (jmiExit == null) {
			jmiExit = new JMenuItem();
			jmiExit.setText(Strings.getString("menuClose"));
			jmiExit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					callExit();
				}
			});
		}
		return jmiExit;
	}

	/**
	 * This method initializes jMenu2
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu2() {
		if (jMenuSettings == null) {
			jMenuSettings = new JMenu();
			jMenuSettings.setText(Strings.getString("MainFrame.settingsMenu"));
			jMenuSettings.add(getJMenuItem2());
			jMenuSettings.add(getJmiColLayout());
			jMenuSettings.add(getJMenuItem6());
			jMenuSettings.add(getJMenuItem9());
		}
		return jMenuSettings;
	}

	/**
	 * This method initializes jMenuItem2
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem2() {
		if (jmiAccounts == null) {
			jmiAccounts = new JMenuItem();
			jmiAccounts.setText(Strings.getString("MainFrame.accountMenuItem"));
			jmiAccounts.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					showAccounts();
				}
			});
		}
		return jmiAccounts;
	}

	/**
	 * This method initializes jMenu3
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuMessages() {
		if (jMenuMessages == null) {
			jMenuMessages = new JMenu();
			jMenuMessages.setText(Strings.getString("MainFrame.messagesMenu"));
			jMenuMessages.add(getJmiMsgOpen());
			jMenuMessages.add(getJmiMsgMove());
			jMenuMessages.add(getJmiCopyMsgs());
			jMenuMessages.add(getJmiMsgDelete());
			jMenuMessages.add(getJmiMsgDeleteNoTrash());
			jMenuMessages.add(getJmiMsgInvertSel());
			jMenuMessages.add(getJmMsgToggle());
			jMenuMessages.add(getJmiMsgCodepage());
			jMenuMessages.add(getJmiMsgShowPics());
			jMenuMessages.addSeparator();
			jMenuMessages.add(getJmiForward());			
			jMenuMessages.add(getJmiSaveAllAtt());
			jMenuMessages.addSeparator();
			jMenuMessages.add(getJmiMsgSelAll());
			jMenuMessages.add(getJmiMsgRefresh());
			jMenuMessages.add(getJmiMsgExport());
		}
		return jMenuMessages;
	}

	/**
	 * This method initializes jMenuItem3
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJmiMsgOpen() {
		if (jmiMsgOpen == null) {
			jmiMsgOpen = new JMenuItem();
			jmiMsgOpen.setText(Strings.getString("MainFrame.openMenuItem"));
			jmiMsgOpen.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					callOpenMessage(null);
				}
			});
		}
		return jmiMsgOpen;
	}

	/**
	 * This method initializes jMenuItem4
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJmiMsgMove() {
		if (jmiMsgMove == null) {
			jmiMsgMove = new JMenuItem();
			jmiMsgMove.setText(Strings.getString("MainFrame.moveMenuItem"));
			jmiMsgMove.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					callMoveMessages(false);
				}
			});
		}
		return jmiMsgMove;
	}

	/**
	 * This method initializes jMenuItem5
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJmiMsgDelete() {
		if (jmiMsgDelete == null) {
			jmiMsgDelete = new JMenuItem();
			jmiMsgDelete.setText(Strings.getString("MainFrame.deleteMenuItem"));
			jmiMsgDelete.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					deleteMessages(false, MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jmiMsgDelete;
	}

	/**
	 * This method initializes jMenuItem6
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem6() {
		if (jmiFolders == null) {
			jmiFolders = new JMenuItem();
			jmiFolders.setText(Strings.getString("MainFrame.foldersMenuItem"));
			jmiFolders.setEnabled(false);
			jmiFolders.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					FoldersFrame ff = new FoldersFrame();
					ff.setParent(Context.mainFrame);
					ff.setVisible(true);
					ff.listFolders();
				}
			});
		}
		return jmiFolders;
	}

	/**
	 * This method initializes jMenu4
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuService() {
		if (jMenuService == null) {
			jMenuService = new JMenu();
			jMenuService.setText(Strings.getString("MainFrame.serviceMenu"));
			jMenuService.add(getJMenuItem7());
			jMenuService.add(getJMenuItem15());
			jMenuService.add(getJMenuItem17());
			jMenuService.add(getJMenuItem8());
			jMenuService.add(getJMenuItem13());
			jMenuService.addSeparator();
			jMenuService.add(getJmiInfo());
			jMenuService.add(getJmiSqlQuery());
		}
		return jMenuService;
	}

	/**
	 * This method initializes jMenuItem7
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem7() {
		if (jmiAddresses == null) {
			jmiAddresses = new JMenuItem();
			jmiAddresses.setText(Strings.getString("MainFrame.addrBookMenuItem"));
			jmiAddresses.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					AddressesFrame af = new AddressesFrame();
					af.setVisible(true);
					af.listAddresses();
				}
			});
		}
		return jmiAddresses;
	}

	/**
	 * This method initializes jMenuItem8
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem8() {
		if (jmiMime == null) {
			jmiMime = new JMenuItem();
			jmiMime
					.setText(Strings.getString("MainFrame.mimeTypesMenuItem"));
			jmiMime.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					MimesFrame mf = new MimesFrame();
					mf.setVisible(true);
					mf.listGroups();
				}
			});
		}
		return jmiMime;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getButtonsPanel() {
		if (buttonsPanel == null) {
			buttonsPanel = new JPanel();
			buttonsPanel.add(getJbCompose(), null);
			buttonsPanel.add(getJbReceiveDefault(), null);
			buttonsPanel.add(getJbSend(), null);
			buttonsPanel.add(getJbOpenMessage(), null);
			buttonsPanel.add(getJbMoveMessages(), null);
			buttonsPanel.add(getJbDeleteMessages(), null);
		}
		return buttonsPanel;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getManagementPanel() {
		if (managementPanel == null) {
			jsSpacer1 = new JLabel();
			jsSpacer1.setText("");
			jsSpacer1.setPreferredSize(new java.awt.Dimension(50,16));
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			folderLabel = new JLabel();
			folderLabel.setText("");
			folderLabel.setForeground(java.awt.Color.white);
			folderLabel.setPreferredSize(new java.awt.Dimension(200, 20));
			folderLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD,
					14));
			managementPanel = new JPanel();
			managementPanel.setBackground(java.awt.Color.gray);
			managementPanel.setBorder(javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.white, 1));
			managementPanel.setLayout(flowLayout);
			managementPanel.add(folderLabel, null);
			managementPanel.add(getJComboBox2(), null);
			managementPanel.add(jsSpacer1, null);
			managementPanel.add(getJtfSearch(), null);
			managementPanel.add(getJbSearch(), null);
		}
		return managementPanel;
	}

	/**
	 * This method initializes jMenuItem9	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem9() {
		if (jmiSettings == null) {
			jmiSettings = new JMenuItem();
			jmiSettings.setText(Strings.getString("MainFrame.menuSettings"));
			jmiSettings.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					SettingsFrame sf = new SettingsFrame(Context.mainFrame);
					sf.setVisible(true);
					sf.getSettings();
				}
			});
		}
		return jmiSettings;
	}

	/**
	 * This method initializes jMenu5	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu5() {
		if (jMenuHelp == null) {
			jMenuHelp = new JMenu();
			jMenuHelp.setText(Strings.getString("menuHelp"));
			jMenuHelp.add(getJMenuItem10());
		}
		return jMenuHelp;
	}

	/**
	 * This method initializes jMenuItem10	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem10() {
		if (jmiAbout == null) {
			jmiAbout = new JMenuItem();
			jmiAbout.setText(Strings.getString("menuAbout"));
			jmiAbout.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					AboutFrame af = new AboutFrame();
					af.center();
					af.setModal(true);
					af.setVisible(true);
				}
			});
		}
		return jmiAbout;
	}

	/**
	 * This method initializes jMenuItem11	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgSelAll() {
		if (jmiMsgSelAll == null) {
			jmiMsgSelAll = new JMenuItem();
			jmiMsgSelAll.setText(Strings.getString("MainFrame.selectAllMenuItem"));
			jmiMsgSelAll.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jTable1.selectAll();
				}
			});
		}
		return jmiMsgSelAll;
	}

	/**
	 * This method initializes jMenuFolders	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuFolders() {
		if (jMenuFolders == null) {
			jMenuFolders = new JMenu();
			jMenuFolders.setText(Strings.getString("menuFolders"));
			jMenuFolders.add(getJmiFldCreate());
			jMenuFolders.add(getJmiFldMove());
			jMenuFolders.add(getJmiFldDelete());
			jMenuFolders.add(getJmiFldProps());			
			jMenuFolders.addSeparator();
			jMenuFolders.add(getJmiImapExpunge());
			jMenuFolders.add(getJmiImapSubscr());
		}
		return jMenuFolders;
	}

	/**
	 * This method initializes jmiFldCreate	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiFldCreate() {
		if (jmiFldCreate == null) {
			jmiFldCreate = new JMenuItem();
			jmiFldCreate.setText(Strings.getString("menuCreate"));
			jmiFldCreate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiFldCreate_actionPerformed(e);
				}
			});
		}
		return jmiFldCreate;
	}

	void jmiFldCreate_actionPerformed(java.awt.event.ActionEvent e) {
		if (getCurrentFolderId() == null) {
			AlertDialog.showWarningDialog(Strings
					.getString("MainFrame.cannotHoldsFolders"));
			return;
		}
		IFolder iFolder = null;
		try {
			iFolder = getCurrentImapFolder();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
		if (iFolder != null && !iFolder.holdsFolders()) {
			AlertDialog.showWarningDialog(Strings
					.getString("MainFrame.cannotHoldsFolders"));
			return;
		}		
		DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode)jTree1.getSelectionPath().getLastPathComponent();
		if(dmtn == null)
			return;
		if(!(dmtn.getUserObject() instanceof Folder)) {			
			return;
		}
		FolderFormFrame fff = new FolderFormFrame();
		fff.createChildFolder(jTree1, dmtn);
		fff.setVisible(true);		
	}
	
	/**
	 * This method initializes jmiFldMove	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiFldMove() {
		if (jmiFldMove == null) {
			jmiFldMove = new JMenuItem();
			jmiFldMove.setText(Strings.getString("menuMove"));
			jmiFldMove.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiFldMove_actionPerformed(e);
				}
			});
		}
		return jmiFldMove;
	}

	void jmiFldMove_actionPerformed(java.awt.event.ActionEvent e) {
		
	}
	
	/**
	 * This method initializes jmiDelete	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiFldDelete() {
		if (jmiFldDelete == null) {
			jmiFldDelete = new JMenuItem();
			jmiFldDelete.setText(Strings.getString("menuDelete"));
			jmiFldDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiFldDelete_actionPerformed(e);
				}
			});
		}
		return jmiFldDelete;
	}

	public void folderDelete(DefaultMutableTreeNode dmtn) {		
		if (dmtn == null)
			return;
		if(!(dmtn.getUserObject() instanceof Folder)) {			
			return;
		}		
		boolean startTimer = false;		
		try {
			olivamail.gui.Folder folder = (olivamail.gui.Folder) dmtn
					.getUserObject();
			if (AlertDialog
					.showConfirmDialog(
							Strings.getString("FoldersFrame.deleteFolder").
							replaceFirst("\\$1", folder.getDisplayName()),
							AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION)
				return;
			
			IFolder iFolder = getCurrentImapFolder();
			if(iFolder != null) {
				//IMAPContext.deleteFolder(iFolder);
				try {
					IMAPContext.operateFolder(iFolder,
							IMAPContext.FOLDER_DELETE);
				} catch (javax.mail.FolderNotFoundException fnfe) {
					if (AlertDialog
							.showConfirmDialog(Strings.getString(
									"MainFrame.deleteMissIFolder")
									.replaceFirst("\\$name", iFolder.name),
									AlertDialog.YES_NO_OPTION) == AlertDialog.NO_OPTION)
						return;
				}
			}
			
			if (!Context.storage.isFolderEmpty(folder.getId())) {
				if (iFolder == null && AlertDialog
						.showConfirmDialog(
								Strings
										.getString("FoldersFrame.folderNotEmpty"), AlertDialog.YES_NO_OPTION) != AlertDialog.YES_OPTION)
					return;
				startTimer = stopTimer();
				Context.storage.deleteFolderContent(folder.getId());
			}
			Context.storage.deleteFolder(folder.getId());
			dmtn.removeFromParent();
			//jTree1.updateUI();
			updateFldNewMsgInfo();
			Context.loadFolders();
			listMessages();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {
			if(startTimer)
				startTimer();
		}		
	}
	
	void jmiFldDelete_actionPerformed(java.awt.event.ActionEvent e) {
		DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode) jTree1
				.getSelectionPath().getLastPathComponent();
		folderDelete(dmtn);
	}
	
	public boolean stopTimer() {
		if(timer == null || !timer.isRunning())
			return false;
		timer.stop();
		return true;
	}

	public boolean startTimer() {
		if(timer != null && timer.isRunning())
			return false;
		timer.start();
		return true;
	}	
	
	/**
	 * This method initializes jmiFldProps	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiFldProps() {
		if (jmiFldProps == null) {
			jmiFldProps = new JMenuItem();
			jmiFldProps.setText(Strings.getString("menuProperties"));
			jmiFldProps.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiFldProps_actionPerformed(e);
				}
			});
		}
		return jmiFldProps;
	}
	
	public void folderProperties(DefaultMutableTreeNode dmtn) {
		if(dmtn == null)
			return;
		if(!(dmtn.getUserObject() instanceof Folder)) {			
			return;
		}		
		FolderFormFrame fff = new FolderFormFrame();
		fff.editFolder(jTree1, dmtn);
		fff.setVisible(true);						
	}
	
	void jmiFldProps_actionPerformed(java.awt.event.ActionEvent e) {
		DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode)jTree1.getSelectionPath().getLastPathComponent();
		folderProperties(dmtn);
	}

	void showFolderMessageInfo() {
		refreshStatusBarText(false);
			
		int row = jTable1.getSelectedRow();
		if (row == -1) {
			//jTextPane1.setText("");
			showFolderInfo();
			return;
		}
		MessageRow mr = mtm.getMessageRowAt(row);

		try {
			if (Context.isShowMessageInline()) {
				
				if (mr.hdr == MessageRow.HDR_COMPLETE) {
					if(!(MessagesSplit.getBottomComponent() instanceof MessageView)) {
						if(messageView1 == null)
							messageView1 = new MessageView();						
						int divPos = MessagesSplit.getDividerLocation();					
						MessagesSplit.setBottomComponent(messageView1);
						MessagesSplit.setDividerLocation(divPos);					
					}					
					messageView1.showMessageRow(mr);
					if (!mr.sfSeen)
						mtm.getMessageRowAt(row).sfSeen = true;
						//jTable1.setValueAt(MessageRow.SEEN_READ, row, MessageTableColumns.COL_SEEN);
					checkShowPics();
				} else {
					if(!(MessagesSplit.getBottomComponent() instanceof JScrollPane)) {
						int divPos = MessagesSplit.getDividerLocation();					
						MessagesSplit.setBottomComponent(getFolderMessageInfoScroll());
						MessagesSplit.setDividerLocation(divPos);					
					}					
					showMessageInfo(mr);
				}
			} else {
				showMessageInfo(mr);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
		}		
	}
	
	private void showMessageInfo(MessageRow mr) throws Exception {
		StringBuffer sb = new StringBuffer();
		sb.append("<html><body>\n");
		sb.append("<table border=\"0\">\n");
		sb.append("<tr><td align=\"center\" valign=\"center\">\n");
		sb.append("<img width=\"96\" height=\"96\" src=\"").append(
				"file://").append(Context.homeDir).append(
				"pics/letter.jpg\">\n");
		sb.append("</td>\n");
		sb.append("<td>\n");
		sb.append("<font face=\"Tahoma, Arial, Verdana\" size=\"3\" color=\"#ffffff\">\n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.from")).append("</strong> ").append(olivamail.core.mail.MailUtils.getHtmlAddressList(getSubstring(mr.addrFrom, -1), null)).append("<br>\n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.to")).append("</strong> ").append(olivamail.core.mail.MailUtils.getHtmlAddressList(getSubstring(mr.addrTo, -1), null)).append("<br>\n");			
		sb.append("<strong>").append(Strings.getString("MessageFrame.subject")).append("</strong> ").append(getSubstring(mr.subject, -1)).append("<br>\n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.sentDate")).append("</strong> ").append(getSubstring(mr.getSentDateDMY(), -1)).append(",   \n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.receivedDate")).append("</strong> ").append(getSubstring(ComUtils.nvl(mr.getReceivedDateDMY()), -1)).append("<br>\n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.msgSize")).append("</strong> ").append(getSubstring(olivamail.core.common.ComUtils.getSizeString(mr.msgSize), -1)).append("<br>\n");
		sb.append("<strong>").append(Strings.getString("MessageFrame.folder")).append("</strong> ").append(getSubstring(Context.storage.getFolder(mr.folderId).getDisplayName(), -1)).append("<br>");						
		sb.append("</font>\n");
		sb.append("</td></tr>\n");
		sb.append("</table\n");
		sb.append("</body></html>");
		folderInfoPane.setText(sb.toString());
		folderInfoPane.setCaretPosition(0);		
	}
	
	public void MessageListSelectionEvent(ListSelectionEvent e) {
		showFolderMessageInfo();
	}
	
	private String getSubstring(String str, int length) {
		if(length == -1)
			length = 255;
		if(str != null && str.length() > length)
			str = str.substring(0, length + 1);		
		return str;
	}

	protected boolean changeImapMessagesFlag(int rows[],
			Flags.Flag flag, int operation) throws Exception {
		IFolder iFolder = getCurrentImapFolder();
		if (iFolder == null)
			return false;

		boolean offline = true;	

		Account acnt = Context.storage.getAccount(iFolder.acntId);		
		
		for (int i = 0; i < rows.length; i++) {
			MessageRow mr = mtm.getMessageRowAt(rows[i]);												
			
			if (mr.dmStat == MessageRow.DM_NEW && mr.willFlagBeSet(Flags.Flag.DELETED, operation)) {
				Context.storage.deleteMessage(mr.id, false);
				mtm.removeRow(rows[i]);
				continue;
			}			
			
			if (!Context.workOffline && acnt.isOnline()) {
				try {
					IMAPContext
							.operateMessages(iFolder, false,
									new String[] { mr.msgUid },
									operation, flag,
									null, null);
					offline = false;
				} catch (Exception exc) {
					if (!Context.gonnaWorkOffline(exc, acnt))
						throw exc;
				}
			}
			
			mr.applyLocallyFlagChange(flag, operation, offline);
			
			Context.storage.saveMessageState(mr);
			mtm.setMessageRowAt(mr, rows[i]);
		}
		
		if (!offline) {
			try {
				IMAPContext.operateFolder(iFolder, IMAPContext.FOLDER_CLOSE);
			} catch (Exception exc) {
				if (!Context.gonnaWorkOffline(exc, acnt))
					throw exc;
			}
		}
		
		return true;
	}

	protected boolean changeImapMessageFlag(MessageRow mr, Flags.Flag flag,
			int operation) throws Exception {
		IFolder iFolder = Context.storage.getImapFolder(mr.folderId);
		if (iFolder == null)
			return false;

		boolean offline = true;

		Account acnt = Context.storage.getAccount(iFolder.acntId);

		if (mr.dmStat == MessageRow.DM_NEW
				&& mr.willFlagBeSet(Flags.Flag.DELETED, operation)) {
			Context.storage.deleteMessage(mr.id, false);
			removeRowIfNeeded(mr);
		} else {

			if (!Context.workOffline && acnt.isOnline()) {
				try {
					IMAPContext.operateMessages(iFolder, true,
							new String[] { mr.msgUid }, operation, flag, null,
							null);
					offline = false;
				} catch (Exception exc) {
					if (!Context.gonnaWorkOffline(exc, acnt))
						throw exc;
				}
			}

			mr.applyLocallyFlagChange(flag, operation, offline);

			Context.storage.saveMessageState(mr);
			updateMessageIfNeeded(mr);
		}

		return true;
	}
		
	protected synchronized void changeSelMsgFlag(Flags.Flag flag, int operation) {
		Cursor oldCursor = getCursor();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			int rows[] = jTable1.getSelectedRows();						
			IFolder iFolder = getCurrentImapFolder();
			
			for (int i = 0; i < rows.length; i++) {
				MessageRow mr = mtm.getMessageRowAt(rows[i]);
				
				if (mr.dmStat == MessageRow.DM_NEW && !mr.sfDel && flag == Flags.Flag.DELETED) {
					Context.storage.deleteMessage(mr.id, false);
					mtm.removeRow(rows[i]);
					continue;
				}			
								
				mr.changeMessageFlag(iFolder, false, flag, operation);				
				Context.storage.saveMessageState(mr);
				mtm.setMessageRowAt(mr, rows[i]);
			}
			
			Account acnt = null;
			if(iFolder != null)
				acnt = Context.storage.getAccount(iFolder.acntId);
			
			if (!Context.workOffline && acnt != null && acnt.isOnline()
					&& flag != Flags.Flag.DELETED) {
				try {
					IMAPContext
							.operateFolder(iFolder, IMAPContext.FOLDER_CLOSE);
				} catch (Exception e) {
					if (!Context.gonnaWorkOffline(e, acnt))
						throw e;
				}
			}
			if (flag == Flags.Flag.SEEN)
				updateFldNewMsgInfo();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {
			setCursor(oldCursor);
		}
	}

	protected synchronized void changeSelMsgHdr(int operation) {
		try {
			int rows[] = jTable1.getSelectedRows();

			for (int i = 0; i < rows.length; i++) {
				MessageRow mr = mtm.getMessageRowAt(rows[i]);
				mr.changeMessageHdr(operation);
				Context.storage.saveMessageState(mr);
				mtm.setMessageRowAt(mr,
						rows[i]);
			}

		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	public void updateFldNewMsgInfo() {
			jTree1.updateUI();
	}
	
	/**
	 * This method initializes jMenuItem13	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem13() {
		if (jmiRules == null) {
			jmiRules = new JMenuItem();
			jmiRules.setText(Strings.getString("MainFrame.rulesMenuItem"));
			jmiRules.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					RulesFrame rf = new RulesFrame();
					rf.setVisible(true);
					rf.listRules();
				}
			});
		}
		return jmiRules;
	}

	/**
	 * This method initializes jMenu6	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuDeliver() {
		if (jMenuDeliver == null) {
			jMenuDeliver = new JMenu();
			jMenuDeliver.setText(Strings.getString("MainFrame.menuDeliver"));
			jMenuDeliver.add(getJmiReceive());
			jMenuDeliver.add(getJMenuReceive());
			jMenuDeliver.add(getJmiReceiveAll());
			jMenuDeliver.add(getJmiSendAll());
			jMenuDeliver.addSeparator();
			jMenuDeliver.add(getJmiCancel());
		}
		return jMenuDeliver;
	}

	/**
	 * This method initializes jMenuItem14	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiReceiveAll() {
		if (jmiReceiveAll == null) {
			jmiReceiveAll = new JMenuItem();
			jmiReceiveAll.setText(Strings.getString("MainFrame.miReceiveAll"));
			jmiReceiveAll.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					MailContext.callReceiveAll();
				}
			});
		}
		return jmiReceiveAll;
	}

	/**
	 * This method initializes jMenuItem15	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSendAll() {
		if (jmiSendAll == null) {
			jmiSendAll = new JMenuItem();
			jmiSendAll.setText(Strings.getString("MainFrame.send"));
			jmiSendAll.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiSendAll_actionPerformed(e);
				}
			});
		}
		return jmiSendAll;
	}

	void jmiSendAll_actionPerformed(java.awt.event.ActionEvent e) {
		MailContext.sendFromOutbox();
	}

	void jMenuReceive_menuSelected(javax.swing.event.MenuEvent e) {
		jMenuReceive.removeAll();
		ReceiveMenu = null;
		populateReceiveMenu();
	}
	
	private void populateReceiveMenu() {
		Vector acnts = null;
		try {
			acnts = Context.storage.getAccountList("STATUS <> '2'", null);
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		if (acnts != null) {
			ReceiveMenu = new Hashtable(acnts.size());
			for (Enumeration en = acnts.elements(); en.hasMoreElements();) {
				Vector row = (Vector)en.nextElement();
				String name = (String) row.elementAt(1);
				JMenuItem jmi = new JMenuItem(name);
				if (((String) row.elementAt(2)).equalsIgnoreCase("D")) {
					jmi.setIcon(Context.getImageIcon("check.png"));
				}
				ReceiveMenu.put(jmi, row.elementAt(0));
				jmi.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						jmiReceiveX_actionPerformed(e);
					}
				});
				jMenuReceive.add(jmi);
			}
		}
	}
	
	/**
	 * This method initializes jMenuReceive
	 * 
	 * @return javax.swing.JMenu
	 */    
	private JMenu getJMenuReceive() {
		if (jMenuReceive == null) {
			jMenuReceive = new JMenu();
			jMenuReceive.setText(Strings.getString("MainFrame.receive"));
			jMenuReceive.addMenuListener(new javax.swing.event.MenuListener() { 
				public void menuSelected(javax.swing.event.MenuEvent e) {    
					jMenuReceive_menuSelected(e);
				}
				public void menuCanceled(javax.swing.event.MenuEvent e) {} 
				public void menuDeselected(javax.swing.event.MenuEvent e) {} 
			});
		}
		return jMenuReceive;
	}
	
	void jmiReceiveX_actionPerformed(ActionEvent e) {
		JMenuItem jmi = (JMenuItem)e.getSource();		
		String id = (String)ReceiveMenu.get(jmi);
		Account acnt = null;
		try {
			acnt = Context.storage.getAccount(id);
			if(!checkImapLoaded(acnt))
				return;
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);			
			return;
		}				
		MailContext.callReceive(acnt, null, true);
	}

	private boolean checkImapLoaded(Account acnt) throws Exception {
		if (acnt.isImap() && Context.storage.getImapRootFolder(acnt.id) == null) {
/*			
			if (isReceiving()) {
				AlertDialog.showWarningDialog(Strings
						.getString("MainFrame.simultReceiving"));
				return false;
			}
*/			
			IMAPFoldersFrame iff = new IMAPFoldersFrame();
			iff.setVisible(true);
			iff.setAccount(acnt);
			iff.listFolders();
			return false;
		}		
		return true;
	}
	
	/**
	 * This method initializes jmiReceive	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiReceive() {
		if (jmiReceive == null) {
			jmiReceive = new JMenuItem();
			jmiReceive.setText(Strings.getString("MainFrame.receive"));
			jmiReceive.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					receiveDefault();
				}
			});
		}
		return jmiReceive;
	}

	void receiveDefault() {		
		Account acnt = null;
		try {
			acnt = Context.storage.getDefaultAccount();
			if (acnt == null) {
				if(AlertDialog.showConfirmDialog(Strings.getString("MainFrame.noAccount"), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION)
					return;
				showAccounts();
				return;
			}
			if(!checkImapLoaded(acnt))
				return;			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
			return;
		}
		MailContext.callReceive(acnt, null, true);				
	}

	/**
	 * This method initializes jmiInfo	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiInfo() {
		if (jmiInfo == null) {
			jmiInfo = new JMenuItem();
			jmiInfo.setText(Strings.getString("MainFrame.miTechInfo"));
			jmiInfo.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiInfo_actionPerformed(e);
				}
			});
		}
		return jmiInfo;
	}

	void jmiInfo_actionPerformed(java.awt.event.ActionEvent e) {
		TechInfoFrame tif = new TechInfoFrame();
		tif.setModal(true);		
		tif.setVisible(true);
	}

	/**
	 * This method initializes jMenuItem14	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgInvertSel() {
		if (jmiMsgInvertSel == null) {
			jmiMsgInvertSel = new JMenuItem();
			jmiMsgInvertSel.setText(Strings.getString("MainFrame.miInvertSel"));
			jmiMsgInvertSel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					invertSelection();
				}
			});
		}
		return jmiMsgInvertSel;
	}
	
	void invertSelection() {
		int rows[] = jTable1.getSelectedRows();
		jTable1.clearSelection();
		int firstRow = 0;
		int lastRow = -1;
		for (int i = 0; i < rows.length; i++) {
			lastRow = rows[i] - 1; 
			if (lastRow - firstRow >= 0)
				jTable1.addRowSelectionInterval(firstRow, lastRow);
			firstRow = rows[i] + 1;
		}
		lastRow = jTable1.getRowCount() - 1;
		if(lastRow - firstRow < 0)
			return;
		jTable1.addRowSelectionInterval(firstRow, lastRow);
	}

	public void updateRow(JTable jTable, int row, Object obj) {
		if (obj == null)
			return;
		if (jTable == null)
			jTable = jTable1;
		if (row == -1)
			return;
		int urow = -1;
		String objId = (String) obj;
		if (jTable.getRowCount() > row) {
			String id = mtm.getMessageRowAt(row).id;
			if (id.equals(objId)) {
				urow = row;
			}
		}
		if (urow == -1) {
			for (int i = 0; i < jTable.getRowCount(); i++) {
				String id = mtm.getMessageRowAt(i).id;
				if (id.equals(objId)) {
					urow = i;
					break;
				}
			}
		}
		if (urow == -1)
			return;
		try {
			MessageRow mr = Context.storage.getMessageRow(objId);
			mtm.setMessageRowAt(mr, urow);
/*
 * jTable.setValueAt(mr.addrFrom, urow, MessageTableColumns.COL_ADDR_FROM);
 * jTable.setValueAt(mr.addrTo, urow, MessageTableColumns.COL_ADDR_TO); 
 * jTable.setValueAt(mr.subject, urow, MessageTableColumns.COL_SUBJECT);
 */							
			showFolderMessageInfo();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}

	/**
	 * This method initializes jMenuItem15	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem15() {
		if (jmiSearchMessages == null) {
			jmiSearchMessages = new JMenuItem();
			jmiSearchMessages.setText(Strings.getString("MainFrame.miSearch"));
			jmiSearchMessages.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					MsgSearchFrame msf = new MsgSearchFrame();
					msf.setParent(Context.mainFrame);
					msf.setVisible(true);
				}
			});
		}
		return jmiSearchMessages;
	}

	public void searchMessages(String where, String searchText,
			JProgressBar progressBar) {
		SearchFolder searchFolder = (SearchFolder)sf.searchCommonTreeNode.getUserObject();
		
		TreePath treePath = new TreePath(sf.searchCommonTreeNode.getPath());
		TreePath selectionPath = jTree1.getSelectionPath();
		if (selectionPath == null || !selectionPath.equals(treePath)) {
			searchFolder.commonSearchCondition = null;
			searchFolder.contentSearchText = null;
			searchFolder.progressBar = null;
			jTree1.setSelectionPath(treePath);
			jTree1.scrollPathToVisible(treePath);
		}
		
		searchFolder.commonSearchCondition = where;
		if(ComUtils.nvl(searchText).equals(""))
			searchText = null;
		searchFolder.contentSearchText = searchText;
		searchFolder.progressBar = progressBar;
		
		showFolderInfo();
		if (searchFolder.contentSearchText != null) {
			final SwingWorker worker = new SwingWorker() {
				public Object construct() {
					listMessages();
					return null;
				}
			};
			worker.start();
		} else
			listMessages();						
	}
	
	/**
	 * This method initializes jtfSearch	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfSearch() {
		if (jtfSearch == null) {
			jtfSearch = new JTextField();
			jtfSearch.setPreferredSize(new java.awt.Dimension(220,20));
			jtfSearch.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					jtfSearch_keyPressed(e);
				}
			});
			TextPopup.registerComponent(jtfSearch);
		}
		return jtfSearch;
	}

	void jtfSearch_keyPressed(java.awt.event.KeyEvent e) {
		if(e.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
			jbSearch_actionPerformed();			
		}
	}
		
	/**
	 * This method initializes jbSearch	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbSearch() {
		if (jbSearch == null) {
			jbSearch = new JButton();
			jbSearch.setText(Strings.getString("searchButton"));
			jbSearch.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbSearch_actionPerformed();
				}
			});
			jbSearch.setPreferredSize(new java.awt.Dimension(90,20));
		}
		return jbSearch;
	}	

	void jbSearch_actionPerformed() {
		if(getCurrentSearchFolder() != null) {
			AlertDialog.showInfoDialog(Strings.getString("MainFrame.noQuickSearch"));
			return;
		}
		String str = jtfSearch.getText().trim().toUpperCase();
		StringBuffer sb = new StringBuffer(); 
		if(!str.equals("")) {		
			sb.append("UPPER(ADDR_FROM) like '%").append(str).append("%'");
			sb.append(" or ");
			sb.append("UPPER(ADDR_TO) like '%").append(str).append("%'");
			sb.append(" or ");
			sb.append("UPPER(ADDR_CC) like '%").append(str).append("%'");
			sb.append(" or ");
			sb.append("UPPER(SUBJECT) like '%").append(str).append("%'");
		}	
		if (sb.length() > 0)
			quickSearchStr = sb.toString();
		else {
			quickSearchStr = null;
		}
		listMessages();
	}

	/**
	 * This method initializes jMenuItem16	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgRefresh() {
		if (jmiMsgRefresh == null) {
			jmiMsgRefresh = new JMenuItem();
			jmiMsgRefresh.setText(Strings.getString("refreshMenuItem"));
			jmiMsgRefresh.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					listMessages();
				}
			});
		}
		return jmiMsgRefresh;
	}
		
	/**
	 * This method initializes jMenuItem17	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem17() {
		if (jmiSignatures == null) {
			jmiSignatures = new JMenuItem();
			jmiSignatures.setText(Strings.getString("MainFrame.signatures"));
			jmiSignatures.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					SignaturesFrame sf = new SignaturesFrame();
					sf.setVisible(true);
					sf.listSignatures();
				}
			});
		}
		return jmiSignatures;
	}

	/**
	 * This method initializes jmiCodepage	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgCodepage() {
		if (jmiMsgCodepage == null) {
			jmiMsgCodepage = new JMenuItem();			
			jmiMsgCodepage.setText(Strings.getString("MainFrame.miCodepage"));
			jmiMsgCodepage.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiCodepage_actionPerformed(e);
				}
			});
		}
		return jmiMsgCodepage;
	}
	
	void jmiCodepage_actionPerformed(java.awt.event.ActionEvent e) {
		int rows[] = jTable1.getSelectedRows();
		if(rows.length == 0)
			return;
		String cp = CpDialog.selectCodepage();
		if(cp == null)
			return;
		if(cp.equals("") || cp.equalsIgnoreCase("Auto"))
			cp = null;
		try {
			for (int i = 0; i < rows.length; i++) {
				String id = mtm.getMessageRowAt(rows[i]).id;
				MimeMessage message = Context.storage.loadMessage(id);
				MessageHeader msg = Context.mailBean.getMessageHeader(message, cp);
				Context.storage.setMessageCodepage(id, cp, msg.From, msg.To,
						msg.Subject);
				updateRow(jTable1, i, id);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	/**
	 * This method initializes jmiMsgExport	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgExport() {
		if (jmiMsgExport == null) {
			jmiMsgExport = new JMenuItem();
			jmiMsgExport.setText(Strings.getString("MessageFrame.jmiMsgExport"));
			jmiMsgExport.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiMsgExport_actionPerformed(e);
				}
			});
		}
		return jmiMsgExport;
	}

	void jmiMsgExport_actionPerformed(java.awt.event.ActionEvent e) {
		boolean timerStopped = false;
		try {
			String oldValue = Context.getSettingsValue("receive_periodically");
			if (oldValue.equalsIgnoreCase("true")) {
				Context.storage.setSettingsValue("receive_periodically", String
						.valueOf(false));
				timerStopped = true;
				this.updateTimer();
				AlertDialog.showInfoDialog(Strings
						.getString("MainFrame.autoReceiveStopped"));
			}

			MsgExportToFsFrame metff = new MsgExportToFsFrame();
			metff.setParent(this);
			metff.setModal(true);
			metff.setVisible(true);
		} catch (Exception exc) {
			AlertDialog.showErrorDialog(exc);
		} finally {
			if (timerStopped) {
				try {
					Context.storage.setSettingsValue(
							"receive_periodically", String
									.valueOf(true));
					this.updateTimer();
					AlertDialog.showInfoDialog(Strings
							.getString("MainFrame.autoReceiveStarted"));
				} catch (Exception exc1) {
					exc1.printStackTrace();
					AlertDialog.showErrorDialog(exc1);
				}
			}
		}
	}

	/**
	 * This method initializes jmiShowPics	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgShowPics() {
		if (jmiMsgShowPics == null) {
			jmiMsgShowPics = new JMenuItem();
			jmiMsgShowPics.setText(Strings.getString("menuItemShowPics"));
			jmiMsgShowPics.setEnabled(false);
			jmiMsgShowPics.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					messageView1.showPics();
					checkShowPics();
				}
			});
		}
		return jmiMsgShowPics;
	}
				
	private void checkShowPics() {		
		if(messageView1.hasPics()) {
			jmiMsgShowPics.setEnabled(true);
		} else {
			jmiMsgShowPics.setEnabled(false);				
		}
	}

	/**
	 * This method initializes jmiDeleteNoTrash	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgDeleteNoTrash() {
		if (jmiMsgDeleteNoTrash == null) {
			jmiMsgDeleteNoTrash = new JMenuItem();
			jmiMsgDeleteNoTrash.setText(Strings.getString("MainFrame.deleteNoTrash"));
			jmiMsgDeleteNoTrash.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(AlertDialog.showConfirmDialog(
							Strings.getString("MainFrame.deleteNoTrashConfirm"),
							AlertDialog.YES_NO_OPTION) == AlertDialog.YES_OPTION)
						deleteMessages(true, MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jmiMsgDeleteNoTrash;
	}

	/**
	 * This method initializes jmiSqlQuery	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSqlQuery() {
		if (jmiSqlQuery == null) {
			jmiSqlQuery = new JMenuItem();
			jmiSqlQuery.setText(Strings.getString("MainFrame.miSqlQuery"));
			jmiSqlQuery.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					SqlFrame sf = new SqlFrame();
					sf.setVisible(true);
				}
			});
		}
		return jmiSqlQuery;
	}

	/**
	 * This method initializes jmiForward	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiForward() {
		if (jmiForward == null) {
			jmiForward = new JMenuItem();
			jmiForward.setText(Strings.getString("MainFrame.forward"));
			jmiForward.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					int rows[] = jTable1.getSelectedRows();
					if(rows.length == 0)
						return;
					MassFwdFrame mff = new MassFwdFrame();
					mff.setVisible(true);
				}
			});
		}
		return jmiForward;
	}

	/**
	 * This method initializes jmiImapSubscr	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiImapSubscr() {
		if (jmiImapSubscr == null) {
			jmiImapSubscr = new JMenuItem();
			jmiImapSubscr
					.setText(Strings.getString("MainFrame.showImapSubscr"));
			jmiImapSubscr.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							Object cto = getCurrentTreeObject();
							if (!(cto instanceof IFolder))
								return;
							IFolder iFolder = (IFolder) cto;
							try {
								Account acnt = Context.storage
										.getAccount(iFolder.acntId);
								IMAPFoldersFrame iff = new IMAPFoldersFrame();
								iff.setVisible(true);
								iff.setAccount(acnt);
								iff.listFolders();								
							} catch (Exception exc) {
								exc.printStackTrace();
							}
						}
			});
		}
		return jmiImapSubscr;
	}

	/**
	 * This method initializes jmiImapExpunge	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiImapExpunge() {
		if (jmiImapExpunge == null) {
			jmiImapExpunge = new JMenuItem();
			jmiImapExpunge.setText(Strings.getString("MainFrame.expungeIFolder"));
			jmiImapExpunge.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiImapExpunge_actionPerformed(e);
				}
			});
		}
		return jmiImapExpunge;
	}	
		
	void jmiImapExpunge_actionPerformed(java.awt.event.ActionEvent e) {
		boolean startTimer = false;
		try {
			IFolder iFolder = getCurrentImapFolder();
			if (iFolder == null)
				return;
			if (AlertDialog.showConfirmDialog(Strings.getString(
					"MainFrame.expungeConfirm").replaceFirst("\\$1",
					iFolder.getName()), AlertDialog.OK_CANCEL_OPTION) != AlertDialog.OK_OPTION)
				return;

			IMAPContext.operateFolder(iFolder, IMAPContext.FOLDER_EXPUNGE);

			Context.storage.expungeImapFolder(iFolder.getId());
			expungeFolder(iFolder);

			updateFldNewMsgInfo();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {
			if (startTimer)
				startTimer();
		}
	}

	/**
	 * This method initializes jmMsgToggle	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJmMsgToggle() {
		if (jmMsgToggle == null) {
			jmMsgToggle = new JMenu();
			jmMsgToggle.setText(Strings.getString("MessageRow.toggleMenu"));
			jmMsgToggle.add(getJmiMsgTglSeen());
			jmMsgToggle.add(getJmiMsgTglReceive());
			jmMsgToggle.add(getJmiMsgTglFlag());
		}
		return jmMsgToggle;
	}

	/**
	 * This method initializes jmiMsgTglSeen	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgTglSeen() {
		if (jmiMsgTglSeen == null) {
			jmiMsgTglSeen = new JMenuItem();
			jmiMsgTglSeen.setText(Strings.getString("MessageRow.toggleSeen"));
			jmiMsgTglSeen.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.SEEN, MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jmiMsgTglSeen;
	}

	/**
	 * This method initializes jmiMsgTglFlag	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgTglFlag() {
		if (jmiMsgTglFlag == null) {
			jmiMsgTglFlag = new JMenuItem();
			jmiMsgTglFlag.setText(Strings.getString("MessageRow.toggleFlag"));
			jmiMsgTglFlag.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.FLAGGED, MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jmiMsgTglFlag;
	}

	/**
	 * This method initializes jmiMsgTglReceive	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiMsgTglReceive() {
		if (jmiMsgTglReceive == null) {
			jmiMsgTglReceive = new JMenuItem();
			jmiMsgTglReceive.setText(Strings.getString("MessageRow.toggleReceive"));
			jmiMsgTglReceive.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgHdr(MessageRow.MESSAGES_FLAGS_TOGGLE);
				}
			});
		}
		return jmiMsgTglReceive;
	}

	/**
	 * This method initializes jmiWorkOffline	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiWorkOffline() {
		if (jmiWorkOffline == null) {
			jmiWorkOffline = new JMenuItem();
			jmiWorkOffline.setText(Strings.getString("MainFrame.workOffline"));
			jmiWorkOffline.setIcon((Context.workOffline) ? Context
					.getImageIcon("check.png") : null);
			jmiWorkOffline
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								Context.setWorkOffline(!Context.workOffline);
								jmiWorkOffline
										.setIcon((Context.workOffline) ? Context
												.getImageIcon("check.png")
												: null);
							} catch (Exception exc) {
								exc.printStackTrace();
								AlertDialog.showErrorDialog(exc);
							}
						}
					});
		}
		return jmiWorkOffline;
	}

	/**
	 * This method initializes jmiCopyMsgs	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiCopyMsgs() {
		if (jmiCopyMsgs == null) {
			jmiCopyMsgs = new JMenuItem();
			jmiCopyMsgs.setText(Strings.getString("MainFrame.copyMenuItem"));
			jmiCopyMsgs.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					callMoveMessages(true);
				}
			});
		}
		return jmiCopyMsgs;
	}

	/**
	 * This method initializes jmiColLayout	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiColLayout() {
		if (jmiColLayout == null) {
			jmiColLayout = new JMenuItem();
			jmiColLayout.setText(Strings.getString("MainFrame.miColumnsLayout"));
			jmiColLayout.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					MsgColLayoutFrame mclf = new MsgColLayoutFrame();
					mclf.setVisible(true);
					mclf.listColumnsAll();
					mclf.listColumnsSel();
				}
			});
		}
		return jmiColLayout;
	}

	/**
	 * This method initializes jmiCancel	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiCancel() {
		if (jmiCancel == null) {
			jmiCancel = new JMenuItem();
			jmiCancel.setText(Strings.getString("MainFrame.cancelDelivery"));
			jmiCancel.setEnabled(false);
			jmiCancel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					cancelDelivery = true;
					jmiCancel.setEnabled(false);
				}
			});
		}
		return jmiCancel;
	}
	
	public synchronized void incReceiving(String operStr) {
		threadsRec++;
		jlStatRec.setText(":" + threadsRec);
		jlStatRec.setIcon(Context.getImageIcon("recact.gif"));
		jProgressBar1.setString(operStr);
	}

	public synchronized void incSending(String operStr) {
		threadsSend++;
		jlStatSend.setText(":" + threadsSend);
		jlStatSend.setIcon(Context.getImageIcon("sendact.gif"));
		jProgressBar1.setString(operStr);		
	}

	public synchronized void decrReceiving() {
		if (threadsRec != 0)
			threadsRec--;
		jlStatRec.setText(":" + threadsRec);
		if (threadsRec == 0)
			jlStatRec.setIcon(Context.getImageIcon("recgr.gif"));
		refreshStatusBarText(true);
	}

	public synchronized void decrSending() {
		if (threadsSend != 0)
			threadsSend--;
		jlStatSend.setText(":" + threadsSend);
		if (threadsSend == 0)
			jlStatSend.setIcon(Context.getImageIcon("sendgr.gif"));
	}	
	
	public void placeOnTop() {
		if ((this.getExtendedState() & JFrame.ICONIFIED) == JFrame.ICONIFIED)
			Context.deiconify(this);
		else {
			this.setAlwaysOnTop(true);
			this.setAlwaysOnTop(false);
		}
	}

	/**
	 * This method initializes jmiSaveAllAtt	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSaveAllAtt() {
		if (jmiSaveAllAtt == null) {
			jmiSaveAllAtt = new JMenuItem();
			jmiSaveAllAtt.setText(Strings.getString("MainFrame.saveAllAtt"));
			jmiSaveAllAtt.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					callSaveAllAtt();
				}
			});
		}
		return jmiSaveAllAtt;
	}	
		
	protected synchronized void callSaveAllAtt() {
		Cursor oldCursor = getCursor();
		try {
			File dir = Context.dirOpenDialog(this);
			if (dir == null)
				return;
			ReceivingResult result = new ReceivingResult();

			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			int rows[] = jTable1.getSelectedRows();

			for (int i = 0; i < rows.length; i++) {
				MessageRow mr = mtm.getMessageRowAt(rows[i]);
				if(mr.isHeader())
					continue;
				Message olivaMessage = Context.mailBean.getMessage(
						Context.storage.loadMessage(mr.id), mr.codepage);
				result.append(MessageContext.saveAllAtt(olivaMessage, MessageContext
						.extractAttachmets(olivaMessage), dir));
			}

			if (result.skipped > 0)
				AlertDialog.showInfoDialog(Strings.getString(
						"MessageFrame.filesSavedSkipped").replaceAll("\\$1",
						String.valueOf(result.received)).replaceAll("\\$2",
						String.valueOf(result.skipped)));
			else
				AlertDialog.showInfoDialog(Strings.getString(
						"MessageFrame.filesSaved").replaceAll("\\$1",
						String.valueOf(result.received)));
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		} finally {
			setCursor(oldCursor);
		}
	}

	/**
	 * This method initializes jPopupMenuMessages	
	 * 	
	 * @return javax.swing.JPopupMenu	
	 */    
	private JPopupMenu getJPopupMenuMessages() {
		if (jPopupMenuMessages == null) {
			jPopupMenuMessages = new JPopupMenu();
			jPopupMenuMessages.add(getJmiSetSeen());
			jPopupMenuMessages.add(getJmiSetUnseen());
			jPopupMenuMessages.add(getJmiSetReceive());
			jPopupMenuMessages.add(getJmiUnsetReceive());
			jPopupMenuMessages.add(getJmiSetFlag());
			jPopupMenuMessages.add(getJmiUnsetFlag());
		}
		return jPopupMenuMessages;
	}

	/**
	 * This method initializes jmiSetSeen	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSetSeen() {
		if (jmiSetSeen == null) {
			jmiSetSeen = new JMenuItem();
			jmiSetSeen.setText(Strings.getString("MainFrame.msgPopSetSeen"));
			jmiSetSeen.setIcon(Context.getImageIcon("seen.gif"));
			jmiSetSeen.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.SEEN, MessageRow.MESSAGES_FLAGS_SET);
				}
			});
		}
		return jmiSetSeen;
	}

	/**
	 * This method initializes jmiSetUnseen	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSetUnseen() {
		if (jmiSetUnseen == null) {
			jmiSetUnseen = new JMenuItem();
			jmiSetUnseen.setText(Strings.getString("MainFrame.msgPopUnsetSeen"));
			jmiSetUnseen.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.SEEN, MessageRow.MESSAGES_FLAGS_UNSET);
				}
			});
		}
		return jmiSetUnseen;
	}

	/**
	 * This method initializes jmiSetReceived	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSetReceive() {
		if (jmiSetReceive == null) {
			jmiSetReceive = new JMenuItem();
			jmiSetReceive.setText(Strings.getString("MainFrame.msgPopSetReceive"));
			jmiSetReceive.setIcon(Context.getImageIcon("recact.gif"));
			jmiSetReceive.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgHdr(MessageRow.MESSAGES_FLAGS_SET);
				}
			});
		}
		return jmiSetReceive;
	}

	/**
	 * This method initializes jmiUnsetReceive	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiUnsetReceive() {
		if (jmiUnsetReceive == null) {
			jmiUnsetReceive = new JMenuItem();
			jmiUnsetReceive.setText(Strings.getString("MainFrame.msgPopUnsetReceive"));
			jmiUnsetReceive.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgHdr(MessageRow.MESSAGES_FLAGS_UNSET);
				}
			});
		}
		return jmiUnsetReceive;
	}

	/**
	 * This method initializes jmiSetFlag	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiSetFlag() {
		if (jmiSetFlag == null) {
			jmiSetFlag = new JMenuItem();
			jmiSetFlag.setText(Strings.getString("MainFrame.msgPopSetFlag"));
			jmiSetFlag.setIcon(Context.getImageIcon("flagged.gif"));
			jmiSetFlag.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.FLAGGED, MessageRow.MESSAGES_FLAGS_SET);
				}
			});
		}
		return jmiSetFlag;
	}

	/**
	 * This method initializes jmiUnsetFlag	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiUnsetFlag() {
		if (jmiUnsetFlag == null) {
			jmiUnsetFlag = new JMenuItem();
			jmiUnsetFlag.setText(Strings.getString("MainFrame.msgPopUnsetFlag"));
			jmiUnsetFlag.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeSelMsgFlag(Flags.Flag.FLAGGED, MessageRow.MESSAGES_FLAGS_UNSET);
				}
			});
		}
		return jmiUnsetFlag;
	}	
		
} // @jve:decl-index=0:visual-constraint="14,11"

class ColumnHeaderListener extends MouseAdapter {

	private MainFrame mf = null;

	public ColumnHeaderListener(MainFrame mf) {
		this.mf = mf;
	}

	public void mouseClicked(MouseEvent evt) {
		JTable table = ((JTableHeader) evt.getSource()).getTable();
		TableColumnModel colModel = table.getColumnModel();

		// The index of the column whose header was clicked
		int vColIndex = colModel.getColumnIndexAtX(evt.getX());
		//        int mColIndex = table.convertColumnIndexToModel(vColIndex);

		// Return if not clicked on any column header
		if (vColIndex == -1) {
			return;
		}

		// Determine if mouse was clicked between column heads
		Rectangle headerRect = table.getTableHeader().getHeaderRect(vColIndex);
		if (vColIndex == 0) {
			headerRect.width -= 3; // Hard-coded constant
		} else {
			headerRect.grow(-3, 0); // Hard-coded constant
		}
		if (!headerRect.contains(evt.getX(), evt.getY())) {
			// Mouse was clicked between column heads
			// vColIndex is the column head closest to the click

			// vLeftColIndex is the column head to the left of the click
			int vLeftColIndex = vColIndex;
			if (evt.getX() < headerRect.x) {
				vLeftColIndex--;
			}
		} else {
			if (mf != null)
				mf.setOrderBy(MessageTableModel.shownColumns[vColIndex]);
		}
	}
}

class MessageSelectionListener implements ListSelectionListener {
	JTable table = null;
	MessageSelectionEvent msi = null;
	
	// It is necessary to keep the table since it is not possible
	// to determine the table from the event's source
	MessageSelectionListener(JTable table, MessageSelectionEvent msi) {
		this.table = table;
		this.msi = msi;
	}

	public void valueChanged(ListSelectionEvent e) {
		// If cell selection is enabled, both row and column change events are
		// fired
		if (e.getSource() == table.getSelectionModel()
				&& table.getRowSelectionAllowed()) {
			// Column selection changed
			msi.MessageListSelectionEvent(e);
		} else if (e.getSource() == table.getColumnModel().getSelectionModel()
				&& table.getColumnSelectionAllowed()) {
			// Row selection changed
			msi.MessageListSelectionEvent(e);
		}

		if (e.getValueIsAdjusting()) {
			// The mouse button has not yet been released
		}
	}
}

interface MessageSelectionEvent {
	public void MessageListSelectionEvent(ListSelectionEvent e);
}

final class MyCellRenderer extends JLabel implements TreeCellRenderer {
	static final long serialVersionUID = 3458391262076892651L;

	MyCellRenderer() {
		setOpaque(true);
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean selected, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode) value;		 
		if (dmtn.getUserObject() instanceof Folder) {
			Folder folder = (Folder)dmtn.getUserObject();
			String resourceName = null;			
			if (selected) {
				resourceName = "folderop.gif";				
				if(folder.getName().equals(Folder.FOLDER_INBOX))
					resourceName = "fldopin.png";
				else if(folder.getName().equals(Folder.FOLDER_OUTBOX) ||
						folder.getName().equals(Folder.FOLDER_SENT))
					resourceName = "fldopout.png";
				else if(folder.getName().equals(Folder.FOLDER_TRASH))
					resourceName = "trashcan.gif";
			} else {
				resourceName = "foldercl.gif";
				if(folder.getName().equals(Folder.FOLDER_INBOX))
					resourceName = "fldclin.png";
				else if(folder.getName().equals(Folder.FOLDER_OUTBOX) ||
						folder.getName().equals(Folder.FOLDER_SENT))
					resourceName = "fldclout.png";
				else if(folder.getName().equals(Folder.FOLDER_TRASH))
					resourceName = "trashcan.gif";				
			}
			try {
				setIcon(Context.getImageIcon(resourceName));
			} catch (Exception exc) {
				exc.printStackTrace();
			}							
			Font font = tree.getFont();			
			if(folder.getNewMsgCount() == 0)
				setFont(font.deriveFont(Font.PLAIN));
			else
				setFont(font.deriveFont(Font.BOLD));
		} else {
			setIcon(Context.getImageIcon("magnif.png"));
			Font font = this.getFont();			
			setFont(font.deriveFont(Font.PLAIN));
		}
		setText(value.toString());
		setBackground(selected ? Color.LIGHT_GRAY : Color.WHITE);
		return this;		
	}
		
}
