package olivamail.gui;

import java.awt.BorderLayout;
import java.util.Vector;
import javax.activation.DataHandler;
import javax.mail.Multipart;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JButton;
import olivamail.core.common.ComUtils;
import olivamail.core.mail.MailUtils;
import olivamail.core.mail.MessageHeader;
import olivamail.core.mail.NewMessage;
import olivamail.core.mail.SimpleMessage;

public class MassFwdFrame extends JFrame {

	static final long serialVersionUID = 4432455653264324231L;
	
	private JPanel jContentPane = null;
	private JPanel centerPanel = null;

	private ComposeHeader headerPanel = null;

	private JRadioButton jrbCtntSeparate = null;

	private JRadioButton jrbAttSeparate = null;

	private JRadioButton jrbAttOne = null;

	private JPanel buttonPanel = null;

	private JButton sendButton = null;

	private JButton cancelButton = null;
	/**
	 * This is the default constructor
	 */
	public MassFwdFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(535, 260);
		this.setResizable(false);
		this.setTitle(Strings.getString("MassFwdFrame.title"));
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getCenterPanel(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getHeaderPanel(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getButtonPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes centerPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getCenterPanel() {
		if (centerPanel == null) {
			centerPanel = new JPanel();
			centerPanel.add(getJrbCtntSeparate(), null);
			centerPanel.add(getJrbAttOne(), null);
			centerPanel.add(getJrbAttSeparate(), null);
			ButtonGroup bg = new ButtonGroup();
			bg.add(jrbCtntSeparate);
			bg.add(jrbAttSeparate);
			bg.add(jrbAttOne);
		}
		return centerPanel;
	}

	/**
	 * This method initializes headerPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private ComposeHeader getHeaderPanel() {
		if (headerPanel == null) {
			headerPanel = new ComposeHeader();
			headerPanel.setPreferredSize(new java.awt.Dimension(520,109));
			headerPanel.subjectField.setEnabled(false);
		}
		return headerPanel;
	}

	/**
	 * This method initializes jrbContentSeparate	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJrbCtntSeparate() {
		if (jrbCtntSeparate == null) {
			jrbCtntSeparate = new JRadioButton();
			jrbCtntSeparate.setText(Strings.getString("MassFwdFrame.fwdCtntSeparate"));
			jrbCtntSeparate.setSelected(true);
			jrbCtntSeparate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					headerPanel.subjectField.setEnabled(false);
					headerPanel.subjectField.setText("");
				}
			});
			jrbCtntSeparate.setPreferredSize(new java.awt.Dimension(500,20));
		}
		return jrbCtntSeparate;
	}

	/**
	 * This method initializes jrbAttSeparate	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJrbAttSeparate() {
		if (jrbAttSeparate == null) {
			jrbAttSeparate = new JRadioButton();
			jrbAttSeparate.setText(Strings.getString("MassFwdFrame.fwdAttSeparate"));
			jrbAttSeparate.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					headerPanel.subjectField.setEnabled(false);
					headerPanel.subjectField.setText("");
				}
			});
			jrbAttSeparate.setPreferredSize(new java.awt.Dimension(500,20));
		}
		return jrbAttSeparate;
	}

	/**
	 * This method initializes jrbAttOne	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJrbAttOne() {
		if (jrbAttOne == null) {
			jrbAttOne = new JRadioButton();
			jrbAttOne.setText(Strings.getString("MassFwdFrame.fwdAttOne"));
			jrbAttOne.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					headerPanel.subjectField.setEnabled(true);
					int rows[] = Context.mainFrame.jTable1.getSelectedRows();
					headerPanel.subjectField.setText("Fwd: " + rows.length
							+ " messages");
				}
			});
			jrbAttOne.setPreferredSize(new java.awt.Dimension(500,20));
		}
		return jrbAttOne;
	}

	/**
	 * This method initializes buttonPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getButtonPanel() {
		if (buttonPanel == null) {
			buttonPanel = new JPanel();
			buttonPanel.setPreferredSize(new java.awt.Dimension(10,36));
			buttonPanel.add(getSendButton(), null);
			buttonPanel.add(getCancelButton(), null);
		}
		return buttonPanel;
	}

	/**
	 * This method initializes sendButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getSendButton() {
		if (sendButton == null) {
			sendButton = new JButton();
			sendButton.setText(Strings.getString("ComposeFrame.sendButton"));
			sendButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					if(jrbAttOne.isSelected())
						sendOne();
					else
						sendSeparate();
				}
			});
		}
		return sendButton;
	}

	private void sendSeparate() {
		try {
			int rows[] = Context.mainFrame.jTable1.getSelectedRows();
			String ids[] = new String[rows.length];
			for (int i = 0; i < rows.length; i++) {
				ids[i] = ((MessageTableModel) Context.mainFrame.jTable1
						.getModel()).getMessageRowAt(rows[i]).id;				
			}
			for (int i = 0; i < ids.length; i++) {
				MessageRow mr = Context.storage.getMessageRow(ids[i]);
				if(mr.isHeader())
					continue;				
				MimeMessage message = Context.storage.loadMessage(ids[i]);
				SimpleMessage msg = Context.mailBean.getReplyMessage(message,
						mr.codepage, false);
				StringBuffer sb = new StringBuffer();
				sb.append("\n\n\n----- Original Message -----\nFrom: ");
				sb.append(msg.From).append("\nTo: ").append(msg.To).append(
						"\nSent: ").append(msg.getSentDateToString()).append(
						"\nSubject: ").append(msg.Subject).append("\n\n");
				String addrTo = Context.trimField(headerPanel.toField);
				headerPanel.toField.setText(addrTo);
				String addrCc = Context.trimField(headerPanel.ccField);
				headerPanel.ccField.setText(addrCc);
				String addrBcc = Context.trimField(headerPanel.bccField);
				headerPanel.bccField.setText(addrBcc);
				if (addrTo.equals("") && addrCc.equals("")
						&& addrBcc.equals("")) {
					AlertDialog.showWarningDialog(Strings
							.getString("ComposeFrame.enterAddress")); //$NON-NLS-1$
					headerPanel.toField.requestFocus();
					return;
				}
				String subject = MailUtils.getPrefixedSubject(msg.Subject, "Fwd");
				MimeBodyPart mbp = new MimeBodyPart();
				if (jrbCtntSeparate.isSelected()) {
					if (message.isMimeType("multipart/*")) //$NON-NLS-1$
						mbp.setContent((Multipart) message.getContent());
					else
						mbp.setContent(Context.mailBean.getPartText(message,
								mr.codepage), message.getContentType());
				}
				if (jrbAttSeparate.isSelected()) {
					mbp.setDataHandler(new DataHandler(
							new olivamail.core.mail.ByteArrayDataSource(MailUtils
									.getMessageInputStream(message),
									"message/rfc822"))); //$NON-NLS-1$
				}
				
				boolean asUnicode = false;
				boolean requestNotify = false;
				boolean important = false;
				boolean hasAtt = true;
				Vector vBodyParts = new Vector(1);
				vBodyParts.add(mbp);
				
				Account acnt = (Account) headerPanel.jcbAddrFrom.getSelectedItem();
				String fromAddr = acnt.email;
				if(!acnt.person.equals(""))
					fromAddr = acnt.person + " <" + acnt.email + ">";  
				
				NewMessage newMsg = NewMessage.create(fromAddr, headerPanel.toField
						.getText(), headerPanel.ccField.getText(), headerPanel.bccField.getText(),
						subject, sb.toString(), vBodyParts, null,
						asUnicode, requestNotify);

				if (!ComUtils.nvl(acnt.replyTo).equals(""))
					newMsg.ReplyTo = acnt.replyTo;
				if (!ComUtils.nvl(acnt.organization).equals(""))
					newMsg.addHeader("Organization", acnt.organization);			
				if(important)
					newMsg.importance = MessageHeader.IMP_HIGH;
				
				javax.mail.internet.MimeMessage mimeMsg = Context.mailBean
						.createMessage(newMsg);
				MessageHeader hdr = Context.mailBean.getMessageHeader(mimeMsg, null);
				hdr.UID = Context.mailBean.getOlivaMsgUID(mimeMsg);
				hdr.hasAtt = hasAtt;
				Context.mainFrame.addRowToTableIfNeeded(
						Context.storage.saveMessage(hdr, Context.getOutboxFolder(),
								mimeMsg, "".hashCode(), null, null, acnt.id), Context.getOutboxFolder());
			}
			MailContext.sendFromOutbox();
			//this_windowClosing(null);
			dispose();							
		} catch (Exception exc) {
			AlertDialog.showErrorDialog(exc);
		}
	}
	
	private void sendOne() {
		try {
			int rows[] = Context.mainFrame.jTable1.getSelectedRows();
			String ids[] = new String[rows.length];
			for (int i = 0; i < rows.length; i++) {
				ids[i] = ((MessageTableModel) Context.mainFrame.jTable1
						.getModel()).getMessageRowAt(rows[i]).id;
			}
			String addrTo = Context.trimField(headerPanel.toField);
			headerPanel.toField.setText(addrTo);
			String addrCc = Context.trimField(headerPanel.ccField);
			headerPanel.ccField.setText(addrCc);
			String addrBcc = Context.trimField(headerPanel.bccField);
			headerPanel.bccField.setText(addrBcc);
			if (addrTo.equals("") && addrCc.equals("")
					&& addrBcc.equals("")) {
				AlertDialog.showWarningDialog(Strings
						.getString("ComposeFrame.enterAddress"));
				headerPanel.toField.requestFocus();
				return;
			}
			
			String subject = headerPanel.subjectField.getText();
			if(ComUtils.nvl(subject).trim().length() == 0)
				subject = "Fwd: " + ids.length + " messages";
			
			Vector vBodyParts = new Vector(ids.length);			
			for (int i = 0; i < ids.length; i++) {
				MessageRow mr = Context.storage.getMessageRow(ids[i]);
				if(mr.isHeader())
					continue;
				MimeMessage message = Context.storage.loadMessage(ids[i]);
				MimeBodyPart mbp = new MimeBodyPart();
				mbp.setDataHandler(new DataHandler(
						new olivamail.core.mail.ByteArrayDataSource(MailUtils
								.getMessageInputStream(message),
								"message/rfc822")));				
				vBodyParts.add(mbp);								
			}
			boolean asUnicode = false;
			boolean requestNotify = false;
			boolean important = false;
			boolean hasAtt = true;
			Account acnt = (Account) headerPanel.jcbAddrFrom.getSelectedItem();
			String fromAddr = acnt.email;
			if(!acnt.person.equals(""))
				fromAddr = acnt.person + " <" + acnt.email + ">";  			
			NewMessage newMsg = NewMessage.create(fromAddr, headerPanel.toField
					.getText(), headerPanel.ccField.getText(), headerPanel.bccField.getText(),
					subject, null, vBodyParts, null,
					asUnicode, requestNotify);
			if (!ComUtils.nvl(acnt.replyTo).equals(""))
				newMsg.ReplyTo = acnt.replyTo;
			if (!ComUtils.nvl(acnt.organization).equals(""))
				newMsg.addHeader("Organization", acnt.organization);			
			if(important)
				newMsg.importance = MessageHeader.IMP_HIGH;
			
			javax.mail.internet.MimeMessage mimeMsg = Context.mailBean
					.createMessage(newMsg);
			MessageHeader hdr = Context.mailBean.getMessageHeader(mimeMsg, null);
			hdr.UID = Context.mailBean.getOlivaMsgUID(mimeMsg);
			hdr.hasAtt = hasAtt;
			Context.mainFrame.addRowToTableIfNeeded(
					Context.storage.saveMessage(hdr, Context.getOutboxFolder(),
							mimeMsg, "".hashCode(), null, null, acnt.id), Context.getOutboxFolder());
			
			MailContext.sendFromOutbox();
			//this_windowClosing(null);
			dispose();							
		} catch (Exception exc) {
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Strings.getString("cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					dispose();
				}
			});
		}
		return cancelButton;
	}

/*
	public static void showDialog() {
		MassFwdFrame mff = new MassFwdFrame();
		mff.setModal(true);
		mff.show();				
	}
*/	
		
}  //  @jve:decl-index=0:visual-constraint="10,10"
