/*
 * @(#)OldMessageFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JSplitPane;
import java.awt.event.ActionEvent;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.net.URL;
import olivamail.core.common.IOUtils;
import olivamail.core.mail.MailUtils;
import javax.swing.JLabel;
import java.awt.GridLayout;
import javax.swing.JToolBar;

public class MessageFrame extends JFrame implements RequestHandler {
	
	private final String WIN_ID = "message";

	private JToolBar jtbNav = null;

	private JButton jbPrev = null;

	private JButton jbNext = null;

	private JButton jbShowPics = null;	
	
	static final long serialVersionUID = 2211L;

	private JPanel jContentPane = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel3 = null;

	private JPanel jPanel4 = null;
	
	protected MessageView messageView1 = null;		
	
	private JLabel jlXMailer = null;	
	
	int curAttPort = 0;
	
	int curAttXPos = 5;
	
	int curAttYPos = 5;

	private JPanel jPanel6 = null;

	//private MainFrame mainFrame = null;	
	
	private boolean defaultCtntPane = false;
	
	private IMfMenuBar mfmb = null;

	/*
	private static final int FIELD_FROM = 0;
	
	private static final int FIELD_TO = 1;
	
	private static final int FIELD_CC = 2;
	
	private static final int FIELD_SUBJECT = 3;
	
	private static final int FIELD_SENT_DATE = 4;
	
	private static final int FIELD_ATTACHMENTS = 5;
*/	
	/**
	 * This is the default constructor
	 */
	public MessageFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));	
	}
	
	public MessageFrame(boolean defaultCtntPane) {	
		super();
		this.defaultCtntPane = defaultCtntPane;		
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}	
			
/*	
	public void setParent(ParentList parent, JTable table, int row) {
		messageView1.setParent(parent, table, row);
	}
*/	
				
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(735, 431);	
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		
		if (Context.contentPaneNeedAwt())
			mfmb = new MfAwtMenuBar(this);
		else
			mfmb = new MfSwingMenuBar(this);
		mfmb.bindToMessageFrame();
		
		this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("MessageFrame.title"));
		
		messageView1.setMenuBar(mfmb);
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJPanel4(), java.awt.BorderLayout.WEST);
//			jContentPane.add(getContentPane1().getComponent(), java.awt.BorderLayout.CENTER);						
//			jContentPane.add(getJPanel5(), java.awt.BorderLayout.NORTH);
//			jContentPane.add(getJScrollPane2(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getMessageView1(), java.awt.BorderLayout.CENTER);
//			jContentPane.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);			
			jContentPane.add(getJPanel6(), java.awt.BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes messageView1
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getMessageView1() {
		if (messageView1 == null) {
			messageView1 = new MessageView(defaultCtntPane);
			messageView1.setTitleFrame(this);
			messageView1.setStatusBar(jlXMailer);
		}
		return messageView1;
	}
	
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			jlXMailer = new JLabel();
			jlXMailer.setText("");
			jPanel1 = new JPanel();
			jPanel1.setLayout(gridLayout);
			jPanel1.setPreferredSize(new java.awt.Dimension(10,18));
			jPanel1.add(jlXMailer, null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
		}
		return jPanel3;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
		}
		return jPanel4;
	}
	
	public void setTextData(String str) {
		messageView1.setTextData(str);
		mfmb.jMenuItem10_setEnabled(false);
	}

	public void setFileName(String filename) {
		messageView1.setFileName(filename);
	}	

	public void setContentType(String contentType) {
		messageView1.setContentType(contentType);
	}		
	
	public void setHtmlData(String str) {
		setHtmlData(str, Context.hidePictures);
	}
		
	private void setHtmlData(String str, boolean hidePictures) {
		messageView1.setHtmlData(str, hidePictures);
		mfmb.checkShowPics();
	}	

	void jMenuItem10_actionPerformed(ActionEvent e) {
		messageView1.toggleTextHtml();
		mfmb.checkShowPics();
	}

	void jMenuItem8_actionPerformed(ActionEvent e) {
		ComposeFrame cf = new ComposeFrame();
		//cf.setMessage(message, message_id);
		cf.setFwdOrReplyMessage(messageView1.getOlivaMessage().apiMessage);
		cf.setFwdOrReplyCp(messageView1.getCodepage());
		cf.setVisible(true);
		cf.performAction(ComposeFrame.ACTION_REPLY);
	}

	void jButton4_actionPerformed(ActionEvent e) {
	}

	void jComboBox1_actionPerformed(ActionEvent e) {
	}

	public void showMessageRow(MessageRow mr) {
		messageView1.showMessageRow(mr);
		mfmb.checkShowPics();
	}
		
	public olivamail.core.mail.Message showMessage(javax.mail.Message message) {
		olivamail.core.mail.Message msg = messageView1.showAPIMessage(message);
		mfmb.checkShowPics();
		return msg;		
	}	
		
	public void showOlivaMessage(olivamail.core.mail.Message msg) {
		messageView1.showMessage(msg);
		mfmb.checkShowPics();		
	}

	public void hideNavCtrls() {
		//jMenuItem12.setEnabled(false);
		//jMenuItem11.setEnabled(false);
		mfmb.jMenuNavigation_setEnabled(false);
		jbPrev.setEnabled(false);
		jbNext.setEnabled(false);
	}
	
	public void hideButtons() {
		mfmb.hideButtons();
	}
	
	void jMenuItem5_actionPerformed(ActionEvent e) {
		MessageFrame mf = new MessageFrame(true);
		mf.setVisible(true);
		mf.hideButtons();
		mf.hideNavCtrls();
		try {
			mf.setFileName(messageView1.getMessageFileName(messageView1.getOlivaMessage()));
			mf.setTextData(new String(MailUtils
					.getMessageBytes(messageView1.getOlivaMessage().apiMessage), (messageView1
					.getCodepage() == null) ? Context.defaultCodepage
					: messageView1.getCodepage()));
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	void jMenuItem3_actionPerformed(ActionEvent e) {
		Ocm ocm = new Ocm();
		try {
			String osFileName = messageView1.getOSFileName();
			File file = new File(Context.cache_dir + osFileName);
			if (!file.exists()) {
				ByteArrayInputStream bais = new ByteArrayInputStream(
						messageView1.getTextContent().getBytes());
				IOUtils.writeFile(bais, file);
			}
			String program = Context.getProgram(Context
					.getExtension(osFileName));
			if(program == null) {
				AlertDialog.showInfoDialog(Strings.getString("MessageFrame.noBrowser"));					
				return;
			}			
			ocm.run(program.replaceAll("%1", (Context.cache_link + osFileName).replaceAll("\\\\", "\\\\\\\\")), System.out, false);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	void jMenuItem6_actionPerformed(java.awt.event.ActionEvent e) {
		ComposeFrame cf = new ComposeFrame();
		cf.setFwdOrReplyMessage(messageView1.getOlivaMessage().apiMessage);
		cf.setFwdOrReplyCp(messageView1.getCodepage());
		cf.setVisible(true);
		cf.performAction(ComposeFrame.ACTION_FORWARD_PARTLY);		
	}

	void jMenuItem7_actionPerformed(java.awt.event.ActionEvent e) {
		ComposeFrame cf = new ComposeFrame();
		cf.setFwdOrReplyMessage(messageView1.getOlivaMessage().apiMessage);
		cf.setFwdOrReplyCp(messageView1.getCodepage());
		cf.setVisible(true);
		cf.performAction(ComposeFrame.ACTION_FORWARD_AS_ATT);		
	}	

	void jmiFwdInPlace_actionPerformed(java.awt.event.ActionEvent e) {
		ComposeFrame cf = new ComposeFrame();
		cf.setFwdOrReplyMessage(messageView1.getOlivaMessage().apiMessage);
		cf.setFwdOrReplyCp(messageView1.getCodepage());
		cf.setVisible(true);
		cf.performAction(ComposeFrame.ACTION_FORWARD_INPLACE);		
	}	
	
	void miShowPics_actionPerformed(java.awt.event.ActionEvent e) {
		messageView1.showPics();
		mfmb.checkShowPics();
	}
	
	void jMenuItem9_actionPerformed(java.awt.event.ActionEvent e) {
		messageView1.saveMessageAs();
	}
	
	void jMenuItem11_actionPerformed(java.awt.event.ActionEvent e) {
		MessageRow mr = Context.mainFrame.nextMessage(this);		
		if(mr == null)
			return;
		messageView1.showMessageRow(mr);
		setVisible(true);
	}

/*	
	void setMainFrame(MainFrame mainFrame) {
		thhis.mainFrame = mainFrame;
	}
*/	
	
	void jMenuItem12_actionPerformed(java.awt.event.ActionEvent e) {
		MessageRow mr = Context.mainFrame.previousMessage(this);
		if(mr == null)
			return;
		messageView1.showMessageRow(mr);
		setVisible(true);
	}

	void disposeFrame() {
		this_windowClosing(null);
		dispose();		
	}
	
	void jMenuItem13_actionPerformed(java.awt.event.ActionEvent e) {
		try {
			if (messageView1.getMessageId() == null)
				return;
			MessageRow mr = Context.mainFrame.deleteMessage(messageView1.getMessageId(), false);
			if (mr == null) {
				this_windowClosing(null);
				dispose();
				return;
			}
			messageView1.showMessageRow(mr);
			setVisible(true);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
	
	void jMenuItem14_actionPerformed(java.awt.event.ActionEvent e) {
		MessageRow mr = Context.mainFrame.firstMessage(this);		
		if(mr == null)
			return;
		messageView1.showMessageRow(mr);
		setVisible(true);		
	}
		
	void jMenuItem15_actionPerformed(java.awt.event.ActionEvent e) {
		MessageRow mr = Context.mainFrame.lastMessage(this);
		if(mr == null)
			return;
		messageView1.showMessageRow(mr);
		setVisible(true);				
	}

	void jMenuItem17_actionPerformed(java.awt.event.ActionEvent e) {
		MessageRow mr = Context.mainFrame.currentMessage(this);
		if(mr == null)
			return;
		messageView1.showMessageRow(mr);
		setVisible(true);		
	}
	
	void jMenuItem18_actionPerformed(java.awt.event.ActionEvent e) {
		try {
			messageView1.sendNotifyResponse(false);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	void jMenuItem19_actionPerformed(java.awt.event.ActionEvent e) {
		try {
			messageView1.sendNotifyResponse(true);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	
	void jMenuItem20_actionPerformed(java.awt.event.ActionEvent e) {
		messageView1.saveAllAtt();
	}	
			
	public void handleRequest(URL url) {
		if(url.getHost().equalsIgnoreCase("messageframe.gui.olivamail")) {
			switch(url.getPort()) {
			case 1:
				jMenuItem9_actionPerformed(null);
				break;
			case 2:
				jMenuItem19_actionPerformed(null);
				break;
			}
		}
	}

	void jepAtt_mouseClicked(java.awt.event.MouseEvent e) {
	}

	/**
	 * This method initializes jPanel6	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel6() {
		if (jPanel6 == null) {
			jPanel6 = new JPanel();
			jPanel6.setLayout(new BorderLayout());
			jPanel6.setPreferredSize(new java.awt.Dimension(400,40));
			jPanel6.add(getJtbNav(), java.awt.BorderLayout.NORTH);			
		}
		return jPanel6;
	}
		
	/**
	 * This method initializes jtbNav	
	 * 	
	 * @return javax.swing.JToolBar	
	 */    
	private JToolBar getJtbNav() {
		if (jtbNav == null) {
			jtbNav = new JToolBar();
			jtbNav.setPreferredSize(new java.awt.Dimension(300,40));
			jtbNav.setFloatable(true);
			jtbNav.add(getJbPrev());
			jtbNav.add(getJbNext());
			jtbNav.add(getJbShowPics());
		}
		return jtbNav;
	}

	/**
	 * This method initializes jbPrev	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbPrev() {
		if (jbPrev == null) {
			jbPrev = new JButton();
			jbPrev.setText("");
			jbPrev.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItem12_actionPerformed(e);
				}
			});
			jbPrev.setIcon(Context.getImageIcon("prev.png"));
		}
		return jbPrev;
	}

	/**
	 * This method initializes jbNext	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbNext() {
		if (jbNext == null) {
			jbNext = new JButton();
			jbNext.setText("");
			jbNext.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
			jbNext.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jMenuItem11_actionPerformed(e);
				}
			});
			jbNext.setIcon(Context.getImageIcon("next.png"));
		}
		return jbNext;
	}

	/**
	 * This method initializes jbShowPics	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbShowPics() {
		if (jbShowPics == null) {
			jbShowPics = new JButton();
			jbShowPics.setIcon(Context.getImageIcon("shpics.jpg"));
			jbShowPics.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					miShowPics_actionPerformed(e);
				}
			});
			jbShowPics.setEnabled(false);
		}
		return jbShowPics;
	}
		
	void jbShowPics_setEnabled(boolean enabled) {
		jbShowPics.setEnabled(enabled);
	}
		
} // @jve:decl-index=0:visual-constraint="10,10"
