/*
 * @(#)MessagePartStreamHolder.java
 *
 * Copyright (C) 2008 Sergey Bredikhin
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package olivamail.gui;

import java.io.InputStream;

import olivamail.core.common.StreamHolder;
import olivamail.core.mail.Message;

public class MessagePartStreamHolder implements StreamHolder {

	private Message olivaMessage = null;

	private int partNo = -1;

	public MessagePartStreamHolder(Message olivaMessage, int partNo) {
		this.olivaMessage = olivaMessage;
		this.partNo = partNo;
	}

	public InputStream getInputStream() throws Exception {
		return olivaMessage.getBinaryPart(partNo);
	}

}
