package olivamail.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.util.Enumeration;
import java.util.Vector;
import javax.mail.Flags;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import olivamail.core.common.IOUtils;
import olivamail.core.common.ComUtils;
import olivamail.core.mail.MailUtils;
import olivamail.core.mail.Message;
import olivamail.core.mail.MessageHeader;
import olivamail.core.mail.MessagePart;
import olivamail.core.mail.OlivaMimeMessage;

public class MessageView extends JSplitPane implements RequestHandler {	

	private boolean defaultCtntPane = false;
	
	static final long serialVersionUID = 242423L;
		
	private JScrollPane jScrollPane2 = null;	
	
	private JSplitPane jSplitPane1 = this;	
	
	private JScrollPane jScrollPane1 = null;	

	private JPanel jPanel7 = null;
	
	private JLabel jlSubject = null;
	
	private JLabel jlFrom = null;

	private JLabel jlTo = null;

	private JLabel jlSentDate = null;

	private JLabel jlAttachments = null;

	private JTextField jtfSentDate = null;

	private JTextField jtfSubject = null;

	private JTextField jtfTo = null;

	private JTextField jtfFrom = null;

	private JLabel jlCc = null;

	private JTextField jtfCc = null;	
	
	String inReplyTo = "";
	
	private olivamail.core.mail.Message olivaMessage = null;
	
	private MessageRow messageRow = null;

	private String message_id = null;
	
	private String text = null;
	
	private String textHeader = null;
	
	private String textFileName = null;

	private static final int tfHeight = 18;
	
	private static final int tfInterval = 20;	
	
	private static final int attHeight = 30;
	
	private static final int divLimNoAtt = 100;
	
	private static final int divLimAtt = 138;
	
	private static final int divLimSimple = 0;	
	
	private String cp = null;
	
	private ContentPane contentPane1 = null;
	
	private JEditorPane jepAtt = null;
	
	private StringBuffer sbAtt = null;
	
	private Vector atts = null;
	
	private String contentType = null;	
	
	int curAttPort = 0;
	
	int curAttXPos = 5;
	
	int curAttYPos = 5;
	
	private JButton curButton = null;
			
//	private ParentList parent = null;
	
//	private JTable parentTable = null;
	
//	private int parentRow = -1;	
		
	private JPopupMenu jPopupMenu1 = null;

	private JMenuItem jMenuItem1 = null;

	private JMenuItem jMenuItem2 = null;
	
	private boolean hasPics = false;
	
	private JLabel statusBar = null;
	
	private JFrame titleFrame = null;
		
	private IMfMenuBar mfmb = null;
	
	public void setMenuBar(IMfMenuBar mfmb) {
		this.mfmb = mfmb;
	}
	
	/**
	 * This is the default constructor
	 */
	public MessageView() {
		super();
		initialize();
	}

	/**
	 * This is the default constructor
	 */
	public MessageView(boolean defaultCtntPane) {
		super();
		this.defaultCtntPane = defaultCtntPane;		
		initialize();
	}
		
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(700, 350);
		this.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
		this.setDividerSize(1);
		this.setDividerLocation(160);
		this.addPropertyChangeListener("dividerLocation", new java.beans.PropertyChangeListener() { 
			public void propertyChange(java.beans.PropertyChangeEvent e) { 
				jSplitPane1_dividerLocation(e);
			}
		});			
		this.addComponentListener(new java.awt.event.ComponentAdapter() { 
			public void componentResized(java.awt.event.ComponentEvent e) {
				this_componentResized(e);
			}
		});				
		this.setTopComponent(getJPanel7());
		this.setBottomComponent(getJScrollPane1());
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			jlSubject = new JLabel();
			jlSubject.setText(Strings.getString("MessageFrame.subject"));
			jlSubject.setPreferredSize(new Dimension(100, 16));
			jlSubject.setHorizontalAlignment(SwingConstants.LEADING);
			jlSubject.setFont(jlSubject.getFont().deriveFont(Font.BOLD));
			jlCc = new JLabel();
			jlCc.setText(Strings.getString("MessageFrame.cc"));
			jlCc.setPreferredSize(new java.awt.Dimension(100,16));
			jlCc.setFont(jlCc.getFont().deriveFont(Font.BOLD));
			jlAttachments = new JLabel();
			jlAttachments.setText(Strings.getString("MessageFrame.attachments"));
			jlAttachments.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jlAttachments.setPreferredSize(new java.awt.Dimension(100,16));
			jlAttachments.setFont(jlAttachments.getFont().deriveFont(Font.BOLD));
			jlSentDate = new JLabel();
			jlSentDate.setText(Strings.getString("MessageFrame.sentDate"));
			jlSentDate.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jlSentDate.setPreferredSize(new java.awt.Dimension(100,16));
			jlSentDate.setFont(jlSentDate.getFont().deriveFont(Font.BOLD));
			jlTo = new JLabel();
			jlTo.setText(Strings.getString("ComposeFrame.toFiled"));
			jlTo.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jlTo.setPreferredSize(new java.awt.Dimension(100,16));
			jlTo.setFont(jlTo.getFont().deriveFont(Font.BOLD));
			jlFrom = new JLabel();
			jlFrom.setText(Strings.getString("MessageFrame.from"));
			jlFrom.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jlFrom.setPreferredSize(new java.awt.Dimension(100,16));
			jlFrom.setFont(jlFrom.getFont().deriveFont(Font.BOLD));
			jPanel7 = new JPanel();
			jPanel7.add(jlFrom, null);
			jPanel7.add(getJtfFrom(), null);
			jPanel7.add(jlTo, null);
			jPanel7.add(getJtfTo(), null);
			jPanel7.add(jlCc, null);
			jPanel7.add(getJtfCc(), null);
			jPanel7.add(jlSubject, null);
			jPanel7.add(getJtfSubject(), null);			
			jPanel7.add(jlSentDate, null);						
			jPanel7.add(getJtfSentDate(), null);
			jPanel7.add(jlAttachments, null);
			jPanel7.add(getJScrollPane2(), null);		
		}
		return jPanel7;
	}
		
	void jSplitPane1_dividerLocation(java.beans.PropertyChangeEvent e) {
		int divLoc = jSplitPane1.getDividerLocation();
		if(jPanel7.getParent() == null) {
			if (divLoc != divLimSimple)
				jSplitPane1.setDividerLocation(divLimSimple);			
			return;
		}		
		int limAdd = (jtfCc.isVisible()?tfInterval:0);
		int limit = divLimNoAtt + limAdd;
		if (jlAttachments.isVisible()) {
			limit = divLimAtt + limAdd;
		} else {
			if (divLoc != limit)
				jSplitPane1.setDividerLocation(limit);
			return;
		}
		if(divLoc < limit) {
			jSplitPane1.setDividerLocation(limit);
			return;
		}		
		int flexAttSize = attHeight + divLoc - limit;
		int width = this.getWidth() - jlFrom.getWidth() - 40;
		if (width > 0) {
			jScrollPane2.setPreferredSize(new Dimension(width, flexAttSize));
			jScrollPane2.setSize(new Dimension(width, flexAttSize));
		}		
		jPanel7.updateUI();			
		getContentPane1().setSize(jScrollPane1.getSize());
		jScrollPane1.updateUI();				
	}
		
	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getContentPane1().getComponent());
		}
		return jScrollPane1;
	}
		
	/**
	 * This method initializes jtfSentDate	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfSentDate() {
		if (jtfSentDate == null) {
			jtfSentDate = new JTextField();
			jtfSentDate.setPreferredSize(new java.awt.Dimension(570, tfHeight));
			jtfSentDate.setEditable(false);
			TextPopup.registerComponent(jtfSentDate);
		}
		return jtfSentDate;
	}

	/**
	 * This method initializes jtfSubject	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfSubject() {
		if (jtfSubject == null) {
			jtfSubject = new JTextField();
			jtfSubject.setPreferredSize(new java.awt.Dimension(570, tfHeight));
			jtfSubject.setEditable(false);
			TextPopup.registerComponent(jtfSubject);
		}
		return jtfSubject;
	}

	/**
	 * This method initializes jtfTo	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfTo() {
		if (jtfTo == null) {
			jtfTo = new JTextField();
			jtfTo.setPreferredSize(new java.awt.Dimension(570, tfHeight));
			jtfTo.setEditable(false);
			TextPopup.registerComponent(jtfTo);
		}
		return jtfTo;
	}

	/**
	 * This method initializes jtfFrom	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfFrom() {
		if (jtfFrom == null) {
			jtfFrom = new JTextField();
			jtfFrom.setPreferredSize(new java.awt.Dimension(570, tfHeight));
			jtfFrom.setEditable(false);
			TextPopup.registerComponent(jtfFrom);
		}
		return jtfFrom;
	}

	/**
	 * This method initializes jtfCc	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfCc() {
		if (jtfCc == null) {
			jtfCc = new JTextField();
			jtfCc.setPreferredSize(new java.awt.Dimension(570, tfHeight));
			jtfCc.setEditable(false);
			TextPopup.registerComponent(jtfCc);
		}
		return jtfCc;
	}
		
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setPreferredSize(new java.awt.Dimension(570, attHeight));
			jScrollPane2.setViewportView(getJepAtt());
		}
		return jScrollPane2;
	}
		
	/**
	 * This method initializes contentPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private ContentPane getContentPane1() {
		if (contentPane1 == null) {
			if (defaultCtntPane)
				contentPane1 = new DefaultContentPane();
			else {
				try {
					Class storageClass = Class.forName(Context.contentPane);
					Constructor ct = storageClass.getConstructor(null);
					contentPane1 = (ContentPane) ct.newInstance(null);
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
					contentPane1 = new DefaultContentPane();
				}
				// contentPane1 = new JDICContentPane();
			}
		}
		return contentPane1;
	}
		
	/**
	 * This method initializes jEditorPane	
	 * 	
	 * @return javax.swing.JEditorPane	
	 */    
	private JEditorPane getJepAtt() {
		if (jepAtt == null) {
			jepAtt = new JEditorPane();
			jepAtt.setEditable(false);
			jepAtt.setSize(570, 27);
			jepAtt.setContentType("text/html");
			jepAtt.addHyperlinkListener(new HyperlinkListener() {				
				public void hyperlinkUpdate(HyperlinkEvent hyperlinkEvent) {
					if(hyperlinkEvent.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
						curAttPort = hyperlinkEvent.getURL().getPort();
						getJPopupMenu1().show(jepAtt, curAttXPos, curAttYPos);
/*						
						response.resultURL = hyperlinkEvent.getURL();
						System.out.println(response.resultURL);						
						dispose();
*/						
					}
				}
			});												
			jepAtt.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() { 
				public void mouseMoved(java.awt.event.MouseEvent e) {
					curAttXPos = e.getX();
					curAttYPos = e.getY();
				}
			});
			TextPopup.registerComponent(jepAtt);
		}
		return jepAtt;
	}
		
	public void showMessageRow(MessageRow mr) {
		initState();		

		try {							
			javax.mail.Message message = Context.storage.loadMessage(mr.id);
			messageRow = mr;
			cp = mr.codepage;
//			cp = Context.storage.getMessageCodepage(id);			
			this.message_id = mr.id;
			this.showAPIMessage(message);
			if (!mr.sfSeen) {
				String notifyAddress = Context.mailBean.getCoder()
						.getPartHeader(message,
								"Disposition-Notification-To", cp);
				if (!ComUtils.nvl(notifyAddress).equals("")) {
					if (AlertDialog
							.showConfirmDialog(Strings.getString("MessageFrame.sendNotify")
									.replaceFirst("\\$1", notifyAddress)
									.replaceFirst("\\$2", "http://messageframe.gui.olivamail:2")
									, AlertDialog.OK_CANCEL_OPTION, this) == AlertDialog.OK_OPTION) {
						try {
							sendNotifyResponse(false);
						} catch (Exception exc) {
							exc.printStackTrace();
							AlertDialog.showErrorDialog(exc);
						}
					}
				}
				IFolder iFolder = Context.storage.getImapFolder(mr.folderId);
				boolean imapFailed = false;
				try {
					mr.changeMessageFlag(iFolder, true, Flags.Flag.SEEN,
							MessageRow.MESSAGES_FLAGS_SET);
				} catch (Exception exc) {
					if (Context.isConnectionProblem(exc))
						imapFailed = true;
					else
						throw exc;
				}
				if (!imapFailed) {
					Context.storage.saveMessageState(mr);
					Context.mainFrame.updateFldNewMsgInfo();
					Context.mainFrame.updateRowInTable(mr);
				}
			}
		} catch (FileNotFoundException fnfe) {
			if (mr != null && mr.srcPlace.equals("1")) {
				AlertDialog.showErrorDialog(Strings.getString(
						"MessageView.fileNotFound").replaceAll("\\$1", mr.id));
			} else {
				fnfe.printStackTrace();
				AlertDialog.showErrorDialog(fnfe);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	public olivamail.core.mail.Message showAPIMessage(javax.mail.Message message) {
		try {
			if (MailUtils.getContentType(message).equals("message/partial")) {
				AlertDialog
						.showWarningDialog(
								Strings.getString("MessageFrame.notAllParts"));
//				return null;
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
//			return null;
		}		
		olivamail.core.mail.Message msg = null;
		try {
			msg = Context.mailBean.getMessage(message, cp);
			showMessage(msg);
		} catch (Exception exc) {
			exc.printStackTrace();
			if (olivaMessage == null) {
				olivaMessage = new Message();
				olivaMessage.apiMessage = message;
			}
			AlertDialog.showErrorDialog(Strings.getString(
					"MessageFrame.openError").replaceAll("\\$1",
					"http://messageframe.gui.olivamail:1"), exc, this); 
		}
		return msg;
	}	
		
	public void initState() {
		inReplyTo = "";
		messageRow = null;
		olivaMessage = null;
		message_id = null;
		text = null;
		textHeader = null;
		textFileName = null;
		cp = null;
		hasPics = false;
		initGui();
	}
	
	private void initGui() {
		if (mfmb != null)
			mfmb.miOpenReplied_setEnabled(false);
		
		jPanel7.setPreferredSize(new Dimension(jPanel7.getWidth(), 200));
		jPanel7.setSize(new Dimension(jPanel7.getWidth(), 200));
		jlCc.setVisible(true);
		jtfCc.setVisible(true);
		jlAttachments.setVisible(true);
		
		int width = jtfFrom.getWidth();		
		jScrollPane2.setVisible(true);
		jScrollPane2.setPreferredSize(new Dimension(width, attHeight));
		jScrollPane2.setSize(new Dimension(width, attHeight));
		jSplitPane1.setDividerLocation(divLimAtt + (jtfCc.isVisible()?tfInterval:0));
		this_componentResized(null);		
		
		if (jtfFrom != null)
			jtfFrom.setText("");
		if (jtfTo != null)
			jtfTo.setText("");
		if (jtfCc != null)
			jtfCc.setText("");
		if (jtfSubject != null)
			jtfSubject.setText("");
		if (jtfSentDate != null)
			jtfSentDate.setText("");
		sbAtt = null;
		getJepAtt().setText("");
		atts = null;
		curButton = null;
		contentType = null;
		setTextData("");
		if (statusBar != null)
			statusBar.setText("");
	}

	public void setTextData(String str) {
		text = str;
		contentPane1.setContentType("text/plain");
		contentPane1.setText(text);
		contentPane1.setCaretPosition(0);
	}

	public void setFileName(String filename) {
		textFileName = filename;
	}	

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}		
	
	public void setHtmlData(String str) {
		setHtmlData(str, Context.hidePictures);
	}
	
	public void setHtmlData(String str, boolean hidePictures) {
		hasPics = false;
		String fontSize = "3";
		if (!Context.contentPane
				.equalsIgnoreCase("olivamail.gui.DefaultContentPane"))
			fontSize = "2";

		text = str;

		if (hidePictures && Context.hasPics(str)) {
			str = ComUtils.nvl(str);
			String strNoPics = Context.getHtmlNoPics(str);
			if (str != strNoPics) {
				// if (!str.equals(strNoPics)) {
				str = strNoPics;
				strNoPics = null;
				hasPics = true;
			}
		}

		if (str.length() > 128 * 1024) {
			AlertDialog.showInfoDialog(Strings
					.getString("MessageFrame.textTooLong"));
			return;
		}
		contentPane1.setContentType("text/html");
		if (contentType == null) {
			if (Context.htmlMetaCharset != null) {
				StringBuffer sb = new StringBuffer();
/*				
				sb.append("<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=")
						.append(Context.htmlMetaCharset).append("\"></head><body>");
*/				
				sb.append(str);
				//sb.append("</body></html>");
				contentPane1.setText(sb.toString());
			} else
				contentPane1.setText(str);
		} else {
			StringBuffer sb = new StringBuffer();
			if (str == null)
				;
			else if (contentType.equals("text/html")) {
				sb = new StringBuffer(str);
			} else if (contentType.startsWith("text/")) {
				sb.append(
						"<font face=\"Fixed, Lucida Console\" size=\""
								+ fontSize + "\">").append(
						olivamail.core.mail.MailUtils.replaceODOA(str.replaceAll("<",
								"&lt;").replaceAll(">", "&gt;"), "<br>"))
						.append("</font>");
			} else if (contentType.compareTo("message/delivery-status") == 0)
				sb.append("<pre>").append(str).append("</pre>");
			else if (contentType.compareTo("message/partial") == 0)
				sb.append("<h3>").append(
						Strings.getString("splittedMessageBody")).append(
						"</h3>");
			contentPane1.setText(sb.toString());
		}
		contentPane1.setCaretPosition(0);
		/*
		 * jEditorPane1.setText(new String(jEditorPane1.getText()));
		 * jEditorPane1.updateUI();
		 */
		return;
	}
		
	public void sendNotifyResponse(boolean inter) throws Exception {
                String deliveredTo = Context.mailBean.getCoder().getPartHeader(olivaMessage.apiMessage,"Delivered-To", cp); // deliveredTo should point to one receipient from which respond to send
		Vector acnts = Context.storage.getAccounts(deliveredTo);
		Account acnt = null;
		if(acnts.size() == 0)
			acnt = AcntSelDialog.showAccountDialog(null);
		else if(acnts.size() == 1)
			acnt = (Account) acnts.get(0);
		else {
			acnt = AcntSelDialog.showAccountDialog(deliveredTo);
			if(acnt == null) {
				AlertDialog.showInfoDialog(Strings.getString("Context.noAccount"));
				return;
			}
		}
/*			
		if(acnt == null)
			acnt = Context.storage.getDefaultAccount();
*/			
		String fromAddr = acnt.email;
		if(!acnt.person.equals(""))
			fromAddr = acnt.person + " <" + acnt.email + ">";  		
		OlivaMimeMessage mimeMsg = Context.mailBean.createNotifyResponse(
				fromAddr,
				olivaMessage, cp,
				Strings.getString("MessageFrame." + ((inter)?"i":"") + "notifySubject"),
				Strings.getString("MessageFrame." + ((inter)?"i":"") + "notifyText"));
/*		
		if (!ComUtils.nvl(acnt.replyTo).equals(""))
			newMsg.ReplyTo = acnt.replyTo;
		if (!ComUtils.nvl(acnt.organization).equals(""))
			newMsg.addHeader("Organization", acnt.organization);			
*/		
		MessageHeader hdr = Context.mailBean.getMessageHeader(mimeMsg, null);
		hdr.UID = Context.mailBean.getOlivaMsgUID(mimeMsg);
		hdr.hasAtt = true;
		Context.storage.saveMessage(hdr, Context.storage.getOutboxFolder(),
				mimeMsg, "".hashCode(), null, null, acnt.id);
		MailContext.sendFromOutbox();
	}
		
	public void handleRequest(URL url) {
		if(url.getHost().equalsIgnoreCase("messageframe.gui.olivamail")) {
			switch(url.getPort()) {
			case 1:
				jMenuItem9_actionPerformed(null);
				break;
			case 2:
				try {
					sendNotifyResponse(true);
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
				}				
				break;
			}
		}
	}
			
	void jMenuItem9_actionPerformed(java.awt.event.ActionEvent e) {
		String filename = null;
		if(olivaMessage != null) {
			filename = getMessageFileName(olivaMessage);
		} else if(textFileName != null) {
			filename = MessageContext.escapeBraces(textFileName);			
		} else if(contentPane1.getContentType().equals("text/html"))
			filename = "part.htm";
		else if(contentPane1.getContentType().equals("text/plain"))
			filename = "part.txt";
		
		File file = Context.fileSaveDialog(this, filename);
		if (file == null)
			return;

/*
 * InputStream is = Context.mailBean
 * .getRfc822Part(olivaMessage.messagePartsContent
 * .get(mp.partNo)).apiMessage.getDataHandler() .getInputStream();
 * Context.writeFile(is, file);
 */				
		try {
			if (olivaMessage != null) {
				OutputStream os = Context.getFileOutputStream(file);
				olivaMessage.apiMessage.writeTo(os);
				Context.closeOutputStream(os);
				file = null;
			} else {
				ByteArrayInputStream bais = new ByteArrayInputStream(text.getBytes());
				IOUtils.writeFile(bais, file);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}
			
	public void openReplied() {
		if (olivaMessage == null || olivaMessage.apiMessage == null)
			return;
		try {
			if (!inReplyTo.equals("")) {
				MessageRow mr = null;
				Vector list = Context.storage.getMessageList(null,
						"MESSAGE_ID = '" + inReplyTo + "'", null, -1);
				if (list != null && list.size() > 0)
					mr = (MessageRow) list.get(0);
				if (mr != null)
					mr = MessageContext.prepareMessageForOpen(mr, null);
				if (mr == null) {
					AlertDialog.showWarningDialog(Strings.getString(
							"MessageFrame.repliedNotFound").replaceAll(
							"\\$id",
							inReplyTo.replaceAll("<", "&lt;").replaceAll(">",
									"&gt;")));
					return;
				}
				MessageFrame mf = new MessageFrame();
				mf.setVisible(true);
				mf.showMessageRow(mr);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
	
	public void showMessage(olivamail.core.mail.Message msg) {
		String fontSize = "3";
		if(!Context.contentPane.equalsIgnoreCase("olivamail.gui.DefaultContentPane"))
			fontSize = "2";
		olivaMessage = msg;
		if (cp == null) {
			if(titleFrame != null)
				titleFrame.setTitle(Strings.getString("MessageFrame.title") + " - " + Strings.getString("cpAuto"));
		} else {
			if(titleFrame != null)
				titleFrame.setTitle(Strings.getString("MessageFrame.title") + " - " + Charsets.getNameForCp(cp));
		}
		try {
			inReplyTo = Context.mailBean.getCoder().getPartHeader(
					olivaMessage.apiMessage, "In-Reply-To", cp);			
			if(!inReplyTo.equals("") && mfmb != null) {
				mfmb.miOpenReplied_setEnabled(true);
			}
			
			if(statusBar != null)
				statusBar.setText("   " + Strings.getString("MessageFrame.msgSize") + " " + ComUtils.getSizeString(msg.msgSize));
			if (msg.apiMessage != null) {
				try {
					String xMailer = Context.mailBean.getCoder().getPartHeader(msg.apiMessage, "X-Mailer", cp);
					if(xMailer.equals("")) {
						xMailer = Context.mailBean.getCoder().getPartHeader(msg.apiMessage, "User-Agent", cp);	
					}
					if (statusBar != null)
						statusBar.setText((new StringBuffer(statusBar.getText())
							.append(",   "))
							.append((Strings.getString("MessageFrame.senderMTA")))
							.append(" ").append(
							xMailer).toString());
				} catch (Exception exc) {
					exc.printStackTrace();
				}				
//				Context.mailBean.setUsePOP3UID(false);
				msg.UID = Context.mailBean.getOlivaMsgUID(msg.apiMessage);
			}
			StringBuffer sb = new StringBuffer();
			sb.append("<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" bgcolor=\"#999999\" width=\"100%\">\n");
			sb.append("<tr>\n<td bgcolor=\"#cccccc\">\n");
			sb.append(
					Strings.getString("MessageFrame.from")
							+ " "
							+ olivamail.core.mail.MailUtils.getHtmlAddressList(msg.From,
									null)).append("<br>\n");
			jtfFrom.setText(msg.From);
			sb.append(
					Strings.getString("MessageFrame.to")
							+ " "
							+ olivamail.core.mail.MailUtils.getHtmlAddressList(msg.To,
									null))
					.append("<br>\n");
			jtfTo.setText(msg.To);
			if (!msg.Cc.trim().equals("")) {
				sb.append(
						Strings.getString("MessageFrame.cc")
								+ " "
								+ olivamail.core.mail.MailUtils.getHtmlAddressList(
										msg.Cc, null))
						.append("<br>\n");
				jtfCc.setText(msg.Cc);
			} else {
				jlCc.setVisible(false);
				jtfCc.setVisible(false);
				jSplitPane1.setDividerLocation(divLimAtt + (jtfCc.isVisible()?tfInterval:0));				
/*				
				jPanel7.remove(jlCc);
				jPanel7.remove(jtfCc);
*/
				jPanel7.setPreferredSize(new Dimension(jPanel7.getWidth(), jPanel7.getHeight() - 25));
				jPanel7.setSize(new Dimension(jPanel7.getWidth(), jPanel7.getHeight() - 25));	
				jPanel7.updateUI();				
			}
			sb.append(Strings.getString("MessageFrame.subject") + 
					" " + msg.Subject).append("<br>\n");
			jtfSubject.setText(msg.Subject);
			sb.append(Strings.getString("MessageFrame.sentDate") + 
					" " + msg.getSentDateToString()).append("<br>\n");
			jtfSentDate.setText(msg.getSentDateToString());			
			if(message_id != null) {
				MessageRow mr = Context.storage.getMessageRow(message_id);
				sb.append(Strings.getString("MessageFrame.msgSize") + " " +
						olivamail.core.common.ComUtils.getSizeString(mr.msgSize));
			} else
				sb.append(Strings.getString("MessageFrame.msgSize") + " " +
						olivamail.core.common.ComUtils.getSizeString(msg.msgSize));							
			sb.append("\n</td>\n</tr>\n</table>\n<br>\n");
			// Create buttons for attachments
			for(Enumeration en = MessageContext.extractAttachmets(msg).elements(); en.hasMoreElements();) {
				addAttachment((olivamail.core.mail.MessagePart)en.nextElement());
			}

//			sb.append("<hr>");
//			show();
						
			textHeader = sb.toString();			
			sb = new StringBuffer();
								
			if(atts == null || atts.size() == 0) {
				jlAttachments.setVisible(false);
				jScrollPane2.setVisible(false);
				jPanel7.setPreferredSize(new Dimension(jPanel7.getWidth(), jPanel7.getHeight() - 35));
				jPanel7.setSize(new Dimension(jPanel7.getWidth(), jPanel7.getHeight() - 35));
				jPanel7.updateUI();
				
				jSplitPane1.setDividerLocation(divLimNoAtt + (jtfCc.isVisible()?tfInterval:0));
			}

			// Show text parts
			boolean allowHr = false;
			if (msg.messageParts != null) {
				for (java.util.Enumeration en = msg.messageParts.elements(); en
						.hasMoreElements();) {
					olivamail.core.mail.MessagePart textPart = (olivamail.core.mail.MessagePart) en
							.nextElement();
					if (textPart.fileName != null || textPart.cid != null
							|| textPart.alternative
							|| textPart.type == olivamail.core.mail.MessagePart.T_RFC822
							|| textPart.type == olivamail.core.mail.MessagePart.T_BINARY
							)
						//  || textPart.type == olivamail.core.mail.MessagePart.T_EMPTY // for message/partial 						
						continue;
					String textPartText = null;
					if (!textPart.isMimeType("message/partial")) {					
						textPartText = olivaMessage.getTextPart(textPart.partNo);
					}
					if (textPart.isMimeType("text/html")) {
						if (msg.cids != null) {
							for (java.util.Enumeration ciden = msg.cids
									.elements(); ciden.hasMoreElements();) {
								MessagePart cidPart = (MessagePart)ciden.nextElement();
								String ext = ComUtils.nvl(MailUtils.getExtension(cidPart.contentType));
								String filename = "msg" + msg.UID + "_" + cidPart.partNo + "." + ext;									
								File file = new File(Context.cache_dir + filename); 										
								if (!file.exists()) {
									InputStream is = olivaMessage.getBinaryPart(cidPart.partNo);									
									IOUtils.writeFile(is, file);
								}
								file = null;
								String link = Context.cache_link + filename;
								textPartText = textPartText.replaceAll(cidPart.getCidPattern(), link);
							}
						}
						textPartText = MailUtils.escapeHtmlTags(textPartText);
					} else if (textPart.isMimeType("text/*")) {
						textPartText = "<font face=\"Fixed, Lucida Console\" size=\"" + fontSize + "\">"
							+ olivamail.core.mail.MailUtils.replaceODOA(textPartText
										.replaceAll("<", "&lt;")
										.replaceAll(">", "&gt;"), "<br>") + "</font>";
					} else if (textPart.isMimeType("message/delivery-status"))
						textPartText = "<pre>" + textPartText + "</pre>";
					else if (textPart.isMimeType("message/partial"))
						textPartText = "<h3>" + Strings.getString("MessageFrame.splittedMessageBody") + "<h3>";
					if (textPartText != null) {
						if (allowHr) {
							sb.append("<hr>");
						}
						sb.append("<div>").append(textPartText).append("<div>");
						allowHr = true;
					}
				}

				// Show image parts
				if (Context.mailBean.isRichContent()) {
					for (java.util.Enumeration en = msg.messageParts.elements(); en
							.hasMoreElements();) {
						olivamail.core.mail.MessagePart att = (olivamail.core.mail.MessagePart) en
								.nextElement();
						if (att.fileName != null && att.isMimeType("image/*")) {							
							String ext = Context.getExtension(att.fileName);
							if(ext == null)
								ext = "";							
							
							File file = new File(Context.cache_dir + "msg"
									+ msg.UID + "_" + att.partNo + ext);
							if (!file.exists()) {
								InputStream is = olivaMessage.getBinaryPart(att.partNo);								
								IOUtils.writeFile(is, file);
							}
							file = null;
							String link = Context.cache_link + "msg" + msg.UID
									+ "_" + att.partNo + ext;
							if (allowHr) {
								sb.append("<hr>");
							}
							sb.append("<p><img src=").append(link).append(
									"></p>");
							allowHr = true;
						}
					}
				}
			}
			this.setHtmlData(sb.toString());
			text = sb.toString();
/*
			this.osFileName = "msg" + msg.UID + ".htm";
			ByteArrayInputStream bais = new ByteArrayInputStream(
					("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n<meta http-equiv=\"Content-Language\" content=\"ru-RU\">\n<meta HTTP-EQUIV=\"PRAGMA\" content=\"NO-CACHE\">\n<title>Message</title>\n</head>\n<body link=\"#000033\" alink=\"#000033\" vlink=\"#000033\">\n" + sb
							.append("</body>\n</html>").toString())
							.getBytes("UTF-8"));
			Context.writeFile(bais, new File(Context.cache_dir
					+ this.osFileName));
*/		
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
				
	public void addAttachment(olivamail.core.mail.MessagePart mp) {
		/*
		 * final JButton jButtonAtt = new JButton(); //
		 * jButtonAtt.setBorderPainted(false); jButtonAtt.setText(mp.fileName);
		 * jButtonAtt.addMouseListener(new java.awt.event.MouseAdapter() {
		 * public void mouseClicked(java.awt.event.MouseEvent e) { curButton =
		 * jButtonAtt; jButtonAtt_mouseClicked(e); } }); // start
		 * jButtonAtt.addActionListener(new java.awt.event.ActionListener() {
		 * public void actionPerformed(ActionEvent e) {
		 * jButtonAtt_actionPerformed((JButton) e.getSource()); } }); // end
		 * jPanel2.add(jButtonAtt, null); buttons.put(jButtonAtt, mp);
		 */
		if (sbAtt == null)
			sbAtt = new StringBuffer();
		if (sbAtt.length() > 0)
			sbAtt.append(";   ");
		if (atts == null)
			atts = new Vector(5);
		atts.add(mp);
		int attPort = atts.indexOf(mp);

		int size = -1;
		try {
			size = olivaMessage.getPartSize(mp.partNo);
		} catch (Exception exc) {
		}

		String filename = mp.fileName;
		if(filename.trim().equals("")) {
			mp.fileName = "noname." + MailUtils.getExtension(mp.contentType);
			filename = "&lt;" + mp.fileName + "&gt;";
		}
		sbAtt.append("<a href=\"http://message.gui.olivamail:").append(attPort)
				.append("\">").append(filename).append("</a>").append(
						(size == -1) ? "" : " [" + ComUtils.getSizeString(size)
								+ "]");
		// .append(mp.fileName).append("</a>");
		jepAtt.setText(sbAtt.toString());
		jepAtt.setCaretPosition(0);
	}
		
	void this_componentResized(java.awt.event.ComponentEvent e) {
		int width = this.getWidth() - jlFrom.getWidth() - 40;
		if (width > 0) {
			Dimension dim = new Dimension(width, tfHeight);
			jtfFrom.setPreferredSize(dim);
			jtfFrom.setSize(dim);
			jtfTo.setPreferredSize(dim);
			jtfTo.setSize(dim);
			jtfCc.setPreferredSize(dim);
			jtfCc.setSize(dim);
			jtfSubject.setPreferredSize(dim);
			jtfSubject.setSize(dim);
			jtfSentDate.setPreferredSize(dim);
			jtfSentDate.setSize(dim);
			int flexAttHeight = jScrollPane2.getHeight(); 
			jScrollPane2.setPreferredSize(new Dimension(width, flexAttHeight));
			jScrollPane2.setSize(new Dimension(width, flexAttHeight));
		}
		jPanel7.updateUI();			
		getContentPane1().setSize(jScrollPane1.getSize());
		jScrollPane1.updateUI();						
	}
		
	public void showPics() {
		if (contentPane1.getContentType().equals("text/html"))
			setHtmlData(text, false);
	}

	public String getCodepage() {
		return cp;
	}
	
	public void setCodepage(String cp) {
		this.cp = cp;
		initGui();
		olivamail.core.mail.Message msg = showAPIMessage(olivaMessage.apiMessage);
		if (message_id != null) {
			try {
				Context.storage.setMessageCodepage(message_id, cp, msg.From,
						msg.To, msg.Subject);
				if(messageRow != null) {
					messageRow.codepage = cp;
					Context.mainFrame.updateMessageIfNeeded(messageRow);
				}
/*				
				if(parent != null) {
					parent.updateRow(parentTable, parentRow, message_id);
				}
*/				
			} catch (Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
		}		
	}
	
/*	
	public void setParent(ParentList parent, JTable table, int row) {
		this.parent = parent;
		parentTable = table;
		parentRow = row;
	}
*/	
		
	private void jButtonAtt_actionPerformed(int attPort) {
		olivamail.core.mail.MessagePart mp = (olivamail.core.mail.MessagePart) atts.get(attPort);
		try {
			if (mp.type == olivamail.core.mail.MessagePart.T_BINARY) {
				File file = Context.fileSaveDialog(this, mp.fileName);
				if (file == null)
					return;
				InputStream is = olivaMessage.getBinaryPart(mp.partNo);
				IOUtils.writeFile(is, file);
				file = null;
			}
			if (mp.type == olivamail.core.mail.MessagePart.T_RFC822
					|| mp.type == olivamail.core.mail.MessagePart.T_TEXT) {
				String filename = mp.fileName;
				if (mp.type == olivamail.core.mail.MessagePart.T_RFC822)
					filename += ".eml";
				else
					filename = MessageContext.escapeBraces(filename);
				File file = Context.fileSaveDialog(this, filename);
				if (file == null)
					return;
				if (mp.type == olivamail.core.mail.MessagePart.T_RFC822) {
					OutputStream os = Context.getFileOutputStream(file);
					olivaMessage.getRfc822Part(mp.partNo).apiMessage
							.writeTo(os);
					Context.closeOutputStream(os);
					file = null;
				} else {
					ByteArrayInputStream bais = new ByteArrayInputStream(
							olivaMessage.getTextPart(mp.partNo).getBytes());
					IOUtils.writeFile(bais, file);
				}
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	/**
	 * This method initializes jMenuItem1
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem();
			jMenuItem1.setText(Strings.getString("MessageFrame.openMenuItem"));
			jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//jButtonAtt_open(curButton);
					jButtonAtt_open(curAttPort);
				}
			});
		}
		return jMenuItem1;
	}

	/**
	 * This method initializes jMenuItem2
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem2() {
		if (jMenuItem2 == null) {
			jMenuItem2 = new JMenuItem();
			jMenuItem2.setText(Strings.getString("MessageFrame.saveAsMenuItem"));
			jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButtonAtt_actionPerformed(curAttPort);
					//jButtonAtt_actionPerformed(curButton);
				}
			});
		}
		return jMenuItem2;
	}
		
	/**
	 * This method initializes jPopupMenu1
	 * 
	 * @return javax.swing.JPopupMenu
	 */
	private JPopupMenu getJPopupMenu1() {
		if (jPopupMenu1 == null) {
			JPopupMenu.setDefaultLightWeightPopupEnabled(false);			
			jPopupMenu1 = new JPopupMenu();
			jPopupMenu1.add(getJMenuItem1());
			jPopupMenu1.add(getJMenuItem2());
		}
		return jPopupMenu1;
	}	
	
	void jButtonAtt_open(int attPort) {
		olivamail.core.mail.MessagePart mp = (olivamail.core.mail.MessagePart)atts.get(attPort);
		try {
			if(mp.type == olivamail.core.mail.MessagePart.T_BINARY && mp.contentType.equalsIgnoreCase("message/rfc822")) {
				MessageFrame mf = new MessageFrame();
				mf.setVisible(true);
				Session session = Session.getDefaultInstance(System
						.getProperties());
				mf.showMessage(new MimeMessage(session, olivaMessage
						.getBinaryPart(mp.partNo)));
				mf.hideNavCtrls();
				return;
			}
			if (mp.type == olivamail.core.mail.MessagePart.T_RFC822) {
				MessageFrame mf = new MessageFrame();
				mf.setVisible(true);
				mf.showOlivaMessage(olivaMessage.getRfc822Part(mp.partNo));
				mf.hideNavCtrls();
				return;
			}			
			if (mp.type == olivamail.core.mail.MessagePart.T_BINARY) {
				String ext = Context.getExtension(mp.fileName);
				if(ext == null)
					ext = "";
				File file = new File(Context.cache_dir + "msg"
						+ olivaMessage.UID + "_" + mp.partNo + ext);
				if (!file.exists()) {
					InputStream is = olivaMessage.getBinaryPart(mp.partNo);					
					IOUtils.writeFile(is, file);
				}
				Ocm ocm = new Ocm();
				String program = Context.getProgram(ext);
				if(program == null) {
					AlertDialog.showInfoDialog(Strings.getString("MessageFrame.noProgram"));					
					return;
				}
				try {
					//ocm.run(program + " " + file.getPath(), System.out);
					ocm.run(program.replaceAll("%1", file.getPath().replaceAll("\\\\", "\\\\\\\\")), System.out, false);
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
				}
				return;
			}
			if (mp.type == olivamail.core.mail.MessagePart.T_TEXT) {
				MessageFrame mf = new MessageFrame(true);
				mf.setVisible(true);
				mf.hideButtons();
				mf.hideNavCtrls();
				String textPartText = olivaMessage.getTextPart(mp.partNo);			
/*
				if (textPartText == null)
					;			
				else if (mp.contentType.compareTo("text/html") == 0) {
					;
				} else if (mp.contentType.startsWith("text/")) {
					textPartText = "<font face=\"Courier\" size=\"3\">"
							+ olivamail.core.mail.MailUtils.replaceODOA(textPartText
									.replaceAll("<", "&lt;").replaceAll(">",
											"&gt;"), "<br>") + "</font>";
				} else if (mp.contentType.compareTo("message/delivery-status") == 0)
					textPartText = "<pre>" + textPartText + "</pre>";
				else if (mp.contentType.compareTo("message/partial") == 0)
					textPartText = "<h3>" + Strings.getString("splittedMessageBody") + "</h3>";
*/				
				if (textPartText != null) {
					mf.setContentType(mp.contentType);
					mf.setHtmlData(textPartText);
					mf.setFileName(mp.fileName);
				}
				return;				
			}
		} catch (Exception exc) {
			exc.printStackTrace();			
			AlertDialog.showErrorDialog(exc);
		}
	}
		
	void jButtonAtt_mouseClicked(java.awt.event.MouseEvent e) {
		if (e.getButton() != MouseEvent.BUTTON3 && e.getButton() != MouseEvent.BUTTON1)
			return;
		getJPopupMenu1().show(curButton, curAttXPos, curAttYPos);
	}

	public void toggleTextHtml() {
		if (contentPane1.getContentType().equals("text/plain"))
			setHtmlData(text);
		else {
			contentPane1.setContentType("text/plain");
			contentPane1.setText(text);
		}
	}
		
	public Message getOlivaMessage() {
		return olivaMessage;
	}
	
	public String getOSFileName() {
		return "msg" + olivaMessage.UID + ".htm";
	}
	
	public String getTextContent() {
		StringBuffer sb = new StringBuffer();
//		sb.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n<meta http-equiv=\"Content-Language\" content=\"ru-RU\">\n<meta HTTP-EQUIV=\"PRAGMA\" content=\"NO-CACHE\">\n<title>Message</title>\n</head>\n<body link=\"#000033\" alink=\"#000033\" vlink=\"#000033\">\n")
//		sb.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html\">\n<title>Message</title>\n</head>\n<body>\n")	
		sb.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n");
		if(Context.htmlMetaCharset != null) {
			sb.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=")
			.append(Context.htmlMetaCharset).append("\">\r\n");
		} else {
			sb.append("<meta http-equiv=\"Content-Type\" content=\"text/html\">\r\n");			
		}		
		sb.append("<title>Message</title>\r\n</head>\r\n<body>\r\n")
			.append(textHeader).append(text).append("</body>\r\n</html>");		
		return sb.toString();
	}

	public void saveMessageAs() {
		String filename = null;
		if(olivaMessage != null) {
			filename = getMessageFileName(olivaMessage);
		} else if(textFileName != null) {
			filename = MessageContext.escapeBraces(textFileName);			
		} else if(contentPane1.getContentType().equals("text/html"))
			filename = "part.htm";
		else if(contentPane1.getContentType().equals("text/plain"))
			filename = "part.txt";
		
		File file = Context.fileSaveDialog(this, filename);
		if (file == null)
			return;

		try {
			if (olivaMessage != null) {
				OutputStream os = Context.getFileOutputStream(file);
				olivaMessage.apiMessage.writeTo(os);
				Context.closeOutputStream(os);
				file = null;
			} else {
				ByteArrayInputStream bais = new ByteArrayInputStream(text.getBytes());
				IOUtils.writeFile(bais, file);
			}
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}
		
	public String getMessageId() {
		return message_id;		
	}

	public void saveAllAtt() {
		try {
			File dir = Context.dirOpenDialog(this);
			if (dir == null)
				return;
			
			ReceivingResult result = MessageContext.saveAllAtt(olivaMessage, atts,
					dir);
			if (result.skipped > 0)
				AlertDialog.showInfoDialog(Strings.getString(
						"MessageFrame.filesSavedSkipped").replaceAll("\\$1",
						String.valueOf(result.received)).replaceAll("\\$2",
						String.valueOf(result.skipped)));
			else
				AlertDialog.showInfoDialog(Strings.getString(
						"MessageFrame.filesSaved").replaceAll("\\$1",
						String.valueOf(result.received)));
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}	
			
	public boolean hasPics() {
		return hasPics;
	}
	
	public void hideHeaders() {
		this.remove(jPanel7);	
		this.setDividerLocation(divLimSimple);
	}
	
	public void setStatusBar(JLabel statusBar) {
		this.statusBar = statusBar;
	}

	public void setTitleFrame(JFrame titleComponent) {
		this.titleFrame = titleComponent;
	}	
	
	public String getMessageFileName(olivamail.core.mail.Message message) {
		String filename = message.Subject;
		if(filename == null)
			filename = "";
		filename = filename.replaceAll("[\\\\/:\\*\\?\"<>\\|]", "");
		if(filename.length() == 0)
			filename = "message.eml";
		else
			filename += ".eml";
		return filename;
	}
		
}
