package olivamail.gui;

import java.awt.BorderLayout;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.OutputStream;
import java.util.Vector;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;
import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JProgressBar;
import javax.swing.border.TitledBorder;
import javax.swing.JCheckBox;

import olivamail.core.common.ComUtils;
import olivamail.core.mail.MessageHeader;

public class MsgExportToFsFrame extends JDialog {

	static final long serialVersionUID = 4675075126622923991L;	
	
	private final String WIN_ID = "export";
	
	private JPanel jContentPane = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JLabel jlPath = null;

	private JTextField jtfPath = null;

	private JButton jbPath = null;

	private JLabel jlName = null;

	private JComboBox jcbName = null;

	private JLabel jlScope = null;

	private JComboBox jcbScope = null;

	private JProgressBar jProgressBar1 = null;

	private JButton jbExport = null;

	private JButton jbClose = null;

	public static final int NAME_ID = 0;
	
	public static final int NAME_SUBJECT = 1;
	
	public static final int SCOPE_SELECTED = 0;
	
	public static final int SCOPE_FOLDER = 1;
	
	public static final int SCOPE_ALL = 2;
	
	private MainFrame parent = null;

	private JPanel jpExport = null;

	private JPanel jpImport = null;

	private JButton jbImport = null;

	private JCheckBox jcbSaveFolders = null;

	private JLabel jlImportFolder = null;

	private JComboBox jcbImportFolder = null;
	
	private static final String EXT = ".eml";
	
	/**
	 * This is the default constructor
	 */
	public MsgExportToFsFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(479, 298);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setResizable(false);
		this.setTitle(Strings.getString("MsgExportToFsFrame.title"));
		this.setContentPane(getJContentPane());
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}	
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jlPath = new JLabel();
			jlPath.setText(Strings.getString("MsgExportToFsFrame.pathField"));
			jPanel1 = new JPanel();
			jPanel1.add(jlPath, null);
			jPanel1.add(getJtfPath(), null);
			jPanel1.add(getJbPath(), null);
			jPanel1.add(getJcbSaveFolders(), null);			
			jPanel1.add(getJpExport(), null);
			jPanel1.add(getJpImport(), null);
			jPanel1.add(getJProgressBar1(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setPreferredSize(new java.awt.Dimension(10,40));
			jPanel2.add(getJbExport(), null);
			jPanel2.add(getJbImport(), null);
			jPanel2.add(getJbClose(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jtfPath	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJtfPath() {
		if (jtfPath == null) {
			jtfPath = new JTextField();
			jtfPath.setPreferredSize(new java.awt.Dimension(325,20));
			TextPopup.registerComponent(jtfPath);
		}
		return jtfPath;
	}

	/**
	 * This method initializes jbPath	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbPath() {
		if (jbPath == null) {
			jbPath = new JButton();
			jbPath.setText(Strings.getString("MsgExportToFsFrame.pathSelect"));
			jbPath.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbPath_actionPerformed(e);
				}
			});
		}
		return jbPath;
	}

	void jbPath_actionPerformed(java.awt.event.ActionEvent e) {
		File file = Context.dirOpenDialog(this);
		if(file == null)
			return;
		jtfPath.setText(file.getPath());
	}
	
	/**
	 * This method initializes jcbName	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJcbName() {
		if (jcbName == null) {
			String[] names = {Strings.getString("MsgExportToFsFrame.nameTypeId"), 
					Strings.getString("MsgExportToFsFrame.nameTypeSubject")};
			jcbName = new JComboBox(names);
			jcbName.setPreferredSize(new java.awt.Dimension(100,20));
		}
		return jcbName;
	}

	/**
	 * This method initializes jcbScope	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJcbScope() {
		if (jcbScope == null) {
			String[] scopes = { 
					Strings.getString("MsgExportToFsFrame.scopeTypeSel"),
					Strings.getString("MsgExportToFsFrame.scopeTypeFolder"),
					Strings.getString("MsgExportToFsFrame.scopeTypeAll")
			};
			jcbScope = new JComboBox(scopes);
			jcbScope.setPreferredSize(new java.awt.Dimension(100, 20));
		}
		return jcbScope;
	}

	/**
	 * This method initializes jProgressBar1
	 * 
	 * @return javax.swing.JProgressBar
	 */    
	private JProgressBar getJProgressBar1() {
		if (jProgressBar1 == null) {
			jProgressBar1 = new JProgressBar();
			jProgressBar1.setPreferredSize(new java.awt.Dimension(446,20));
		}
		return jProgressBar1;
	}

	/**
	 * This method initializes jbExport	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbExport() {
		if (jbExport == null) {
			jbExport = new JButton();
			jbExport.setText(Strings.getString("MsgExportToFsFrame.export"));
			jbExport.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbExport_actionPerformed(e);
				}
			});
		}
		return jbExport;
	}

	void jbExport_actionPerformed(java.awt.event.ActionEvent e) {
		String path = jtfPath.getText().trim();
		if(path.equals("")) {
			AlertDialog.showWarningDialog(Strings.getString("MsgExportToFsFrame.pathNull"));
			return;		
		}
		int nameType = jcbName.getSelectedIndex();
		int scopeType = jcbScope.getSelectedIndex();
		if (AlertDialog.showConfirmDialog(
				Strings.getString("MsgExportToFsFrame.startExport"),
				AlertDialog.YES_NO_OPTION) == AlertDialog.NO_OPTION) {
			return;
		}
//		setVisible(false);
		performExport(path, nameType, scopeType, jcbSaveFolders.isSelected(), jProgressBar1);
//		AlertDialog.showInfoDialog(Strings.getString("MsgExportToFsFrame.exportCompleted"));		
//		dispose();
	}
	
	/**
	 * This method initializes jbClose	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbClose() {
		if (jbClose == null) {
			jbClose = new JButton();
			jbClose.setText(Strings.getString("closeButton"));
			jbClose.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return jbClose;
	}

	public void setParent(MainFrame parent) {
		this.parent = parent;
	}

	/**
	 * This method initializes jpExport	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJpExport() {
		if (jpExport == null) {
			jpExport = new JPanel();
			TitledBorder titledBorder = javax.swing.BorderFactory
					.createTitledBorder(new javax.swing.border.SoftBevelBorder(
							javax.swing.border.SoftBevelBorder.LOWERED),
							Strings.getString("MsgExportToFsFrame.export"),
							javax.swing.border.TitledBorder.LEFT,
							javax.swing.border.TitledBorder.TOP, null, null);
			titledBorder.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED));
			jlScope = new JLabel();
			jlScope.setText(Strings.getString("MsgExportToFsFrame.scope"));
			jlName = new JLabel();
			jlName.setText(Strings.getString("MsgExportToFsFrame.nameBase"));						
			jpExport.setPreferredSize(new java.awt.Dimension(450,60));
			jpExport.setBorder(titledBorder);
			jpExport.add(jlName, null);
			jpExport.add(getJcbName(), null);
			jpExport.add(jlScope, null);
			jpExport.add(getJcbScope(), null);			
		}
		return jpExport;
	}

	/**
	 * This method initializes jpImport	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJpImport() {
		if (jpImport == null) {
			jlImportFolder = new JLabel();
			jlImportFolder.setText(Strings.getString("MsgExportToFsFrame.importFolder"));
			jpImport = new JPanel();
			jpImport.setPreferredSize(new java.awt.Dimension(450, 60));
			jpImport
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									javax.swing.BorderFactory
											.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED),
									Strings.getString("MsgExportToFsFrame.import"),
									javax.swing.border.TitledBorder.LEFT,
									javax.swing.border.TitledBorder.TOP, null,
									null));
			jpImport.add(jlImportFolder, null);
			jpImport.add(getJcbImportFolder(), null);
		}
		return jpImport;
	}

	/**
	 * This method initializes jbImport	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJbImport() {
		if (jbImport == null) {
			jbImport = new JButton();
			jbImport.setText(Strings.getString("MsgExportToFsFrame.import"));
			jbImport.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jbImport_actionPerformed(e);
				}
			});
		}
		return jbImport;
	}

	void jbImport_actionPerformed(java.awt.event.ActionEvent e) {
		String path = jtfPath.getText().trim();
		if(path.equals("")) {
			AlertDialog.showWarningDialog(Strings.getString("MsgExportToFsFrame.pathNull"));
			return;		
		}
		if (AlertDialog.showConfirmDialog(
				Strings.getString("MsgExportToFsFrame.startImport"),
				AlertDialog.YES_NO_OPTION) == AlertDialog.NO_OPTION) {
			return;
		}
		String importFolderId = ((Folder)jcbImportFolder.getSelectedItem()).getId();
		performImport(importFolderId, path, jcbSaveFolders.isSelected(), jProgressBar1);
	}

	/**
	 * This method initializes jcbSaveFolders	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJcbSaveFolders() {
		if (jcbSaveFolders == null) {
			jcbSaveFolders = new JCheckBox();
			jcbSaveFolders.setText(Strings.getString("MsgExportToFsFrame.mapFldDir"));
			jcbSaveFolders.setPreferredSize(new java.awt.Dimension(300,24));
			jcbSaveFolders.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jcbSaveFolders.setSelected(true);
			jcbSaveFolders.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
		}
		return jcbSaveFolders;
	}
	
	public void performExport(final String path, final int nameType,
			final int scopeType, final boolean saveFolders, final JProgressBar jpb) {
		final SwingWorker worker = new SwingWorker() {

			public Object construct() {
				try {
					MessageRow mr = null;
					String folderId = null;
					switch (scopeType) {
					case MsgExportToFsFrame.SCOPE_SELECTED:
						int rows[] = parent.jTable1.getSelectedRows();
						String ids[] = new String[rows.length];
						for (int i = 0; i < rows.length; i++) {
							ids[i] = ((MessageTableModel) Context.mainFrame.jTable1
									.getModel()).getMessageRowAt(rows[i]).id;
						}
						jpb.setMaximum(ids.length);
						boolean warnHeader = true;
						boolean warnFnfe = true;
						for (int i = 0; i < ids.length; i++) {
							
							mr = Context.storage.getMessageRow(ids[i]);
							if (mr.isHeader()) {
								if(warnHeader) {
									int response = AlertDialog
											.showWarningDialog(Strings.getString(
											"MsgExportToFsFrame.skipHeader").replaceAll("\\$1", ids[i]),
											AlertDialog.YES_NO_CANCEL_OPTION);
									if(response == AlertDialog.CANCEL_OPTION)
										throw new OperationCancelledException();						
									warnHeader = (response == AlertDialog.YES_OPTION);
								}
								jpb.setValue(i + 1);
								continue;
							}
							
							MimeMessage mimeMsg = null;
							try {
								mimeMsg = Context.storage.loadMessage(ids[i]);
							} catch (FileNotFoundException fnfe) {
								if (mr.srcPlace.equals("1")) {
									if(warnFnfe) {
										int response = AlertDialog
												.showWarningDialog(Strings.getString(
												"MsgExportToFsFrame.skipFnfe").replaceAll("\\$1", ids[i]),
												AlertDialog.YES_NO_CANCEL_OPTION);
										if(response == AlertDialog.CANCEL_OPTION)
											throw new OperationCancelledException();						
										warnFnfe = (response == AlertDialog.YES_OPTION);
									}
									jpb.setValue(i + 1);
									continue;
								} else
									throw fnfe;
							}
							String filename = getMessageFileName(path, ids[i], mr.subject, nameType);
							writeMessageToFile(mimeMsg, ids[i], path, filename, saveFolders, mr.folderId);
							jpb.setValue(i + 1);
						}
						// listMessages();
						break;
					case MsgExportToFsFrame.SCOPE_FOLDER:
						folderId = parent.getCurrentFolderId();
						if (folderId == null)
							return null;
						exportFolder(folderId, true, getFolderPath(folderId, path, saveFolders), saveFolders, jpb, nameType);
						break;
					case MsgExportToFsFrame.SCOPE_ALL:
						folderId = Context.storage.getLocalFolder();
						if (folderId == null)
							return null;
						exportFolder(folderId, true, path, saveFolders, jpb, nameType);
						break;						
/*						
						msgRows = Context.storage.getMessageList(
								null, null, null, -1);
						jpb.setMaximum(msgRows.size());
						for (int i = 0; i < msgRows.size(); i++) {
							Vector msgRow = (Vector) msgRows.get(i);
							String id = (String) msgRow.get(0);
							
							mr = Context.storage.getMessage(id);
							if (Context.isHeader(mr)) {
								System.out.println("Skip header for id: " + id);
								continue;
							}							
							
							MimeMessage mimeMsg = Context.storage							
									.loadMessage(id);							
							writeMessageToFile(mimeMsg, path, id, saveFolders, mr.folderId);
							jpb.setValue(i + 1);
						}
*/												
					}					
					AlertDialog.showInfoDialog(Strings.getString("MsgExportToFsFrame.successExport"));
				} catch (OperationCancelledException exc) {
					AlertDialog.showWarningDialog(Strings.getString("MsgExportToFsFrame.exportCancelled"));					
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
				}
				return null;
			}
		};
		worker.start(); 
	}
	
	private static String getFolderPath(String folderId, String path, boolean saveFolders)
			throws Exception {
		if(!saveFolders)
			return path;
		Vector names = new Vector(3);
		Folder folder = Context.storage.getFolder(folderId);
		while (folder.getFldId() != null) {
			names.add(folder.getName());
			folder = Context.storage.getFolder(folder.getFldId());
		}
		for (int i = names.size() - 1; i >= 0; i--) {
			path += File.separator + (String) names.get(i);
			File dir = new File(path);
			if (!dir.exists()) {
				dir.mkdir();
			}
		}
		return path;
	}
	
	private static String getMessageFileName(String path, String id,
			String subject, int nameType) {		
		switch (nameType) {
		case NAME_ID:
			return id + EXT;
		case NAME_SUBJECT:
			String filename = ComUtils.nvl(subject).trim();
			filename = filename.replaceAll("[\\\\/:\\*\\?\"<>\\|]", "");
			if (filename.equals(""))
				filename = "nosubject";
			if(filename.length() > 30)
				filename = filename.substring(0, 30);
			File file = new File(path + File.separator + filename + EXT);
			int count = 0;
			while (file.exists()) {
				count++;
				if (count == 1000) {
					file = null;
					break;
				}
				String newName = filename + String.valueOf(count);
				file = new File(path + File.separator + newName + EXT);
			}
			if (file == null)
				return id + EXT;
			else
				return file.getName();
		default:
			return id + EXT;
		}
	}	
	
	private static void exportFolder(String folderId, boolean withSubfolders,
			String path, boolean saveFolders, JProgressBar jpb, int nameType)
			throws Exception {
		if (folderId == null)
			return;		
		Vector msgRows = Context.storage.getMessageList(folderId, null, null,
				-1);
		if(jpb != null)
			jpb.setMaximum(msgRows.size());
		
		boolean warnFileExists = true;
		boolean warnHeader = true;
		boolean warnFnfe = true;
		for (int i = 0; i < msgRows.size(); i++) {
			MessageRow mr = (MessageRow) msgRows.get(i);
			
			if (mr.isHeader()) {
				if(warnHeader) {
					int response = AlertDialog
							.showWarningDialog(Strings.getString(
							"MsgExportToFsFrame.skipHeader").replaceAll("\\$1", mr.id),
							AlertDialog.YES_NO_CANCEL_OPTION);
					if(response == AlertDialog.CANCEL_OPTION)
						throw new OperationCancelledException();						
					warnHeader = (response == AlertDialog.YES_OPTION);
				}
				if(jpb != null)
					jpb.setValue(i + 1);				
				continue;
			}						

			MimeMessage mimeMsg = null;
			try {
				mimeMsg = Context.storage.loadMessage(mr.id);
			} catch (FileNotFoundException fnfe) {
				if (mr.srcPlace.equals("1")) {
					if(warnFnfe) {
						int response = AlertDialog
								.showWarningDialog(Strings.getString(
								"MsgExportToFsFrame.skipFnfe").replaceAll("\\$1", mr.id),
								AlertDialog.YES_NO_CANCEL_OPTION);
						if(response == AlertDialog.CANCEL_OPTION)
							throw new OperationCancelledException();						
						warnFnfe = (response == AlertDialog.YES_OPTION);
					}
					if(jpb != null)
						jpb.setValue(i + 1);
					continue;
				} else
					throw fnfe;
			}			
			
			String filename = getMessageFileName(path, mr.id, mr.subject, nameType); 
			
			File file = new File(path + File.separator + filename);
			if (file.exists()) {
				if(warnFileExists) {
					int response = AlertDialog				
							.showWarningDialog(Strings.getString("MsgExportToFsFrame.fileExists").
							replaceAll("\\$1", filename).replaceAll("\\$2", mr.id), AlertDialog.YES_NO_CANCEL_OPTION);
					if(response == AlertDialog.CANCEL_OPTION)
						throw new OperationCancelledException();						
					warnFileExists = (response == AlertDialog.YES_OPTION);
				}
			} else {
				OutputStream os = Context.getFileOutputStream(file);
				mimeMsg.writeTo(os);
				Context.closeOutputStream(os);
			}
			if(jpb != null)
				jpb.setValue(i + 1);
		}
		Folder folders[] = Context.storage.getFoldersChildren(folderId);
		for(int i = 0; i < folders.length; i++) {
			String folderPath = path;
			if (saveFolders) {
				folderPath += File.separator + folders[i].getName();
				File dir = new File(folderPath);
				if (!dir.exists()) {
					dir.mkdir();
				}
			}			
			exportFolder(folders[i].getId(), withSubfolders, folderPath, saveFolders, jpb, nameType);
		}
	}
	
	private static void writeMessageToFile(MimeMessage mimeMsg, String msgId, String path,
			String filename, boolean saveFolders, String folderId)
			throws Exception {
		if (saveFolders && folderId != null) {
			path = getFolderPath(folderId, path, saveFolders);
		}
		File file = new File(path + File.separator + filename);
		if (file.exists()) {
			if(AlertDialog				
					.showWarningDialog(Strings.getString("MsgExportToFsFrame.fileExists").
					replaceAll("\\$1", filename).replaceAll("\\$2", msgId), AlertDialog.OK_CANCEL_OPTION) == AlertDialog.CANCEL_OPTION)
				throw new OperationCancelledException();									
		} else {
			OutputStream os = Context.getFileOutputStream(file);
			mimeMsg.writeTo(os);
			Context.closeOutputStream(os);
		}
	}

	public void performImport(final String importFolderId, final String path, final boolean saveFolders,
			final JProgressBar jpb) {
		final SwingWorker worker = new SwingWorker() {

			public Object construct() {
				try {
					File dir = new File(path);
					if (!dir.exists() || !dir.isDirectory()) {
						AlertDialog
								.showErrorDialog("MsgExportToFsFrame.dirNotExists");
						return null;
					}
					importFromDir(dir, true, importFolderId,
							saveFolders, jpb);
					AlertDialog.showInfoDialog(Strings
							.getString("MsgExportToFsFrame.successImport"));
					parent.updateTree();
					Context.loadFolders();
				} catch (Exception exc) {
					exc.printStackTrace();
					AlertDialog.showErrorDialog(exc);
				}
				return null;
			}
		};
		worker.start();
	}	



	private void importFromDir(File dir, boolean baseDir, String folderId,
			final boolean saveFolders, final JProgressBar jpb) throws Exception {
		String subFolderId = null;
		if (baseDir)
			subFolderId = folderId;
		else {
			subFolderId = Context.storage.getFolderId(folderId, dir
					.getName());
			if (subFolderId == null) {
				Folder subFolder = new Folder(null, dir.getName(), folderId);
				subFolder = Context.storage.saveFolder(subFolder);
				subFolderId = subFolder.getId();
			}
		}		
		File[] files = dir.listFiles(new FilenameFilter() {
			public boolean accept(File dir, String name) {
				return name.matches(".*\\.[Ee][Mm][Ll]");
			}
		});
		if (files != null && files.length > 0) {			
			jpb.setMaximum(files.length);
			for (int i = 0; i < files.length; i++) {
				FileInputStream fis = new FileInputStream(files[i]);
				Session session = Session.getDefaultInstance(System
						.getProperties());
				MimeMessage mimeMsg = new MimeMessage(session, fis);
				fis.close();
				MessageHeader hdr = Context.mailBean.getMessageHeader(mimeMsg,
						null);
				hdr.UID = Context.mailBean.getOlivaMsgUID(mimeMsg);
				parent.addRowToTableIfNeeded(
						Context.storage.saveMessage(hdr, subFolderId, mimeMsg, "".hashCode(), null, null, null),
						subFolderId);
				jpb.setValue(i + 1);
			}
		}
		if (!saveFolders)
			return;
		File[] dirs = dir.listFiles(new FileFilter() {
			public boolean accept(File pathname) {
				return pathname.isDirectory();
			}
		});
		if (dirs == null || dirs.length == 0) {
			return;
		}
		for (int i = 0; i < dirs.length; i++) {
			importFromDir(dirs[i], false, subFolderId, saveFolders, jpb);
		}
	}

	/**
	 * This method initializes jcbImportFolder	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJcbImportFolder() {
		if (jcbImportFolder == null) {
			Object folders[] = null;
			try {
				 folders = Context.storage.getAllFolderList().toArray();
			} catch(Exception exc) {
				exc.printStackTrace();
				AlertDialog.showErrorDialog(exc);
			}
			jcbImportFolder = new JComboBox(folders);
			jcbImportFolder.setPreferredSize(new java.awt.Dimension(200,20));
		}
		return jcbImportFolder;
	}
		
}  //  @jve:decl-index=0:visual-constraint="10,10"
