package olivamail.gui;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class MsgsHeaderRenderer extends JLabel implements TableCellRenderer {
	static final long serialVersionUID = 4451833789L;

	public MsgsHeaderRenderer() {
		super();
	}

	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		// column = MessageTableModel.shownColumns[column];
		column = MessageTableModel
				.checkColumn(MessageTableModel.shownColumns[column]);
		switch (column) {
		case MessageTableModel.COL_IMPORTANCE:
			this.setIcon(Context.getImageIcon("imptnt.gif"));
			break;
		case MessageTableModel.COL_HAS_ATT:
			this.setIcon(Context.getImageIcon("att.gif"));
			break;
		case MessageTableModel.COL_HDR:
			this.setIcon(Context.getImageIcon("glasses.gif"));
			break;
		case MessageTableModel.COL_SF_SEEN:
			this.setIcon(Context.getImageIcon("seen.gif"));
			break;
		case MessageTableModel.COL_SF_FLAGGED:
			this.setIcon(Context.getImageIcon("flagged.gif"));
			break;
		default:
			this.setText(value.toString());
			if (Context.mainFrame != null) {
				if (column == Context.mainFrame.getOrderByColumn()) {
					if (Context.mainFrame.getOrderByDirection() == 0)
						this.setIcon(Context.getImageIcon("desc.gif"));
					else
						this.setIcon(Context.getImageIcon("asc.gif"));
				} else
					this.setIcon(null);
			}
			break;
		}
		return this;
	}

}
