/*
 * @(#)MtypeFormFrame.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.FlowLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.io.File;

public class MtypeFormFrame extends JFrame {

	static final long serialVersionUID = 8714997150822245294L;
	private final String WIN_ID = "mime_type";
	private JPanel jContentPane = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JTextField idField = null;
	private JTextField mimeTypeField = null;
	private JTextField programField = null;
	private JTextField mgrpIdField = null;
	private JButton okButton = null;
	private JButton cancelButton = null;
	private MimesFrame parent = null;
	private JButton jButtonFind = null;
	private JButton jButtonTest = null;
	private JButton jButtonSelect = null;	

	/**
	 * This is the default constructor
	 */
	public MtypeFormFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	public void setMimeGroupId(String mgrpId) {
		if(mgrpId == null)
			return;
		mgrpIdField.setText(mgrpId);
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(444, 199);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("MtypeFormFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
		
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel4 = new JLabel();
			jLabel4.setText(Strings.getString("MtypeFormFrame.mgrpIdField")); //$NON-NLS-1$
			jLabel4.setPreferredSize(new java.awt.Dimension(70,16));
			jLabel3 = new JLabel();
			jLabel3.setText(Strings.getString("MtypeFormFrame.programField")); //$NON-NLS-1$
			jLabel3.setPreferredSize(new java.awt.Dimension(70,16));
			jLabel2 = new JLabel();
			jLabel2.setText(Strings.getString("MtypeFormFrame.mimeTypeField")); //$NON-NLS-1$
			jLabel2.setPreferredSize(new java.awt.Dimension(70,16));
			jLabel1 = new JLabel();
			jLabel1.setText(Strings.getString("MtypeFormFrame.idField")); //$NON-NLS-1$
			jLabel1.setPreferredSize(new java.awt.Dimension(70,16));
			jContentPane = new JPanel();
			jContentPane.setLayout(new FlowLayout());
			jContentPane.add(jLabel1, null);
			jContentPane.add(getIdField(), null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(getMimeTypeField(), null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getProgramField(), null);
			jContentPane.add(getJButton1(), null);
			jContentPane.add(getJButtonFind(), null);
			jContentPane.add(getJButtonTest(), null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(getMgrpIdField(), null);
			jContentPane.add(getOkButton(), null);
			jContentPane.add(getCancelButton(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes idField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getIdField() {
		if (idField == null) {
			idField = new JTextField();
			idField.setPreferredSize(new java.awt.Dimension(350,20));
			idField.setEnabled(false);
			TextPopup.registerComponent(idField);
		}
		return idField;
	}

	/**
	 * This method initializes mimeTypeField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getMimeTypeField() {
		if (mimeTypeField == null) {
			mimeTypeField = new JTextField();
			mimeTypeField.setPreferredSize(new java.awt.Dimension(350,20));
			TextPopup.registerComponent(mimeTypeField);
		}
		return mimeTypeField;
	}

	public void setMimeTypeField(String mimeType) {
		this.mimeTypeField.setText(mimeType);
	}
	
	/**
	 * This method initializes programField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getProgramField() {
		if (programField == null) {
			programField = new JTextField();
			programField.setPreferredSize(new java.awt.Dimension(350,20));
			TextPopup.registerComponent(programField);
		}
		return programField;
	}

	/**
	 * This method initializes mgrpIdField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getMgrpIdField() {
		if (mgrpIdField == null) {
			mgrpIdField = new JTextField();
			mgrpIdField.setPreferredSize(new java.awt.Dimension(350,20));
			mgrpIdField.setEnabled(false);
			TextPopup.registerComponent(mgrpIdField);
		}
		return mgrpIdField;
	}

	/**
	 * This method initializes okButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setText(Strings.getString("okButton")); //$NON-NLS-1$
			okButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					okButton_actionPerformed(e);
				}
			});
		}
		return okButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Strings.getString("cancelButton")); //$NON-NLS-1$
			cancelButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return cancelButton;
	}

	public void editMimeType(String id) {
		try {
			olivamail.gui.MimeType mgrp = Context.storage.getMimeType(id);
			idField.setText(mgrp.id);
			mimeTypeField.setText(mgrp.mimeType);
			programField.setText(mgrp.program);
			mgrpIdField.setText(mgrp.mgrpId);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	public void setParent(MimesFrame parent) {
		this.parent = parent;
	}

	void okButton_actionPerformed(ActionEvent e) {
		olivamail.gui.MimeType mtype = new olivamail.gui.MimeType(); 
		mtype.id = idField.getText();
		mtype.mimeType = mimeTypeField.getText();		
		mtype.program = programField.getText();
		mtype.mgrpId = mgrpIdField.getText();
		try {
			Context.storage.saveMimeType(mtype);
			parent.listTypes();
			this_windowClosing(null);
			dispose();
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
	}

	/**
	 * This method initializes jButtonFind	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButtonFind() {
		if (jButtonFind == null) {
			jButtonFind = new JButton();
			jButtonFind.setText(Strings.getString("MtypeFormFrame.findButton")); //$NON-NLS-1$
			jButtonFind.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jButtonFind_actionPerformed(e);
				}
			});
			jButtonFind.setPreferredSize(new java.awt.Dimension(138,26));
		}
		return jButtonFind;
	}

	/**
	 * This method initializes jButtonTest	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButtonTest() {
		if (jButtonTest == null) {
			jButtonTest = new JButton();
			jButtonTest.setText(Strings.getString("MtypeFormFrame.testButton")); //$NON-NLS-1$
			jButtonTest.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jButtonTest_actionPerformed(e);
				}
			});
			jButtonTest.setPreferredSize(new java.awt.Dimension(138,26));
		}
		return jButtonTest;
	}

	void jButtonFind_actionPerformed(ActionEvent e) {
		File file = Context.fileOpenDialog(this);
		if (file == null)
			return;
		programField.setText(file.getPath() + " %1"); //$NON-NLS-1$
	}

	void jButtonTest_actionPerformed(ActionEvent e) {
		if(programField.getText().length() == 0)
			return;
		File file = Context.fileOpenDialog(this);
		if (file == null)
			return;
		Ocm ocm = new Ocm();
		String program = programField.getText();			
		try {
			//ocm.run(program + " " + file.getPath(), System.out);
			ocm.run(program.replaceAll("%1", file.getPath().replaceAll("\\\\", "\\\\\\\\")), System.out, false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButtonSelect == null) {
			jButtonSelect = new JButton();
			jButtonSelect.setText(Strings.getString("MtypeFormFrame.mimeTypeBtn")); //$NON-NLS-1$
			jButtonSelect.setPreferredSize(new java.awt.Dimension(138,26));
			jButtonSelect.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jButtonSelect_actionPerformed(e);
				}
			});
		}
		return jButtonSelect;
	}

	void jButtonSelect_actionPerformed(java.awt.event.ActionEvent e) {
		MimeSelectionForm msf = new MimeSelectionForm();
		msf.setParent(this);
		msf.setVisible(true);
		msf.listMimeTypes();		
	}
	
}  //  @jve:decl-index=0:visual-constraint="10,10"
