/*
 * @(#)Ocm.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.io.*;

class StreamGobbler extends Thread {
  InputStream is = null;
  String type;
  OutputStream os = null;

  StreamGobbler(InputStream is, String type) {
    this(is, type, null);
  }

  StreamGobbler(InputStream is, String type, OutputStream redirect) {
    this.is = is;
    this.type = type;
    this.os = redirect;
  }

  public void run() {
    try {
      InputStreamReader isr = new InputStreamReader(is);
      BufferedReader br = new BufferedReader(isr);
      String line = null;
      while ( (line = br.readLine()) != null) {
        if (os != null)
        	os.write(line.getBytes());
          //os.println(line);
      }
      if (os != null)
        os.flush();
    } catch (java.io.IOException ioe) {
    }
  }
}

public class Ocm {
  public synchronized void run(String args, OutputStream os, boolean wait)
			throws Exception {
		Runtime rt = Runtime.getRuntime();
		Process proc = rt.exec(args);

		StreamGobbler outputGobbler = new StreamGobbler(proc.getInputStream(),
				"OUT", null);
		StreamGobbler errorGobbler = new StreamGobbler(proc.getErrorStream(),
				"ERR", null);

		outputGobbler.start();
		errorGobbler.start();

		if (wait) {
			while (outputGobbler.isAlive() || errorGobbler.isAlive()) {
				this.wait(1);
			}
		}

		//int exitVal = proc.waitFor();
		//os.println("<br/>");
		//os.println("OCM ExitValue: " + exitVal);
	}
}
