/*
 * @(#)ReceivingResult.java
 *
 * Copyright (C) 2007 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

/**
 *
 * @author bredikhin
 */
public class ReceivingResult {
    
    /** Creates a new instance of ReceivingResult */
    public ReceivingResult() {
    }

    public int received = 0;
    
    public int skipped = 0;
    
    public int deleted = 0;
    
    public void incrementReceived() {
        received++;
    }
    
    public void incrementSkipped() {
        skipped++;
    }    
    
    public void incrementDeleted() {
        deleted++;
    }    
    
    public int getReceived() {
        return received;
    }
    
    public int getSkipped() {
        return skipped;
    }
    
    public int getDeleted() {
        return deleted;
    }

    public int getNew() {
        return received + skipped;
    }    

    public void append(ReceivingResult result) {
    	if(result == null)
    		return;
        received += result.received;
        skipped += result.skipped;
        deleted += result.deleted;
    }

    public void reset() {
        received = 0;
        skipped = 0;
        deleted = 0;
    }
    
}
