/*
 * @(#)RulesFrame.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.util.Enumeration;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;

public class RulesFrame extends JFrame implements ParentList {

	static final long serialVersionUID = 2L;	
	private final String WIN_ID = "rules";
	private JPanel jContentPane = null;
	private JPanel jPanelNorth = null;
	private JPanel jPanelSouth = null;
	private JPanel jPanelEast = null;
	private JPanel jPanelWest = null;
	private JLabel jLabelAccount = null;
	private JComboBox jComboBoxAcnt = null;
	private JScrollPane jScrollPane1 = null;
	private JTable jTable1 = null;
	private JMenu jMenuFile = null;
	private JMenuItem jMenuItemClose = null;
	private JMenuBar jJMenuBar1 = null;
	private JMenu jMenuRules = null;
	private JMenuItem jmiRuleAdd = null;
	private JMenuItem jmiRuleEdit = null;
	private JMenuItem jmiRuleDelete = null;
	/**
	 * This is the default constructor
	 */
	public RulesFrame() {
		super();
		initialize();
		setLocation(Context.getWindowPosition(WIN_ID));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(575, 378);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				this_windowClosing(e);
			}
		});
		this.setJMenuBar(getJJMenuBar1());
		this.setContentPane(getJContentPane());
		this.setTitle(Strings.getString("RulesFrame.title")); //$NON-NLS-1$
	}

	void this_windowClosing(java.awt.event.WindowEvent e) {
		Context.setWindowPosition(WIN_ID, getLocation());
	}
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanelNorth(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanelSouth(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanelEast(), java.awt.BorderLayout.EAST);
			jContentPane.add(getJPanelWest(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanelNorth() {
		if (jPanelNorth == null) {
			jLabelAccount = new JLabel();
			jLabelAccount.setText(Strings.getString("accountComboBox"));
			jPanelNorth = new JPanel();
			jPanelNorth.setPreferredSize(new java.awt.Dimension(10,30));
			jPanelNorth.add(jLabelAccount, null);
			jPanelNorth.add(getJComboBoxAcnt(), null);
		}
		return jPanelNorth;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanelSouth() {
		if (jPanelSouth == null) {
			jPanelSouth = new JPanel();
		}
		return jPanelSouth;
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanelEast() {
		if (jPanelEast == null) {
			jPanelEast = new JPanel();
		}
		return jPanelEast;
	}

	/**
	 * This method initializes jPanel5	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanelWest() {
		if (jPanelWest == null) {
			jPanelWest = new JPanel();
		}
		return jPanelWest;
	}

	/**
	 * This method initializes jComboBoxAcnt	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBoxAcnt() {
/*		
		if (jComboBoxAcnt == null) {
			jComboBoxAcnt = new JComboBox();
			jComboBoxAcnt.setPreferredSize(new java.awt.Dimension(250,20));
		}
		return jComboBoxAcnt;
*/	
		if (jComboBoxAcnt == null) {
			Object senderAddresses[] = null;
			try {
				senderAddresses = Context.storage.getAccounts(null).toArray();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
			Account defAcnt = null;
			try {
				defAcnt = Context.storage.getDefaultAccount();
			} catch (Exception exc) {
				exc.printStackTrace();
			}
			if (senderAddresses == null)
				jComboBoxAcnt = new JComboBox();
			else
				jComboBoxAcnt = new JComboBox(senderAddresses);
			if (defAcnt != null)
				jComboBoxAcnt.setSelectedItem(defAcnt);
			jComboBoxAcnt.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					jComboBoxAcnt_itemStateChanged(e);
				}
			});
			jComboBoxAcnt.setPreferredSize(new java.awt.Dimension(300, 20));
		}
		return jComboBoxAcnt;
	}

	void jComboBoxAcnt_itemStateChanged(java.awt.event.ItemEvent e) {
		listRules();
	}	
	
	public void listRules() {
		//String acntEmail = (String) jComboBoxAcnt.getSelectedItem();
		Account acnt = (Account) jComboBoxAcnt.getSelectedItem();
		if(acnt == null)
			return;
		try {			
			//String acntId = Context.storage.getAccountForEmail(acntEmail).id;
			Vector rules = Context.storage.getRulesList(acnt.id);
			Vector rows = null;			
			if (rules != null) {
				rows = new Vector(rules.size());
				for (Enumeration en = rules.elements(); en.hasMoreElements();) {
					Rule rule = (Rule) en.nextElement();
					Vector row = new Vector(2);
					row.add(rule.id);
					row.add(Rule.getRuleText(rule));
					rows.add(row);
				}
			}
			Vector headers = new Vector(2);
			headers.add(Strings.getString("RulesFrame.idField")); //$NON-NLS-1$
			headers.add(Strings.getString("RulesFrame.nameField")); //$NON-NLS-1$
			DefaultTableModel dtm = new DefaultTableModel();
			dtm.setDataVector(rows, headers);
			jTable1.setModel(dtm);
			TableColumnModel tcm = jTable1.getColumnModel();
			tcm.getColumn(0).setMaxWidth(40);
			tcm.getColumn(1).setMinWidth(200);			
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}		
	}
	
	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable1());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jTable1	
	 * 	
	 * @return javax.swing.JTable	
	 */    
	private JTable getJTable1() {
		if (jTable1 == null) {
			jTable1 = new JTable() {
				static final long serialVersionUID = 1507730867321229517L;

				public boolean isCellEditable(int rowIndex, int vColIndex) {
					return false;
				}																
				
				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {
					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					if (isCellSelected(rowIndex, vColIndex)) {
						c.setBackground(Color.blue);
						c.setForeground(Color.white);
					} else {
						c.setBackground(Color.white);
						c.setForeground(Color.black);
					}				
					return c;
				}
			};
			//jTable1.setFont(new java.awt.Font("Dialog", 0, 14)); //$NON-NLS-1$
			jTable1.addMouseListener(new java.awt.event.MouseAdapter() { 
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if (e.getClickCount() == 2) {
						editCurrentRow();
					}
				}
			});
			
			jTable1.setGridColor(jTable1.getBackground());
		}
		return jTable1;
	}

	/**
	 * This method initializes jMenuFile	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
			jMenuFile.setText(Strings.getString("menuFile")); //$NON-NLS-1$
			jMenuFile.add(getJMenuItemClose());
		}
		return jMenuFile;
	}

	/**
	 * This method initializes jMenuItemClose	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItemClose() {
		if (jMenuItemClose == null) {
			jMenuItemClose = new JMenuItem();
			jMenuItemClose.setText(Strings.getString("menuClose")); //$NON-NLS-1$
			jMenuItemClose.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					this_windowClosing(null);
					dispose();
				}
			});
		}
		return jMenuItemClose;
	}

	/**
	 * This method initializes jJMenuBar1	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private JMenuBar getJJMenuBar1() {
		if (jJMenuBar1 == null) {
			jJMenuBar1 = new JMenuBar();
			jJMenuBar1.add(getJMenuFile());
			jJMenuBar1.add(getJMenuRules());
		}
		return jJMenuBar1;
	}

	/**
	 * This method initializes jMenuRules	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuRules() {
		if (jMenuRules == null) {
			jMenuRules = new JMenu();
			jMenuRules.setText(Strings.getString("RulesFrame.rulesMenu")); //$NON-NLS-1$
			jMenuRules.add(getJmiRuleAdd());
			jMenuRules.add(getJmiRuleEdit());
			jMenuRules.add(getJmiRuleDelete());
		}
		return jMenuRules;
	}

	/**
	 * This method initializes jmiRuleAdd	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiRuleAdd() {
		if (jmiRuleAdd == null) {
			jmiRuleAdd = new JMenuItem();
			jmiRuleAdd.setText(Strings.getString("createMenuItem")); //$NON-NLS-1$
			jmiRuleAdd.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiRuleAdd_actionPerformed(e);
				}
			});
		}
		return jmiRuleAdd;
	}

	void jmiRuleAdd_actionPerformed(java.awt.event.ActionEvent e) {
		RuleFormFrame rff = new RuleFormFrame();
		rff.setVisible(true);
		rff.setParent(this);		
		//String acntEmail = (String) jComboBoxAcnt.getSelectedItem();
		Account acnt = (Account) jComboBoxAcnt.getSelectedItem();
		if(acnt != null)
			rff.setAcntId(acnt.id);
/*		
		try {			
			String acntId = Context.storage.getAccountForEmail(acntEmail).id;		
			rff.setAcntId(acnt.id);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}
*/						
	}

	/**
	 * This method initializes jmiRuleEdit	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiRuleEdit() {
		if (jmiRuleEdit == null) {
			jmiRuleEdit = new JMenuItem();
			jmiRuleEdit.setText(Strings.getString("editMenuItem")); //$NON-NLS-1$
			jmiRuleEdit.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiRuleEdit_actionPerformed(e);
				}
			});
		}
		return jmiRuleEdit;
	}

	void editCurrentRow() {
		int row = jTable1.getSelectedRow();
		if (row == -1)
			return;
		RuleFormFrame rff = new RuleFormFrame();
		rff.setVisible(true);
		rff.setParent(this);
		rff.editRule(jTable1, row, (String) jTable1.getValueAt(row, 0));
	}
	
	
	void jmiRuleEdit_actionPerformed(java.awt.event.ActionEvent e) {
		editCurrentRow();		
	}

	public void updateRow(JTable jTable, int row, Object obj) {
		if (obj == null)
			return;
		if (jTable == null)
			jTable = jTable1;
		if (row == -1) {
			if(jTable.getRowCount() == 0) {
				listRules();
				return;
			}
			Rule rule = (Rule) obj;
			DefaultTableModel dtm = (DefaultTableModel) jTable.getModel();
			String[] rowArray = { rule.id, rule.getRuleText() };
			dtm.addRow(rowArray);
			return;
		}
		if (jTable.getRowCount() <= row)
			return;
		String id = (String) jTable.getValueAt(row, 0);
		Rule rule = (Rule) obj;
		if (!rule.id.equals(id))
			return;
		jTable.setValueAt(rule.getRuleText(), row, 1);
	}

	/**
	 * This method initializes jmiRuleDelete	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiRuleDelete() {
		if (jmiRuleDelete == null) {
			jmiRuleDelete = new JMenuItem();
			jmiRuleDelete.setText(Strings.getString("deleteMenuItem")); //$NON-NLS-1$
			jmiRuleDelete.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					jmiRuleDelete_actionPerformed(e);
				}
			});
		}
		return jmiRuleDelete;
	}
		
	void jmiRuleDelete_actionPerformed(java.awt.event.ActionEvent e) {
		int row = jTable1.getSelectedRow();
		if (row == -1)
			return;
		try {
			Context.storage.deleteRule((String)jTable1.getValueAt(row, 0));
			((DefaultTableModel) jTable1.getModel()).removeRow(row);
		} catch (Exception exc) {
			exc.printStackTrace();
			AlertDialog.showErrorDialog(exc);
		}						
	}
	
}  // @jve:decl-index=0:visual-constraint="10,10"
