/*
 * @(#)SearchFolder.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import javax.swing.JProgressBar;

public class SearchFolder {

	private int type = 0;
	
	private String title = null;	
	
	public String commonSearchCondition = null;
	
	public String contentSearchText = null;
	
	public JProgressBar progressBar = null;
	
	public static final int SEARCH_NONE = 0;	
	
	public static final int SEARCH_BASIC = 1;
	
	public static final int SEARCH_BIG_SIZE = 2;	
	
	public SearchFolder(int type, String title) {
		this.type = type;
		this.title = title;
	}

	public String toString() {
		return title;
	}
	
	public String getSearchCondition() {
		String searchCondition = null;
		switch(type) {
		case SEARCH_NONE:
			return null;
		case SEARCH_BASIC:
			return commonSearchCondition;
		case SEARCH_BIG_SIZE:
			return "MSG_SIZE > 5242880";			
		}
		return searchCondition;
	}

	public int getType() {
		return type;
	}

	public String getTitle() {
		return title;
	}
	
}
