/*
 * @(#)Strings.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Locale;

public class Strings {
	private static final String BUNDLE_NAME = "strings";

	private static String lang = "";
	
	private static ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	public static String getString(String key) {
		String result = '!' + key + '!';
		try {
			key = RESOURCE_BUNDLE.getString(key);
			if(key != null) 
				result = olivamail.core.common.ComUtils.getStringInternals(key, "UTF-8");
		} catch (MissingResourceException e) {
		} catch (Exception e) {
		}
		return result;
	}

	public static String getLanguage() {
		return Strings.lang;
	}
	
	public static void setLanguage(String lang) { 
		Strings.lang = lang;		
		Locale locale = new Locale(lang, "");
		RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME, locale);
	}

}
